/*
 * Controller.cpp
 *
 * Code generation for model "Controller".
 *
 * Model version              : 1.1303
 * Simulink Coder version : 8.3 (R2012b) 20-Jul-2012
 * C++ source code generated on : Sun Jun 01 14:58:10 2014
 *
 * Target selection: grt.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: Generic->32-bit x86 compatible
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */
#include "Controller.h"
#include "Controller_private.h"

/* Block signals (auto storage) */
BlockIO_Controller Controller_B;

/* Continuous states */
ContinuousStates_Controller Controller_X;

/* Block states (auto storage) */
D_Work_Controller Controller_DWork;

/* Previous zero-crossings (trigger) states */
PrevZCSigStates_Controller Controller_PrevZCSigState;

/* External inputs (root inport signals with auto storage) */
ExternalInputs_Controller Controller_U;

/* External outputs (root outports fed by signals with auto storage) */
ExternalOutputs_Controller Controller_Y;

/* Real-time model */
RT_MODEL_Controller Controller_M_;
RT_MODEL_Controller *const Controller_M = &Controller_M_;

/* Forward declaration for local functions */
static real_T Controller_sum(const real_T x[6]);
static void Controller_diag(const real_T v[12], real_T d[144]);
static void Controller_invNxN(const real_T x[144], real_T y[144]);
static void Controller_inv(const real_T x[144], real_T y[144]);
static real_T Controller_inv_i(real_T x);
static void Controller_eye(real_T I[144]);

/* Forward declaration for local functions */
static void Controller_conv(const real_T A[2], const real_T B[3], real_T C[4]);

/*
 * Time delay interpolation routine
 *
 * The linear interpolation is performed using the formula:
 *
 *          (t2 - tMinusDelay)         (tMinusDelay - t1)
 * u(t)  =  ----------------- * u1  +  ------------------- * u2
 *              (t2 - t1)                  (t2 - t1)
 */
real_T rt_TDelayInterpolate(
  real_T tMinusDelay,                  /* tMinusDelay = currentSimTime - delay */
  real_T tStart,
  real_T *tBuf,
  real_T *uBuf,
  int_T bufSz,
  int_T *lastIdx,
  int_T oldestIdx,
  int_T newIdx,
  real_T initOutput,
  boolean_T discrete,
  boolean_T minorStepAndTAtLastMajorOutput)
{
  int_T i;
  real_T yout, t1, t2, u1, u2;

  /*
   * If there is only one data point in the buffer, this data point must be
   * the t= 0 and tMinusDelay > t0, it ask for something unknown. The best
   * guess if initial output as well
   */
  if ((newIdx == 0) && (oldestIdx ==0 ) && (tMinusDelay > tStart))
    return initOutput;

  /*
   * If tMinusDelay is less than zero, should output initial value
   */
  if (tMinusDelay <= tStart)
    return initOutput;

  /* For fixed buffer extrapolation:
   * if tMinusDelay is small than the time at oldestIdx, if discrete, output
   * tailptr value,  else use tailptr and tailptr+1 value to extrapolate
   * It is also for fixed buffer. Note: The same condition can happen for transport delay block where
   * use tStart and and t[tail] other than using t[tail] and t[tail+1].
   * See below
   */
  if ((tMinusDelay <= tBuf[oldestIdx] ) ) {
    if (discrete) {
      return(uBuf[oldestIdx]);
    } else {
      int_T tempIdx= oldestIdx + 1;
      if (oldestIdx == bufSz-1)
        tempIdx = 0;
      t1= tBuf[oldestIdx];
      t2= tBuf[tempIdx];
      u1= uBuf[oldestIdx];
      u2= uBuf[tempIdx];
      if (t2 == t1) {
        if (tMinusDelay >= t2) {
          yout = u2;
        } else {
          yout = u1;
        }
      } else {
        real_T f1 = (t2-tMinusDelay) / (t2-t1);
        real_T f2 = 1.0 - f1;

        /*
         * Use Lagrange's interpolation formula.  Exact outputs at t1, t2.
         */
        yout = f1*u1 + f2*u2;
      }

      return yout;
    }
  }

  /*
   * When block does not have direct feedthrough, we use the table of
   * values to extrapolate off the end of the table for delays that are less
   * than 0 (less then step size).  This is not completely accurate.  The
   * chain of events is as follows for a given time t.  Major output - look
   * in table.  Update - add entry to table.  Now, if we call the output at
   * time t again, there is a new entry in the table. For very small delays,
   * this means that we will have a different answer from the previous call
   * to the output fcn at the same time t.  The following code prevents this
   * from happening.
   */
  if (minorStepAndTAtLastMajorOutput) {
    /* pretend that the new entry has not been added to table */
    if (newIdx != 0) {
      if (*lastIdx == newIdx) {
        (*lastIdx)--;
      }

      newIdx--;
    } else {
      if (*lastIdx == newIdx) {
        *lastIdx = bufSz-1;
      }

      newIdx = bufSz - 1;
    }
  }

  i = *lastIdx;
  if (tBuf[i] < tMinusDelay) {
    /* Look forward starting at last index */
    while (tBuf[i] < tMinusDelay) {
      /* May occur if the delay is less than step-size - extrapolate */
      if (i == newIdx)
        break;
      i = ( i < (bufSz-1) ) ? (i+1) : 0;/* move through buffer */
    }
  } else {
    /*
     * Look backwards starting at last index which can happen when the
     * delay time increases.
     */
    while (tBuf[i] >= tMinusDelay) {
      /*
       * Due to the entry condition at top of function, we
       * should never hit the end.
       */
      i = (i > 0) ? i-1 : (bufSz-1);   /* move through buffer */
    }

    i = ( i < (bufSz-1) ) ? (i+1) : 0;
  }

  *lastIdx = i;
  if (discrete) {
    /*
     * tempEps = 128 * eps;
     * localEps = max(tempEps, tempEps*fabs(tBuf[i]))/2;
     */
    double tempEps = (DBL_EPSILON) * 128.0;
    double localEps = tempEps * fabs(tBuf[i]);
    if (tempEps > localEps) {
      localEps = tempEps;
    }

    localEps = localEps / 2.0;
    if (tMinusDelay >= (tBuf[i] - localEps)) {
      yout = uBuf[i];
    } else {
      if (i == 0) {
        yout = uBuf[bufSz-1];
      } else {
        yout = uBuf[i-1];
      }
    }
  } else {
    if (i == 0) {
      t1 = tBuf[bufSz-1];
      u1 = uBuf[bufSz-1];
    } else {
      t1 = tBuf[i-1];
      u1 = uBuf[i-1];
    }

    t2 = tBuf[i];
    u2 = uBuf[i];
    if (t2 == t1) {
      if (tMinusDelay >= t2) {
        yout = u2;
      } else {
        yout = u1;
      }
    } else {
      real_T f1 = (t2-tMinusDelay) / (t2-t1);
      real_T f2 = 1.0 - f1;

      /*
       * Use Lagrange's interpolation formula.  Exact outputs at t1, t2.
       */
      yout = f1*u1 + f2*u2;
    }
  }

  return(yout);
}

/*
 * This function updates continuous states using the ODE4 fixed-step
 * solver algorithm
 */
static void rt_ertODEUpdateContinuousStates(RTWSolverInfo *si )
{
  time_T t = rtsiGetT(si);
  time_T tnew = rtsiGetSolverStopTime(si);
  time_T h = rtsiGetStepSize(si);
  real_T *x = rtsiGetContStates(si);
  ODE4_IntgData *id = (ODE4_IntgData *)rtsiGetSolverData(si);
  real_T *y = id->y;
  real_T *f0 = id->f[0];
  real_T *f1 = id->f[1];
  real_T *f2 = id->f[2];
  real_T *f3 = id->f[3];
  real_T temp;
  int_T i;
  int_T nXc = 198;
  rtsiSetSimTimeStep(si,MINOR_TIME_STEP);

  /* Save the state values at time t in y, we'll use x as ynew. */
  (void) memcpy(y, x,
                (uint_T)nXc*sizeof(real_T));

  /* Assumes that rtsiSetT and ModelOutputs are up-to-date */
  /* f0 = f(t,y) */
  rtsiSetdX(si, f0);
  Controller_derivatives();

  /* f1 = f(t + (h/2), y + (h/2)*f0) */
  temp = 0.5 * h;
  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + (temp*f0[i]);
  }

  rtsiSetT(si, t + temp);
  rtsiSetdX(si, f1);
  Controller_step();
  Controller_derivatives();

  /* f2 = f(t + (h/2), y + (h/2)*f1) */
  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + (temp*f1[i]);
  }

  rtsiSetdX(si, f2);
  Controller_step();
  Controller_derivatives();

  /* f3 = f(t + h, y + h*f2) */
  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + (h*f2[i]);
  }

  rtsiSetT(si, tnew);
  rtsiSetdX(si, f3);
  Controller_step();
  Controller_derivatives();

  /* tnew = t + h
     ynew = y + (h/6)*(f0 + 2*f1 + 2*f2 + 2*f3) */
  temp = h / 6.0;
  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + temp*(f0[i] + 2.0*f1[i] + 2.0*f2[i] + f3[i]);
  }

  rtsiSetSimTimeStep(si,MAJOR_TIME_STEP);
}

/* Function for MATLAB Function: '<S14>/MATLAB Function' */
static real_T Controller_sum(const real_T x[6])
{
  real_T y;
  int32_T k;
  y = x[0];
  for (k = 0; k < 5; k++) {
    y += x[k + 1];
  }

  return y;
}

/* Function for MATLAB Function: '<S14>/MATLAB Function' */
static void Controller_diag(const real_T v[12], real_T d[144])
{
  int32_T j;
  memset(&d[0], 0, 144U * sizeof(real_T));
  for (j = 0; j < 12; j++) {
    d[j + 12 * j] = v[j];
  }
}

/* Function for MATLAB Function: '<S14>/MATLAB Function' */
static void Controller_invNxN(const real_T x[144], real_T y[144])
{
  int8_T p[12];
  real_T A[144];
  int8_T ipiv[12];
  int32_T b_j;
  int32_T c;
  int32_T ix;
  real_T smax;
  real_T s;
  int32_T b_ix;
  int32_T jy;
  int32_T ijA;
  int32_T pipk;
  int32_T c_i;
  for (b_j = 0; b_j < 144; b_j++) {
    y[b_j] = 0.0;
    A[b_j] = x[b_j];
  }

  for (b_j = 0; b_j < 12; b_j++) {
    ipiv[b_j] = (int8_T)(1 + b_j);
  }

  for (b_j = 0; b_j < 11; b_j++) {
    c = b_j * 13;
    jy = 0;
    ix = c;
    smax = fabs(A[c]);
    for (pipk = 2; pipk <= 12 - b_j; pipk++) {
      ix++;
      s = fabs(A[ix]);
      if (s > smax) {
        jy = pipk - 1;
        smax = s;
      }
    }

    if (A[c + jy] != 0.0) {
      if (jy != 0) {
        ipiv[b_j] = (int8_T)((b_j + jy) + 1);
        b_ix = b_j;
        pipk = b_j + jy;
        for (jy = 0; jy < 12; jy++) {
          smax = A[b_ix];
          A[b_ix] = A[pipk];
          A[pipk] = smax;
          b_ix += 12;
          pipk += 12;
        }
      }

      ix = (c - b_j) + 12;
      for (pipk = c + 1; pipk + 1 <= ix; pipk++) {
        A[pipk] /= A[c];
      }
    }

    pipk = c;
    jy = c + 12;
    for (c_i = 1; c_i <= 11 - b_j; c_i++) {
      smax = A[jy];
      if (A[jy] != 0.0) {
        ix = c + 1;
        b_ix = (pipk - b_j) + 24;
        for (ijA = 13 + pipk; ijA + 1 <= b_ix; ijA++) {
          A[ijA] += A[ix] * -smax;
          ix++;
        }
      }

      jy += 12;
      pipk += 12;
    }
  }

  for (b_j = 0; b_j < 12; b_j++) {
    p[b_j] = (int8_T)(1 + b_j);
  }

  for (ix = 0; ix < 11; ix++) {
    if (ipiv[ix] > 1 + ix) {
      pipk = p[ipiv[ix] - 1];
      p[ipiv[ix] - 1] = p[ix];
      p[ix] = (int8_T)pipk;
    }
  }

  for (ix = 0; ix < 12; ix++) {
    y[ix + 12 * (p[ix] - 1)] = 1.0;
    for (pipk = ix; pipk + 1 < 13; pipk++) {
      if (y[(p[ix] - 1) * 12 + pipk] != 0.0) {
        for (jy = pipk + 1; jy + 1 < 13; jy++) {
          y[jy + 12 * (p[ix] - 1)] = y[(p[ix] - 1) * 12 + jy] - y[(p[ix] - 1) *
            12 + pipk] * A[12 * pipk + jy];
        }
      }
    }
  }

  for (ix = 0; ix < 12; ix++) {
    pipk = 12 * ix;
    for (jy = 11; jy >= 0; jy += -1) {
      b_ix = 12 * jy;
      if (y[jy + pipk] != 0.0) {
        y[jy + pipk] /= A[jy + b_ix];
        for (c_i = 0; c_i + 1 <= jy; c_i++) {
          y[c_i + pipk] -= y[jy + pipk] * A[c_i + b_ix];
        }
      }
    }
  }
}

/* Function for MATLAB Function: '<S14>/MATLAB Function' */
static void Controller_inv(const real_T x[144], real_T y[144])
{
  Controller_invNxN(x, y);
}

/* Function for MATLAB Function: '<S14>/MATLAB Function' */
static real_T Controller_inv_i(real_T x)
{
  return 1.0 / x;
}

/* Function for MATLAB Function: '<S14>/MATLAB Function' */
static void Controller_eye(real_T I[144])
{
  int32_T i;
  memset(&I[0], 0, 144U * sizeof(real_T));
  for (i = 0; i < 12; i++) {
    I[i + 12 * i] = 1.0;
  }
}

real_T rt_powd_snf(real_T u0, real_T u1)
{
  real_T y;
  real_T tmp;
  real_T tmp_0;
  if (rtIsNaN(u0) || rtIsNaN(u1)) {
    y = (rtNaN);
  } else {
    tmp = fabs(u0);
    tmp_0 = fabs(u1);
    if (rtIsInf(u1)) {
      if (tmp == 1.0) {
        y = (rtNaN);
      } else if (tmp > 1.0) {
        if (u1 > 0.0) {
          y = (rtInf);
        } else {
          y = 0.0;
        }
      } else if (u1 > 0.0) {
        y = 0.0;
      } else {
        y = (rtInf);
      }
    } else if (tmp_0 == 0.0) {
      y = 1.0;
    } else if (tmp_0 == 1.0) {
      if (u1 > 0.0) {
        y = u0;
      } else {
        y = 1.0 / u0;
      }
    } else if (u1 == 2.0) {
      y = u0 * u0;
    } else if ((u1 == 0.5) && (u0 >= 0.0)) {
      y = sqrt(u0);
    } else if ((u0 < 0.0) && (u1 > floor(u1))) {
      y = (rtNaN);
    } else {
      y = pow(u0, u1);
    }
  }

  return y;
}

/* Initial conditions for atomic system: '<S14>/MATLAB Function' */
void Controller_MATLABFunction_Init(void)
{
  memset(&Controller_DWork.u_prev[0], 0, 12U * sizeof(real_T));
}

/* Output and update for atomic system: '<S14>/MATLAB Function' */
void Controller_MATLABFunction(void)
{
  real_T pow_sum;
  real_T w[12];
  real_T W[144];
  real_T b_1_T_pinv[12];
  real_T v[12];
  real_T Q[144];
  real_T gamma;
  real_T u_temp[12];
  real_T u[12];
  real_T F_2_hat[2];
  real_T v_0[12];
  real_T Q_0[144];
  real_T l;
  real_T u_0[12];
  real_T f_3_hat;
  int32_T i;
  real_T tmp[144];
  int32_T i_0;
  real_T tmp_0[12];
  real_T tmp_1[2];
  real_T b_1_T_pinv_0[144];
  real_T tmp_2[12];
  int32_T i_1;

  /* Constant: '<S14>/Constant3' */
  /* MATLAB Function 'Controll system/Thrust allocation/MATLAB Function': '<S127>:1' */
  /* % Step 1 */
  /*  setup variables and parameters */
  /* '<S127>:1:5' if isempty(u_prev) */
  /* '<S127>:1:10' if isempty(time_prev) */
  /* '<S127>:1:14' f_1 = tau(3); */
  /* '<S127>:1:15' b_1_T = T(3,:); */
  /* W_1 = eye(max(size(T))); */
  /*  Calculate weigths */
  /* '<S127>:1:19' pow_sum = sum(u_sat); */
  pow_sum = Controller_sum(Controller_P.Constant3_Value);

  /* '<S127>:1:20' w_1 = b_1_T; */
  for (i_0 = 0; i_0 < 12; i_0++) {
    /* Constant: '<S14>/Constant2' */
    w[i_0] = Controller_P.Constant2_Value_l[3 * i_0 + 2];
  }

  /* '<S127>:1:21' for i = 1:length(u_sat) */
  for (i = 0; i < 6; i++) {
    /* Constant: '<S14>/Constant3' */
    /* '<S127>:1:22' if u_sat(i) > 0 */
    if (Controller_P.Constant3_Value[i] > 0.0) {
      /* '<S127>:1:23' w_1(2*i) = pow_sum/u_sat(i); */
      w[((1 + i) << 1) - 1] = pow_sum / Controller_P.Constant3_Value[i];

      /* '<S127>:1:24' w_1(2*i-1) = pow_sum/u_sat(i); */
      w[((1 + i) << 1) - 2] = pow_sum / Controller_P.Constant3_Value[i];
    } else {
      /* '<S127>:1:25' else */
      /* '<S127>:1:26' w_1(2*i) = pow_sum; */
      w[((1 + i) << 1) - 1] = pow_sum;

      /* '<S127>:1:27' w_1(2*i-1) = pow_sum; */
      w[((1 + i) << 1) - 2] = pow_sum;
    }
  }

  /* '<S127>:1:30' W_1 = diag(w_1); */
  Controller_diag(w, W);

  /*  calculate u contribution */
  /* '<S127>:1:33' b_1_T_pinv = inv(W_1)*b_1_T'*inv(b_1_T*inv(W_1)*b_1_T'); */
  Controller_inv(W, tmp);
  pow_sum = 0.0;
  for (i_0 = 0; i_0 < 12; i_0++) {
    w[i_0] = 0.0;
    for (i = 0; i < 12; i++) {
      /* Constant: '<S14>/Constant2' */
      w[i_0] += Controller_P.Constant2_Value_l[3 * i + 2] * tmp[12 * i_0 + i];
    }

    /* Constant: '<S14>/Constant2' */
    pow_sum += Controller_P.Constant2_Value_l[3 * i_0 + 2] * w[i_0];
  }

  pow_sum = Controller_inv_i(pow_sum);
  Controller_inv(W, tmp);

  /* '<S127>:1:34' v_11 = b_1_T_pinv*f_1; */
  for (i_0 = 0; i_0 < 12; i_0++) {
    tmp_0[i_0] = 0.0;
    for (i = 0; i < 12; i++) {
      /* Constant: '<S14>/Constant2' */
      tmp_0[i_0] += tmp[12 * i + i_0] * Controller_P.Constant2_Value_l[3 * i + 2];
    }

    b_1_T_pinv[i_0] = tmp_0[i_0] * pow_sum;
    v[i_0] = b_1_T_pinv[i_0] * Controller_B.Product3[2];
  }

  /* '<S127>:1:35' Q_1 = eye(length(b_1_T)) - b_1_T_pinv*b_1_T; */
  Controller_eye(tmp);
  for (i_0 = 0; i_0 < 12; i_0++) {
    for (i = 0; i < 12; i++) {
      /* Constant: '<S14>/Constant2' */
      Q[i_0 + 12 * i] = tmp[12 * i + i_0] - Controller_P.Constant2_Value_l[3 * i
        + 2] * b_1_T_pinv[i_0];
    }
  }

  /* '<S127>:1:37' gamma_1 = 1; */
  gamma = 1.0;

  /* '<S127>:1:39' if sat_enable */
  if (Controller_U.TA_sat != 0.0) {
    for (i = 0; i < 6; i++) {
      /*  Determine scaling factor */
      /* '<S127>:1:41' u_cand = zeros(length(b_1_T)/2,1); */
      /* '<S127>:1:43' u_temp = v_11; */
      /* '<S127>:1:44' for i = 1:length(b_1_T)/2 */
      /* '<S127>:1:45' u_cand(i) = sqrt(u_temp(2*i-1)^2 + u_temp(2*i)^2); */
      f_3_hat = sqrt(rt_powd_snf(v[((1 + i) << 1) - 2], 2.0) + rt_powd_snf(v[((1
        + i) << 1) - 1], 2.0));

      /* Constant: '<S14>/Constant3' */
      /* '<S127>:1:46' if u_cand(i) > u_sat(i) */
      if ((f_3_hat > Controller_P.Constant3_Value[i]) && (gamma >
           Controller_P.Constant3_Value[i] / f_3_hat)) {
        /* '<S127>:1:47' if gamma_1 >  u_sat(i)/u_cand(i) */
        /* '<S127>:1:48' gamma_1 = u_sat(i)/u_cand(i); */
        gamma = Controller_P.Constant3_Value[i] / f_3_hat;
      }
    }
  }

  /* '<S127>:1:54' u_1 = gamma_1*v_11; */
  for (i = 0; i < 12; i++) {
    u[i] = gamma * v[i];
  }

  /* % Step 2 */
  /*  setup variables and parameters */
  /* '<S127>:1:58' B_2_T = T(1:2,:); */
  /* '<S127>:1:59' F_2_hat = [tau(1) tau(2)]' - gamma_1*B_2_T*v_11; */
  tmp_1[0] = Controller_B.Product3[0];
  tmp_1[1] = Controller_B.Product3[1];
  for (i_0 = 0; i_0 < 2; i_0++) {
    f_3_hat = 0.0;
    for (i = 0; i < 12; i++) {
      /* Constant: '<S14>/Constant2' */
      f_3_hat += Controller_P.Constant2_Value_l[3 * i + i_0] * gamma * v[i];
    }

    F_2_hat[i_0] = tmp_1[i_0] - f_3_hat;
  }

  /* '<S127>:1:60' f_2_hat = F_2_hat(1); */
  /* '<S127>:1:62' b_2_T = T(1,:); */
  /* '<S127>:1:63' W_2 = W_1; */
  /*  calculate u contribution */
  /* '<S127>:1:66' b_2_T_Q_1_pinv = inv(W_2)*Q_1'*b_2_T'*inv(b_2_T*Q_1*inv(W_2)*Q_1'*b_2_T'); */
  Controller_inv(W, tmp);
  for (i_0 = 0; i_0 < 12; i_0++) {
    tmp_0[i_0] = 0.0;
    for (i = 0; i < 12; i++) {
      /* Constant: '<S14>/Constant2' */
      tmp_0[i_0] += Q[12 * i_0 + i] * Controller_P.Constant2_Value_l[3 * i];
    }
  }

  for (i_0 = 0; i_0 < 12; i_0++) {
    u_temp[i_0] = 0.0;
    for (i = 0; i < 12; i++) {
      u_temp[i_0] += tmp[12 * i_0 + i] * tmp_0[i];
    }
  }

  pow_sum = 0.0;
  for (i_0 = 0; i_0 < 12; i_0++) {
    w[i_0] = 0.0;
    for (i = 0; i < 12; i++) {
      w[i_0] += Q[12 * i + i_0] * u_temp[i];
    }

    /* Constant: '<S14>/Constant2' */
    pow_sum += Controller_P.Constant2_Value_l[3 * i_0] * w[i_0];
  }

  pow_sum = Controller_inv_i(pow_sum);
  Controller_inv(W, tmp);
  for (i_0 = 0; i_0 < 12; i_0++) {
    for (i = 0; i < 12; i++) {
      b_1_T_pinv_0[i_0 + 12 * i] = 0.0;
      for (i_1 = 0; i_1 < 12; i_1++) {
        b_1_T_pinv_0[i_0 + 12 * i] = tmp[12 * i_1 + i_0] * Q[12 * i_1 + i] +
          b_1_T_pinv_0[12 * i + i_0];
      }
    }
  }

  /* '<S127>:1:67' v_21 = b_2_T_Q_1_pinv*f_2_hat; */
  for (i_0 = 0; i_0 < 12; i_0++) {
    tmp_0[i_0] = 0.0;
    for (i = 0; i < 12; i++) {
      /* Constant: '<S14>/Constant2' */
      tmp_0[i_0] += b_1_T_pinv_0[12 * i + i_0] * Controller_P.Constant2_Value_l
        [3 * i];
    }

    b_1_T_pinv[i_0] = tmp_0[i_0] * pow_sum;
    v_0[i_0] = b_1_T_pinv[i_0] * F_2_hat[0];
  }

  /* '<S127>:1:68' Q_2 = eye(length(b_1_T)) - b_2_T_Q_1_pinv*b_2_T*Q_1; */
  Controller_eye(tmp);
  for (i_0 = 0; i_0 < 12; i_0++) {
    for (i = 0; i < 12; i++) {
      /* Constant: '<S14>/Constant2' */
      b_1_T_pinv_0[i_0 + 12 * i] = Controller_P.Constant2_Value_l[3 * i] *
        b_1_T_pinv[i_0];
    }
  }

  for (i_0 = 0; i_0 < 12; i_0++) {
    for (i = 0; i < 12; i++) {
      f_3_hat = 0.0;
      for (i_1 = 0; i_1 < 12; i_1++) {
        f_3_hat += b_1_T_pinv_0[12 * i_1 + i_0] * Q[12 * i + i_1];
      }

      Q_0[i_0 + 12 * i] = tmp[12 * i + i_0] - f_3_hat;
    }
  }

  /* '<S127>:1:69' gamma_2 = 1; */
  pow_sum = 1.0;

  /* u_2 = Q_1*v_21; */
  /* '<S127>:1:73' if sat_enable */
  if (Controller_U.TA_sat != 0.0) {
    /*  Determine scaling factor */
    /* '<S127>:1:75' u_cand = zeros(length(b_1_T)/2,1); */
    /* '<S127>:1:77' u_temp = u_1 +  Q_1*v_21; */
    for (i_0 = 0; i_0 < 12; i_0++) {
      f_3_hat = 0.0;
      for (i = 0; i < 12; i++) {
        f_3_hat += Q[12 * i + i_0] * v_0[i];
      }

      u_temp[i_0] = u[i_0] + f_3_hat;
    }

    /* '<S127>:1:78' u_2_temp = Q_1*v_21; */
    for (i_0 = 0; i_0 < 12; i_0++) {
      b_1_T_pinv[i_0] = 0.0;
      for (i = 0; i < 12; i++) {
        b_1_T_pinv[i_0] += Q[12 * i + i_0] * v_0[i];
      }
    }

    /* '<S127>:1:79' for i = 1:length(b_1_T)/2 */
    for (i = 0; i < 6; i++) {
      /* Constant: '<S14>/Constant3' */
      /* '<S127>:1:80' u_cand(i) = sqrt(u_temp(2*i-1)^2 + u_temp(2*i)^2); */
      /* '<S127>:1:81' if u_cand(i) > u_sat(i) */
      if (sqrt(rt_powd_snf(u_temp[((1 + i) << 1) - 2], 2.0) + rt_powd_snf
               (u_temp[((1 + i) << 1) - 1], 2.0)) >
          Controller_P.Constant3_Value[i]) {
        /* '<S127>:1:82' l_1 = u_sat(i) - sqrt(u_1(2*i)^2 + u_1(2*i-1)^2); */
        f_3_hat = Controller_P.Constant3_Value[i] - sqrt(rt_powd_snf(u[((1 + i) <<
          1) - 1], 2.0) + rt_powd_snf(u[((1 + i) << 1) - 2], 2.0));

        /* '<S127>:1:83' l_2 = sqrt(u_2_temp(2*i)^2 + u_2_temp(2*i-1)^2); */
        l = sqrt(rt_powd_snf(b_1_T_pinv[((1 + i) << 1) - 1], 2.0) + rt_powd_snf
                 (b_1_T_pinv[((1 + i) << 1) - 2], 2.0));

        /* '<S127>:1:85' if gamma_2 > l_1/l_2 */
        if (pow_sum > f_3_hat / l) {
          /* '<S127>:1:86' gamma_2 = l_1/l_2; */
          pow_sum = f_3_hat / l;
        }
      }
    }
  }

  /* '<S127>:1:91' u_2 = u_1 + gamma_2*Q_1*v_21; */
  for (i_0 = 0; i_0 < 12; i_0++) {
    f_3_hat = 0.0;
    for (i = 0; i < 12; i++) {
      f_3_hat += Q[12 * i + i_0] * pow_sum * v_0[i];
    }

    u_0[i_0] = u[i_0] + f_3_hat;
  }

  /* % Step 3 */
  /*  setup variables and parameters */
  /* '<S127>:1:95' b_3_T = T(2,:); */
  /* '<S127>:1:96' f_3_hat = tau(2) - gamma_1*b_3_T*v_11 - gamma_2*b_3_T*Q_1*v_21; */
  f_3_hat = 0.0;
  for (i_0 = 0; i_0 < 12; i_0++) {
    /* Constant: '<S14>/Constant2' */
    w[i_0] = Controller_P.Constant2_Value_l[3 * i_0 + 1] * gamma;
    f_3_hat += w[i_0] * v[i_0];
    w[i_0] = 0.0;
    for (i = 0; i < 12; i++) {
      /* Constant: '<S14>/Constant2' */
      w[i_0] += Controller_P.Constant2_Value_l[3 * i + 1] * pow_sum * Q[12 * i_0
        + i];
    }
  }

  pow_sum = 0.0;
  for (i = 0; i < 12; i++) {
    pow_sum += w[i] * v_0[i];
    tmp_2[i] = 0.0;
    for (i_0 = 0; i_0 < 12; i_0++) {
      /* Constant: '<S14>/Constant2' */
      tmp_2[i] += Controller_P.Constant2_Value_l[3 * i_0 + 1] * Q[12 * i + i_0];
    }
  }

  f_3_hat = (Controller_B.Product3[1] - f_3_hat) - pow_sum;

  /* '<S127>:1:97' W_3 = W_1; */
  /*  calculate u contribution */
  /* '<S127>:1:100' b_3_T_Q_1_Q_2_pinv = inv(W_3)*Q_2'*Q_1'*b_3_T'*inv(b_3_T*Q_1*Q_2*inv(W_3)*Q_2'*Q_1'*b_3_T'); */
  Controller_inv(W, tmp);
  for (i_0 = 0; i_0 < 12; i_0++) {
    tmp_0[i_0] = 0.0;
    for (i = 0; i < 12; i++) {
      tmp_0[i_0] += Q_0[12 * i_0 + i] * tmp_2[i];
    }
  }

  for (i_0 = 0; i_0 < 12; i_0++) {
    u_temp[i_0] = 0.0;
    for (i = 0; i < 12; i++) {
      u_temp[i_0] += tmp[12 * i_0 + i] * tmp_0[i];
    }
  }

  for (i_0 = 0; i_0 < 12; i_0++) {
    tmp_0[i_0] = 0.0;
    for (i = 0; i < 12; i++) {
      tmp_0[i_0] += Q_0[12 * i + i_0] * u_temp[i];
    }
  }

  pow_sum = 0.0;
  for (i_0 = 0; i_0 < 12; i_0++) {
    w[i_0] = 0.0;
    for (i = 0; i < 12; i++) {
      w[i_0] += Q[12 * i + i_0] * tmp_0[i];
    }

    /* Constant: '<S14>/Constant2' */
    pow_sum += Controller_P.Constant2_Value_l[3 * i_0 + 1] * w[i_0];
  }

  pow_sum = Controller_inv_i(pow_sum);

  /* '<S127>:1:101' v_31 = b_3_T_Q_1_Q_2_pinv*f_3_hat; */
  Controller_inv(W, tmp);
  for (i_0 = 0; i_0 < 12; i_0++) {
    for (i = 0; i < 12; i++) {
      b_1_T_pinv_0[i_0 + 12 * i] = 0.0;
      for (i_1 = 0; i_1 < 12; i_1++) {
        b_1_T_pinv_0[i_0 + 12 * i] = tmp[12 * i_1 + i_0] * Q_0[12 * i_1 + i] +
          b_1_T_pinv_0[12 * i + i_0];
      }
    }
  }

  for (i_0 = 0; i_0 < 12; i_0++) {
    for (i = 0; i < 12; i++) {
      tmp[i_0 + 12 * i] = 0.0;
      for (i_1 = 0; i_1 < 12; i_1++) {
        tmp[i_0 + 12 * i] = b_1_T_pinv_0[12 * i_1 + i_0] * Q[12 * i_1 + i] +
          tmp[12 * i + i_0];
      }
    }
  }

  for (i_0 = 0; i_0 < 12; i_0++) {
    tmp_0[i_0] = 0.0;
    for (i = 0; i < 12; i++) {
      /* Constant: '<S14>/Constant2' */
      tmp_0[i_0] += tmp[12 * i + i_0] * Controller_P.Constant2_Value_l[3 * i + 1];
    }

    u[i_0] = tmp_0[i_0] * pow_sum * f_3_hat;
  }

  /* '<S127>:1:102' gamma_3 = 1; */
  pow_sum = 1.0;

  /* '<S127>:1:104' if sat_enable */
  if (Controller_U.TA_sat != 0.0) {
    /*  Determine scaling factor */
    /* '<S127>:1:106' u_cand = zeros(length(b_1_T)/2,1); */
    /* '<S127>:1:108' u_temp = u_2 + Q_1*Q_2*v_31; */
    for (i_0 = 0; i_0 < 12; i_0++) {
      for (i = 0; i < 12; i++) {
        b_1_T_pinv_0[i_0 + 12 * i] = 0.0;
        for (i_1 = 0; i_1 < 12; i_1++) {
          b_1_T_pinv_0[i_0 + 12 * i] = Q[12 * i_1 + i_0] * Q_0[12 * i + i_1] +
            b_1_T_pinv_0[12 * i + i_0];
        }
      }
    }

    for (i_0 = 0; i_0 < 12; i_0++) {
      f_3_hat = 0.0;
      for (i = 0; i < 12; i++) {
        f_3_hat += b_1_T_pinv_0[12 * i + i_0] * u[i];
      }

      u_temp[i_0] = u_0[i_0] + f_3_hat;
    }

    /* '<S127>:1:109' u_3_temp = Q_1*Q_2*v_31; */
    for (i_0 = 0; i_0 < 12; i_0++) {
      for (i = 0; i < 12; i++) {
        b_1_T_pinv_0[i_0 + 12 * i] = 0.0;
        for (i_1 = 0; i_1 < 12; i_1++) {
          b_1_T_pinv_0[i_0 + 12 * i] = Q[12 * i_1 + i_0] * Q_0[12 * i + i_1] +
            b_1_T_pinv_0[12 * i + i_0];
        }
      }
    }

    for (i_0 = 0; i_0 < 12; i_0++) {
      b_1_T_pinv[i_0] = 0.0;
      for (i = 0; i < 12; i++) {
        b_1_T_pinv[i_0] += b_1_T_pinv_0[12 * i + i_0] * u[i];
      }
    }

    /* '<S127>:1:110' for i = 1:length(b_1_T)/2 */
    for (i = 0; i < 6; i++) {
      /* Constant: '<S14>/Constant3' */
      /* '<S127>:1:111' u_cand(i) = sqrt(u_temp(2*i-1)^2 + u_temp(2*i)^2); */
      /* '<S127>:1:112' if u_cand(i) > u_sat(i) */
      if (sqrt(rt_powd_snf(u_temp[((1 + i) << 1) - 2], 2.0) + rt_powd_snf
               (u_temp[((1 + i) << 1) - 1], 2.0)) >
          Controller_P.Constant3_Value[i]) {
        /* '<S127>:1:113' l_1 = u_sat(i) - sqrt(u_2(2*i)^2 + u_2(2*i-1)^2); */
        f_3_hat = Controller_P.Constant3_Value[i] - sqrt(rt_powd_snf(u_0[((1 + i)
          << 1) - 1], 2.0) + rt_powd_snf(u_0[((1 + i) << 1) - 2], 2.0));

        /* '<S127>:1:114' l_2 = sqrt(u_3_temp(2*i)^2 + u_3_temp(2*i-1)^2); */
        l = sqrt(rt_powd_snf(b_1_T_pinv[((1 + i) << 1) - 1], 2.0) + rt_powd_snf
                 (b_1_T_pinv[((1 + i) << 1) - 2], 2.0));

        /* '<S127>:1:116' if gamma_3 > l_1/l_2 */
        if (pow_sum > f_3_hat / l) {
          /* '<S127>:1:117' gamma_3 = l_1/l_2; */
          pow_sum = f_3_hat / l;
        }
      }
    }
  }

  /* '<S127>:1:123' u_3 = u_2 + gamma_3*Q_1*Q_2*v_31; */
  for (i_0 = 0; i_0 < 12; i_0++) {
    for (i = 0; i < 12; i++) {
      b_1_T_pinv_0[i_0 + 12 * i] = 0.0;
      for (i_1 = 0; i_1 < 12; i_1++) {
        b_1_T_pinv_0[i_0 + 12 * i] = Q[12 * i_1 + i_0] * pow_sum * Q_0[12 * i +
          i_1] + b_1_T_pinv_0[12 * i + i_0];
      }
    }
  }

  for (i_0 = 0; i_0 < 12; i_0++) {
    f_3_hat = 0.0;
    for (i = 0; i < 12; i++) {
      f_3_hat += b_1_T_pinv_0[12 * i + i_0] * u[i];
    }

    Controller_B.u[i_0] = u_0[i_0] + f_3_hat;
  }

  /* '<S127>:1:125' u = u_3; */
  /* '<S127>:1:127' if rate_enable */
  if (Controller_U.TA_rate_sat != 0.0) {
    /*  Calculate rate vector */
    /* '<S127>:1:129' rate = (u-u_prev)/0.01; */
    for (i_0 = 0; i_0 < 12; i_0++) {
      Controller_B.u[i_0] = (Controller_B.u[i_0] - Controller_DWork.u_prev[i_0])
        / 0.01;
    }

    /* '<S127>:1:130' rate_cand = zeros(length(b_1_T)/2,1); */
    /* '<S127>:1:131' gamma_rate = 1; */
    pow_sum = 1.0;

    /* '<S127>:1:133' for i = 1:length(b_1_T)/2 */
    for (i = 0; i < 6; i++) {
      /* '<S127>:1:134' rate_cand(i) = sqrt(rate(2*i-1)^2 + rate(2*i)^2); */
      f_3_hat = sqrt(rt_powd_snf(Controller_B.u[((1 + i) << 1) - 2], 2.0) +
                     rt_powd_snf(Controller_B.u[((1 + i) << 1) - 1], 2.0));

      /* Constant: '<S14>/Constant8' */
      /* '<S127>:1:135' if rate_cand(i) > rate_sat(i) */
      if ((f_3_hat > Controller_P.Constant8_Value[i]) && (pow_sum >
           Controller_P.Constant8_Value[i] / f_3_hat)) {
        /* '<S127>:1:136' if gamma_rate >  rate_sat(i)/(rate_cand(i)) */
        /* '<S127>:1:137' gamma_rate = rate_sat(i)/(rate_cand(i)); */
        pow_sum = Controller_P.Constant8_Value[i] / f_3_hat;
      }

      /* End of Constant: '<S14>/Constant8' */
    }

    /* '<S127>:1:142' u = u_prev + 0.01*gamma_rate*rate; */
    pow_sum *= 0.01;

    /* '<S127>:1:143' u_prev = u; */
    for (i_0 = 0; i_0 < 12; i_0++) {
      Controller_B.u[i_0] = pow_sum * Controller_B.u[i_0] +
        Controller_DWork.u_prev[i_0];
      Controller_DWork.u_prev[i_0] = Controller_B.u[i_0];
    }
  }

  /* tau_out = T*u; */
}

real_T rt_urand_Upu32_Yd_f_pw_snf(uint32_T *u)
{
  uint32_T lo;
  uint32_T hi;

  /* Uniform random number generator (random number between 0 and 1)

     #define IA      16807                      magic multiplier = 7^5
     #define IM      2147483647                 modulus = 2^31-1
     #define IQ      127773                     IM div IA
     #define IR      2836                       IM modulo IA
     #define S       4.656612875245797e-10      reciprocal of 2^31-1
     test = IA * (seed % IQ) - IR * (seed/IQ)
     seed = test < 0 ? (test + IM) : test
     return (seed*S)
   */
  lo = *u % 127773U * 16807U;
  hi = *u / 127773U * 2836U;
  if (lo < hi) {
    *u = 2147483647U - (hi - lo);
  } else {
    *u = lo - hi;
  }

  return (real_T)*u * 4.6566128752457969E-10;
}

real_T rt_nrand_Upu32_Yd_f_pw_snf(uint32_T *u)
{
  real_T sr;
  real_T si;

  /* Normal (Gaussian) random number generator */
  do {
    sr = 2.0 * rt_urand_Upu32_Yd_f_pw_snf(u) - 1.0;
    si = 2.0 * rt_urand_Upu32_Yd_f_pw_snf(u) - 1.0;
    si = sr * sr + si * si;
  } while (si > 1.0);

  return sqrt(-2.0 * log(si) / si) * sr;
}

real_T rt_atan2d_snf(real_T u0, real_T u1)
{
  real_T y;
  int32_T u;
  int32_T u_0;
  if (rtIsNaN(u0) || rtIsNaN(u1)) {
    y = (rtNaN);
  } else if (rtIsInf(u0) && rtIsInf(u1)) {
    if (u0 > 0.0) {
      u = 1;
    } else {
      u = -1;
    }

    if (u1 > 0.0) {
      u_0 = 1;
    } else {
      u_0 = -1;
    }

    y = atan2((real_T)u, (real_T)u_0);
  } else if (u1 == 0.0) {
    if (u0 > 0.0) {
      y = RT_PI / 2.0;
    } else if (u0 < 0.0) {
      y = -(RT_PI / 2.0);
    } else {
      y = 0.0;
    }
  } else {
    y = atan2(u0, u1);
  }

  return y;
}

/* Function for MATLAB Function: '<S16>/Control law parameter calculation' */
static void Controller_conv(const real_T A[2], const real_T B[3], real_T C[4])
{
  real_T s;
  int32_T k;
  s = 0.0;
  for (k = 0; k + 1 < 2; k++) {
    s += A[k] * B[-k];
  }

  C[0] = s;
  s = 0.0;
  for (k = 0; k + 1 < 3; k++) {
    s += B[1 - k] * A[k];
  }

  C[1] = s;
  s = 0.0;
  for (k = 0; k + 1 < 3; k++) {
    s += B[2 - k] * A[k];
  }

  C[2] = s;
  s = 0.0;
  for (k = 1; k + 1 < 3; k++) {
    s += B[3 - k] * A[k];
  }

  C[3] = s;
}

/* Model step function */
void Controller_step(void)
{
  /* local block i/o variables */
  real_T rtb_TransferFcn2;
  real_T rtb_TransferFcn1;
  real_T rtb_TransferFcn;
  real_T rtb_TransferFcn_j;
  real_T rtb_TransferFcn1_n;
  real_T rtb_TransferFcn2_b;
  real_T rtb_TransferFcn3;
  real_T rtb_TransferFcn4;
  real_T rtb_TransferFcn5;
  real_T rtb_Clock;
  real_T rtb_Clock_m;
  real_T rtb_Clock_f;
  real_T rtb_Gain_i[3];
  real_T rtb_TransferFcn2_h;
  real_T rtb_TransferFcn1_o;
  real_T rtb_Gain5_g;
  real_T kp[9];
  real_T p[9];
  real_T p_0[9];
  real_T diophantine_eq[4];
  real_T q[2];
  static const int16_T M_0deu[3] = { 10000, 10000, 12000 };

  static const int16_T b_a[4] = { 700, 0, 0, 200 };

  int32_T k;
  static const int16_T M_0du[3] = { 10000, 10000, 12000 };

  static const int16_T a[4] = { 6100, 0, 0, 200 };

  real_T rtb_Gain1_f;
  real_T rtb_D[3];
  real_T rtb_VectorConcatenate_d[9];
  real_T rtb_Integrator_d[3];
  real_T rtb_Sum_be[3];
  real_T rtb_Row1;
  real_T rtb_Row2;
  real_T rtb_Row3;
  real_T rtb_VectorConcatenate_p[9];
  real_T rtb_Gain_pk[3];
  real_T rtb_VectorConcatenate_c[9];
  real_T rtb_Sum_k;
  real_T rtb_Sum2_i;
  real_T rtb_Integrator1_i;
  real_T rtb_VectorConcatenate_h[9];
  real_T rtb_Step;
  int32_T idx2;
  real_T rtb_Divide;
  real_T rtb_Gain_ia;
  real_T rtb_VectorConcatenate_n[9];
  real_T rtb_VectorConcatenate_ck[9];
  real_T rtb_VectorConcatenate_k[9];
  real_T rtb_VectorConcatenate_nu[9];
  real_T rtb_VectorConcatenate_kf[9];
  real_T rtb_sincos_o2[3];
  real_T rtb_VectorConcatenate_nt[9];
  real_T rtb_Gain6[3];
  real_T rtb_Sum_g[3];
  real_T rtb_ypm[3];
  real_T rtb_yFm[3];
  real_T rtb_VectorConcatenate_g[9];
  real_T rtb_VectorConcatenate_pj[9];
  real_T rtb_VectorConcatenate_a[9];
  real_T rtb_VectorConcatenate_l[9];
  real_T rtb_Product_g[3];
  real_T rtb_VectorConcatenate_o[9];
  real_T rtb_VectorConcatenate_kr[9];
  real_T rtb_VectorConcatenate_b[9];
  real_T rtb_VectorConcatenate_ou[9];
  real_T rtb_TmpSignalConversionAtSFun_g[3];
  real_T rtb_TmpSignalConversionAtSFu_gy[3];
  real_T rtb_TmpSignalConversionAtSFun_d[3];
  real_T rtb_TmpSignalConversionAtSFun_n[3];
  real_T rtb_Sum3_g;
  real_T rtb_Z_m[3];
  real_T rtb_k_m_r[3];
  real_T rtb_Integrator2[6];
  real_T rtb_Integrator6[6];
  real_T rtb_Integrator10[18];
  real_T rtb_Integrator3[18];
  real_T rtb_theta_ctrl_hat[12];
  real_T rtb_R_m[9];
  real_T rtb_frc_ctrl[3];
  real_T rtb_mrac_theta_p[36];
  int32_T i;
  real_T tmp[2];
  real_T tmp_0[4];
  real_T tmp_1[4];
  real_T tmp_2[3];
  real_T rtb_VectorConcatenate_p_0[3];
  real_T rtb_VectorConcatenate_p_1[3];
  real_T rtb_Sum1_pd_0[12];
  real_T tmp_3[9];
  real_T tmp_4[9];
  real_T a_data[2];
  real_T rtb_Normalization_data[2];
  real_T rtb_Integrator_idx;
  real_T rtb_Integrator_idx_0;
  real_T rtb_Integrator_idx_1;
  real_T rtb_Integrator2_n_idx;
  real_T rtb_Integrator2_n_idx_0;
  real_T rtb_Integrator2_n_idx_1;
  real_T rtb_sincos_o1_e_idx;
  real_T rtb_Sum5_o_idx;
  real_T rtb_Sum5_o_idx_0;
  real_T rtb_Sum5_o_idx_1;
  real_T rtb_Sum2_a_idx;
  real_T rtb_Sum2_a_idx_0;
  real_T rtb_Sum2_a_idx_1;
  real_T rtb_sincos_o1_idx;
  real_T rtb_sincos_o1_idx_0;
  real_T rtb_sincos_o1_idx_1;
  real_T rtb_Sum1_pd_idx;
  real_T rtb_Sum3_c_idx;
  real_T rtb_Sum3_c_idx_0;
  real_T rtb_Sum3_c_idx_1;
  real_T rtb_Gain1_l_idx;
  real_T rtb_Gain1_l_idx_0;
  real_T rtb_Gain1_l_idx_1;
  real_T rtb_Normalization_idx;
  real_T rtb_Normalization_idx_0;
  real_T omega_idx;
  if (rtmIsMajorTimeStep(Controller_M)) {
    /* set solver stop time */
    if (!(Controller_M->Timing.clockTick0+1)) {
      rtsiSetSolverStopTime(&Controller_M->solverInfo,
                            ((Controller_M->Timing.clockTickH0 + 1) *
        Controller_M->Timing.stepSize0 * 4294967296.0));
    } else {
      rtsiSetSolverStopTime(&Controller_M->solverInfo,
                            ((Controller_M->Timing.clockTick0 + 1) *
        Controller_M->Timing.stepSize0 + Controller_M->Timing.clockTickH0 *
        Controller_M->Timing.stepSize0 * 4294967296.0));
    }
  }                                    /* end MajorTimeStep */

  /* Update absolute time of base rate at minor time step */
  if (rtmIsMinorTimeStep(Controller_M)) {
    Controller_M->Timing.t[0] = rtsiGetT(&Controller_M->solverInfo);
  }

  /* Integrator: '<S14>/Integrator' */
  rtb_Integrator_idx_1 = Controller_X.Integrator_CSTATE[0];
  rtb_Integrator_idx_0 = Controller_X.Integrator_CSTATE[1];
  rtb_Integrator_idx = Controller_X.Integrator_CSTATE[2];

  /* Outport: '<Root>/tau_X' incorporates:
   *  Integrator: '<S14>/Integrator'
   */
  Controller_Y.tau_X = Controller_X.Integrator_CSTATE[0];

  /* Outport: '<Root>/tau_Y' incorporates:
   *  Integrator: '<S14>/Integrator'
   */
  Controller_Y.tau_Y = Controller_X.Integrator_CSTATE[1];

  /* Outport: '<Root>/tau_N' incorporates:
   *  Integrator: '<S14>/Integrator'
   */
  Controller_Y.tau_N = Controller_X.Integrator_CSTATE[2];

  /* Integrator: '<S104>/Integrator1' */
  rtb_Sum2_a_idx_1 = Controller_X.Integrator1_CSTATE[0];
  rtb_Sum2_a_idx_0 = Controller_X.Integrator1_CSTATE[1];
  rtb_Sum2_a_idx = Controller_X.Integrator1_CSTATE[2];

  /* TransferFcn: '<S77>/Transfer Fcn2' */
  rtb_TransferFcn2 = Controller_P.TransferFcn2_C[0]*
    Controller_X.TransferFcn2_CSTATE[0]
    + Controller_P.TransferFcn2_C[1]*Controller_X.TransferFcn2_CSTATE[1];

  /* Step: '<S8>/Step2' */
  if (Controller_M->Timing.t[0] < Controller_P.Step2_Time) {
    rtb_Normalization_idx = Controller_P.Step2_Y0;
  } else {
    rtb_Normalization_idx = Controller_P.Step2_YFinal;
  }

  /* End of Step: '<S8>/Step2' */

  /* Step: '<S8>/Step3' */
  if (Controller_M->Timing.t[0] < Controller_P.Step3_Time) {
    rtb_Normalization_idx_0 = Controller_P.Step3_Y0;
  } else {
    rtb_Normalization_idx_0 = Controller_P.Step3_YFinal;
  }

  /* End of Step: '<S8>/Step3' */

  /* Sum: '<S8>/Sum' incorporates:
   *  Gain: '<S8>/Gain'
   *  Inport: '<Root>/eta_d_y'
   *  Sum: '<S8>/Sum3'
   */
  rtb_Gain_ia = (rtb_Normalization_idx + rtb_Normalization_idx_0) *
    Controller_P.Gain_Gain + Controller_U.eta_d_y;

  /* Step: '<S8>/Step' */
  if (Controller_M->Timing.t[0] < Controller_P.Step_Time) {
    rtb_Normalization_idx = Controller_P.Step_Y0;
  } else {
    rtb_Normalization_idx = Controller_P.Step_YFinal;
  }

  /* End of Step: '<S8>/Step' */

  /* Step: '<S8>/Step1' */
  if (Controller_M->Timing.t[0] < Controller_P.Step1_Time) {
    rtb_Normalization_idx_0 = Controller_P.Step1_Y0;
  } else {
    rtb_Normalization_idx_0 = Controller_P.Step1_YFinal;
  }

  /* End of Step: '<S8>/Step1' */

  /* Gain: '<S135>/Gain1' incorporates:
   *  Gain: '<S8>/Gain1'
   *  Inport: '<Root>/eta_d_psi'
   *  Sum: '<S8>/Sum1'
   *  Sum: '<S8>/Sum2'
   */
  rtb_Gain1_f = ((rtb_Normalization_idx + rtb_Normalization_idx_0) *
                 Controller_P.Gain1_Gain + Controller_U.eta_d_psi) *
    Controller_P.Gain1_Gain_j;

  /* Sum: '<S15>/Sum' incorporates:
   *  Inport: '<Root>/eta_d_x'
   */
  rtb_D[0] = Controller_U.eta_d_x - rtb_Sum2_a_idx_1;
  rtb_D[1] = rtb_Gain_ia - rtb_Sum2_a_idx_0;
  rtb_D[2] = rtb_Gain1_f - rtb_TransferFcn2;

  /* Outport: '<Root>/eta_err_N' */
  Controller_Y.eta_err_N = rtb_D[0];

  /* Outport: '<Root>/eta_err_E' */
  Controller_Y.eta_err_E = rtb_D[1];

  /* Outport: '<Root>/eta_err_psi' */
  Controller_Y.eta_err_psi = rtb_D[2];

  /* Outport: '<Root>/eta_e_N_AFF' */
  Controller_Y.eta_e_N_AFF = rtb_Sum2_a_idx_1;

  /* Outport: '<Root>/eta_e_E_AFF' */
  Controller_Y.eta_e_E_AFF = rtb_Sum2_a_idx_0;

  /* Outport: '<Root>/eta_e_psi_AFF' */
  Controller_Y.eta_e_psi_AFF = rtb_TransferFcn2;

  /* TransferFcn: '<S77>/Transfer Fcn1' */
  rtb_TransferFcn1 = Controller_P.TransferFcn1_C[0]*
    Controller_X.TransferFcn1_CSTATE[0]
    + Controller_P.TransferFcn1_C[1]*Controller_X.TransferFcn1_CSTATE[1];

  /* TransferFcn: '<S77>/Transfer Fcn' */
  rtb_TransferFcn = Controller_P.TransferFcn_C[0]*
    Controller_X.TransferFcn_CSTATE[0]
    + Controller_P.TransferFcn_C[1]*Controller_X.TransferFcn_CSTATE[1];

  /* SignalConversion: '<S109>/TmpSignal ConversionAtsincosInport1' */
  rtb_sincos_o1_idx_1 = rtb_TransferFcn2;
  rtb_sincos_o1_idx_0 = rtb_TransferFcn1;
  rtb_sincos_o1_idx = rtb_TransferFcn;

  /* Trigonometry: '<S114>/sincos' incorporates:
   *  SignalConversion: '<S109>/TmpSignal ConversionAtsincosInport1'
   */
  rtb_Sum_be[0] = sin(rtb_TransferFcn2);
  rtb_Integrator_d[0] = cos(rtb_TransferFcn2);
  rtb_Sum_be[1] = sin(rtb_TransferFcn1);
  rtb_Integrator_d[1] = cos(rtb_TransferFcn1);
  rtb_Sum_be[2] = sin(rtb_TransferFcn);
  rtb_Integrator_d[2] = cos(rtb_TransferFcn);

  /* Fcn: '<S114>/Fcn11' */
  rtb_VectorConcatenate_d[0] = rtb_Integrator_d[1] * rtb_Integrator_d[0];

  /* Fcn: '<S114>/Fcn21' */
  rtb_VectorConcatenate_d[1] = rtb_Sum_be[2] * rtb_Sum_be[1] * rtb_Integrator_d
    [0] - rtb_Integrator_d[2] * rtb_Sum_be[0];

  /* Fcn: '<S114>/Fcn31' */
  rtb_VectorConcatenate_d[2] = rtb_Integrator_d[2] * rtb_Sum_be[1] *
    rtb_Integrator_d[0] + rtb_Sum_be[2] * rtb_Sum_be[0];

  /* Fcn: '<S114>/Fcn12' */
  rtb_VectorConcatenate_d[3] = rtb_Integrator_d[1] * rtb_Sum_be[0];

  /* Fcn: '<S114>/Fcn22' */
  rtb_VectorConcatenate_d[4] = rtb_Sum_be[2] * rtb_Sum_be[1] * rtb_Sum_be[0] +
    rtb_Integrator_d[2] * rtb_Integrator_d[0];

  /* Fcn: '<S114>/Fcn32' */
  rtb_VectorConcatenate_d[5] = rtb_Integrator_d[2] * rtb_Sum_be[1] * rtb_Sum_be
    [0] - rtb_Sum_be[2] * rtb_Integrator_d[0];

  /* Fcn: '<S114>/Fcn13' */
  rtb_VectorConcatenate_d[6] = -rtb_Sum_be[1];

  /* Fcn: '<S114>/Fcn23' */
  rtb_VectorConcatenate_d[7] = rtb_Sum_be[2] * rtb_Integrator_d[1];

  /* Fcn: '<S114>/Fcn33' */
  rtb_VectorConcatenate_d[8] = rtb_Integrator_d[2] * rtb_Integrator_d[1];

  /* Integrator: '<S104>/Integrator' */
  rtb_Integrator_d[0] = Controller_X.Integrator_CSTATE_g[0];
  rtb_Integrator_d[1] = Controller_X.Integrator_CSTATE_g[1];
  rtb_Integrator_d[2] = Controller_X.Integrator_CSTATE_g[2];

  /* Product: '<S107>/Product1' incorporates:
   *  Integrator: '<S104>/Integrator'
   */
  for (k = 0; k < 3; k++) {
    rtb_Sum_be[k] = rtb_VectorConcatenate_d[k + 6] *
      Controller_X.Integrator_CSTATE_g[2] + (rtb_VectorConcatenate_d[k + 3] *
      Controller_X.Integrator_CSTATE_g[1] + rtb_VectorConcatenate_d[k] *
      Controller_X.Integrator_CSTATE_g[0]);
  }

  /* End of Product: '<S107>/Product1' */

  /* Outport: '<Root>/nu_e_u_AFF' */
  Controller_Y.nu_e_u_AFF = rtb_Sum_be[0];

  /* Outport: '<Root>/nu_e_v_AFF' */
  Controller_Y.nu_e_v_AFF = rtb_Sum_be[1];

  /* Integrator: '<S106>/Integrator' */
  Controller_B.Integrator[0] = Controller_X.Integrator_CSTATE_f[0];
  Controller_B.Integrator[1] = Controller_X.Integrator_CSTATE_f[1];
  Controller_B.Integrator[2] = Controller_X.Integrator_CSTATE_f[2];

  /* Outport: '<Root>/nu_e_r_AFF' */
  Controller_Y.nu_e_r_AFF = Controller_B.Integrator[2];

  /* Integrator: '<S107>/Integrator2' */
  rtb_Sum5_o_idx_1 = Controller_X.Integrator2_CSTATE[0];
  rtb_Sum5_o_idx_0 = Controller_X.Integrator2_CSTATE[1];
  rtb_Sum5_o_idx = Controller_X.Integrator2_CSTATE[2];

  /* Gain: '<S107>/Gain' incorporates:
   *  Integrator: '<S107>/Integrator2'
   */
  Controller_B.Gain[0] = Controller_P.Gain_Gain_a *
    Controller_X.Integrator2_CSTATE[0];
  Controller_B.Gain[1] = Controller_P.Gain_Gain_a *
    Controller_X.Integrator2_CSTATE[1];
  Controller_B.Gain[2] = Controller_P.Gain_Gain_a *
    Controller_X.Integrator2_CSTATE[2];

  /* Outport: '<Root>/d_e_x_AFF' */
  Controller_Y.d_e_x_AFF = Controller_B.Gain[0];

  /* Outport: '<Root>/d_e_y_AFF' */
  Controller_Y.d_e_y_AFF = Controller_B.Gain[1];

  /* Outport: '<Root>/d_e_psi_AFF' */
  Controller_Y.d_e_psi_AFF = Controller_B.Gain[2];
  for (i = 0; i < 6; i++) {
    /* Integrator: '<S16>/Integrator2' */
    rtb_Integrator2[i] = Controller_X.Integrator2_CSTATE_f[i];

    /* Integrator: '<S16>/Integrator6' */
    rtb_Integrator6[i] = Controller_X.Integrator6_CSTATE[i];
  }

  /* Fcn: '<S27>/Row1' incorporates:
   *  Inport: '<Root>/eta_d_x'
   */
  Controller_B.Row1 = cos(rtb_TransferFcn2) * Controller_U.eta_d_x + sin
    (rtb_TransferFcn2) * rtb_Gain_ia;

  /* Fcn: '<S27>/Row2' incorporates:
   *  Inport: '<Root>/eta_d_x'
   */
  Controller_B.Row2 = -sin(rtb_TransferFcn2) * Controller_U.eta_d_x + cos
    (rtb_TransferFcn2) * rtb_Gain_ia;

  /* Fcn: '<S27>/Row3' */
  Controller_B.Row3 = rtb_Gain1_f;

  /* TransferFcn: '<S22>/Transfer Fcn' */
  rtb_TransferFcn_j = Controller_P.TransferFcn_C_d*
    Controller_X.TransferFcn_CSTATE_e;

  /* TransferFcn: '<S22>/Transfer Fcn1' */
  rtb_TransferFcn1_n = Controller_P.TransferFcn1_C_o*
    Controller_X.TransferFcn1_CSTATE_d;

  /* TransferFcn: '<S22>/Transfer Fcn2' */
  rtb_TransferFcn2_b = Controller_P.TransferFcn2_C_n*
    Controller_X.TransferFcn2_CSTATE_b;

  /* TransferFcn: '<S22>/Transfer Fcn3' */
  rtb_TransferFcn3 = Controller_P.TransferFcn3_D*Controller_B.Gain[0];

  /* TransferFcn: '<S22>/Transfer Fcn4' */
  rtb_TransferFcn4 = Controller_P.TransferFcn4_D*Controller_B.Gain[1];

  /* TransferFcn: '<S22>/Transfer Fcn5' */
  rtb_TransferFcn5 = Controller_P.TransferFcn5_D*Controller_B.Gain[2];

  /* Fcn: '<S26>/Row1' */
  rtb_Row1 = cos(rtb_TransferFcn2) * rtb_Sum2_a_idx_1 + sin(rtb_TransferFcn2) *
    rtb_Sum2_a_idx_0;

  /* Fcn: '<S26>/Row2' */
  rtb_Row2 = -sin(rtb_TransferFcn2) * rtb_Sum2_a_idx_1 + cos(rtb_TransferFcn2) *
    rtb_Sum2_a_idx_0;

  /* Fcn: '<S26>/Row3' */
  rtb_Row3 = rtb_TransferFcn2;

  /* SignalConversion: '<S31>/TmpSignal ConversionAt SFunction Inport3' incorporates:
   *  MATLAB Function: '<S16>/reference_model'
   */
  rtb_TmpSignalConversionAtSFun_g[0] = Controller_B.Row1;
  rtb_TmpSignalConversionAtSFun_g[1] = Controller_B.Row2;
  rtb_TmpSignalConversionAtSFun_g[2] = Controller_B.Row3;

  /* SignalConversion: '<S31>/TmpSignal ConversionAt SFunction Inport4' incorporates:
   *  MATLAB Function: '<S16>/reference_model'
   */
  rtb_TmpSignalConversionAtSFu_gy[0] = rtb_TransferFcn_j;
  rtb_TmpSignalConversionAtSFu_gy[1] = rtb_TransferFcn1_n;
  rtb_TmpSignalConversionAtSFu_gy[2] = rtb_TransferFcn2_b;

  /* SignalConversion: '<S31>/TmpSignal ConversionAt SFunction Inport8' incorporates:
   *  MATLAB Function: '<S16>/reference_model'
   */
  rtb_TmpSignalConversionAtSFun_d[0] = rtb_TransferFcn3;
  rtb_TmpSignalConversionAtSFun_d[1] = rtb_TransferFcn4;
  rtb_TmpSignalConversionAtSFun_d[2] = rtb_TransferFcn5;

  /* SignalConversion: '<S31>/TmpSignal ConversionAt SFunction Inport9' incorporates:
   *  Fcn: '<S26>/Row3'
   *  MATLAB Function: '<S16>/reference_model'
   */
  rtb_TmpSignalConversionAtSFun_n[0] = rtb_Row1;
  rtb_TmpSignalConversionAtSFun_n[1] = rtb_Row2;
  rtb_TmpSignalConversionAtSFun_n[2] = rtb_TransferFcn2;

  /* MATLAB Function: '<S16>/reference_model' incorporates:
   *  Constant: '<S16>/Constant21'
   *  Constant: '<S16>/Constant22'
   */
  /* MATLAB Function 'Controll system/Control law/Robust MRAC/reference_model': '<S31>:1' */
  /* Initialization */
  /* '<S31>:1:7' if isempty(first) */
  /* System states */
  /* '<S31>:1:17' ypm = zeros(3,1); */
  rtb_ypm[0] = 0.0;
  rtb_ypm[1] = 0.0;
  rtb_ypm[2] = 0.0;

  /* '<S31>:1:18' yFm = zeros(3,1); */
  rtb_yFm[0] = 0.0;
  rtb_yFm[1] = 0.0;
  rtb_yFm[2] = 0.0;

  /* '<S31>:1:19' xm_dot = zeros(2,3); */
  /* '<S31>:1:20' Fm_dot = zeros(2,3); */
  for (i = 0; i < 6; i++) {
    Controller_B.xm_dot[i] = 0.0;
    Controller_B.Fm_dot[i] = 0.0;
  }

  /* Polynomials for control law calculation */
  /* '<S31>:1:23' Z_m = zeros(3,1); */
  rtb_Z_m[0] = 0.0;
  rtb_Z_m[1] = 0.0;
  rtb_Z_m[2] = 0.0;

  /* '<S31>:1:24' R_m = zeros(3,3); */
  memset(&rtb_R_m[0], 0, 9U * sizeof(real_T));

  /* '<S31>:1:25' k_m_r = zeros(3,1); */
  rtb_k_m_r[0] = 0.0;
  rtb_k_m_r[1] = 0.0;
  rtb_k_m_r[2] = 0.0;

  /* Signal indicating force control */
  /* '<S31>:1:28' frc_ctrl = [0 0 0]; */
  rtb_frc_ctrl[0] = 0.0;
  rtb_frc_ctrl[1] = 0.0;
  rtb_frc_ctrl[2] = 0.0;

  /* Defining a reference model compensating for environmental dynamics */
  /* '<S31>:1:31' for i = 1:3 */
  for (i = 0; i < 3; i++) {
    /* '<S31>:1:33' xm = y0(:,i); */
    /* '<S31>:1:34' Fm = F0(:,i); */
    /* '<S31>:1:36' if abs(r(i)-eta_p(i)) > e_tol(i) */
    if (fabs(rtb_TmpSignalConversionAtSFun_g[i] -
             rtb_TmpSignalConversionAtSFun_n[i]) >
        Controller_P.Constant22_Value[i]) {
      /* Desired impedance damping factor and reconance frequency */
      /* '<S31>:1:39' zeta = 0.9; */
      rtb_Divide = 0.9;

      /* '<S31>:1:40' omega_0 = 1.1; */
      rtb_Sum3_g = 1.1;

      /* System matrices of reference model */
      /* '<S31>:1:43' A_m = [-2*zeta*omega_0 1; */
      /* '<S31>:1:44'                             -omega_0^2 0]; */
      /* '<S31>:1:45' B_m = [0 omega_0^2]'; */
      /* '<S31>:1:46' C_m = [1 0]; */
      /* Position control */
      /* '<S31>:1:50' xm_dot(:,i) = A_m*xm + B_m*r_lp(i); */
      Controller_B.xm_dot[i << 1] = (rtb_Integrator2[i << 1] *
        -1.9800000000000002 + rtb_Integrator2[(i << 1) + 1]) + 0.0 *
        rtb_TmpSignalConversionAtSFu_gy[i];
      Controller_B.xm_dot[1 + (i << 1)] = (rtb_Integrator2[(i << 1) + 1] * 0.0 +
        rtb_Integrator2[i << 1] * -1.2100000000000002) + 1.2100000000000002 *
        rtb_TmpSignalConversionAtSFu_gy[i];

      /* '<S31>:1:52' ypm(i) = C_m*xm; */
      rtb_ypm[i] = rtb_Integrator2[(i << 1) + 1] * 0.0 + rtb_Integrator2[i << 1];

      /* '<S31>:1:54' frc_ctrl(i) = 0; */
      rtb_frc_ctrl[i] = 0.0;
    } else if ((fabs(rtb_TmpSignalConversionAtSFun_d[i]) >
                Controller_P.Constant21_Value[i << 1]) && (fabs
                (rtb_TmpSignalConversionAtSFun_g[i] -
                 rtb_TmpSignalConversionAtSFun_n[i]) <
                Controller_P.Constant22_Value[i])) {
      /* '<S31>:1:57' elseif abs(F_C(i)) > F_tol(1,i) && abs(r(i)-eta_p(i)) < e_tol(i) */
      /* Force control */
      /* Desired impedance damping factor and reconance frequency */
      /* '<S31>:1:62' zeta = 0.9; */
      rtb_Divide = 0.9;

      /* '<S31>:1:63' omega_0 = 1.1; */
      rtb_Sum3_g = 1.1;

      /* System matrices of reference model */
      /* '<S31>:1:66' A_m = [-2*zeta*omega_0 1; */
      /* '<S31>:1:67'                             -omega_0^2 0]; */
      /* '<S31>:1:68' B_m = [0 omega_0^2]'; */
      /* '<S31>:1:69' C_m = [1 0]; */
      /* '<S31>:1:71' Fm_dot(:,i) = A_m*Fm + B_m*F_C(i); */
      Controller_B.Fm_dot[i << 1] = (rtb_Integrator6[i << 1] *
        -1.9800000000000002 + rtb_Integrator6[(i << 1) + 1]) + 0.0 *
        rtb_TmpSignalConversionAtSFun_d[i];
      Controller_B.Fm_dot[1 + (i << 1)] = (rtb_Integrator6[(i << 1) + 1] * 0.0 +
        rtb_Integrator6[i << 1] * -1.2100000000000002) + 1.2100000000000002 *
        rtb_TmpSignalConversionAtSFun_d[i];

      /* '<S31>:1:73' yFm(i) = C_m*Fm; */
      rtb_yFm[i] = rtb_Integrator6[(i << 1) + 1] * 0.0 + rtb_Integrator6[i << 1];

      /* '<S31>:1:75' flag(i) = 1; */
      Controller_DWork.flag[i] = 1.0;

      /* '<S31>:1:76' frc_ctrl(i) = 1; */
      rtb_frc_ctrl[i] = 1.0;
    } else if ((fabs(rtb_TmpSignalConversionAtSFun_d[i]) <
                Controller_P.Constant21_Value[(i << 1) + 1]) &&
               (Controller_DWork.flag[i] == 1.0)) {
      /* '<S31>:1:78' elseif abs(F_C(i)) < F_tol(2,i) && flag(i) == 1 */
      /* Desired impedance damping factor and reconance frequency */
      /* '<S31>:1:81' zeta = 1.1; */
      rtb_Divide = 1.1;

      /* '<S31>:1:82' omega_0 = 0.7; */
      rtb_Sum3_g = 0.7;

      /* System matrices of reference model */
      /* '<S31>:1:85' A_m = [-2*zeta*omega_0 1; */
      /* '<S31>:1:86'                             -omega_0^2 0]; */
      /* '<S31>:1:87' B_m = [0 omega_0^2]'; */
      /* '<S31>:1:88' C_m = [1 0]; */
      /* Position control */
      /* '<S31>:1:91' xm_dot(:,i) = A_m*xm + B_m*r_lp(i); */
      Controller_B.xm_dot[i << 1] = (rtb_Integrator2[i << 1] * -1.54 +
        rtb_Integrator2[(i << 1) + 1]) + 0.0 * rtb_TmpSignalConversionAtSFu_gy[i];
      Controller_B.xm_dot[1 + (i << 1)] = (rtb_Integrator2[(i << 1) + 1] * 0.0 +
        rtb_Integrator2[i << 1] * -0.48999999999999994) + 0.48999999999999994 *
        rtb_TmpSignalConversionAtSFu_gy[i];

      /* '<S31>:1:93' ypm(i) = C_m*xm; */
      rtb_ypm[i] = rtb_Integrator2[(i << 1) + 1] * 0.0 + rtb_Integrator2[i << 1];

      /* '<S31>:1:95' flag(i) = 0; */
      Controller_DWork.flag[i] = 0.0;

      /* '<S31>:1:96' frc_ctrl(i) = 0; */
      rtb_frc_ctrl[i] = 0.0;
    } else if ((fabs(rtb_TmpSignalConversionAtSFun_d[i]) <
                Controller_P.Constant21_Value[i << 1]) &&
               (Controller_DWork.flag[i] == 1.0) && (fabs
                (rtb_TmpSignalConversionAtSFun_g[i] -
                 rtb_TmpSignalConversionAtSFun_n[i]) <
                Controller_P.Constant22_Value[i])) {
      /* '<S31>:1:98' elseif abs(F_C(i)) < F_tol(1,i) && flag(i) == 1 && abs(r(i)-eta_p(i)) < e_tol(i) */
      /* Desired impedance damping factor and reconance frequency */
      /* '<S31>:1:101' zeta = 0.9; */
      rtb_Divide = 0.9;

      /* '<S31>:1:102' omega_0 = 1.1; */
      rtb_Sum3_g = 1.1;

      /* System matrices of reference model */
      /* '<S31>:1:105' A_m = [-2*zeta*omega_0 1; */
      /* '<S31>:1:106'                             -omega_0^2 0]; */
      /* '<S31>:1:107' B_m = [0 omega_0^2]'; */
      /* '<S31>:1:108' C_m = [1 0]; */
      /* Force control */
      /* '<S31>:1:111' Fm_dot(:,i) = A_m*Fm + B_m*F_C(i); */
      Controller_B.Fm_dot[i << 1] = (rtb_Integrator6[i << 1] *
        -1.9800000000000002 + rtb_Integrator6[(i << 1) + 1]) + 0.0 *
        rtb_TmpSignalConversionAtSFun_d[i];
      Controller_B.Fm_dot[1 + (i << 1)] = (rtb_Integrator6[(i << 1) + 1] * 0.0 +
        rtb_Integrator6[i << 1] * -1.2100000000000002) + 1.2100000000000002 *
        rtb_TmpSignalConversionAtSFun_d[i];

      /* '<S31>:1:113' yFm(i) = C_m*Fm; */
      rtb_yFm[i] = rtb_Integrator6[(i << 1) + 1] * 0.0 + rtb_Integrator6[i << 1];

      /* '<S31>:1:115' frc_ctrl(i) = 1; */
      rtb_frc_ctrl[i] = 1.0;
    } else {
      /* '<S31>:1:117' else */
      /* Desired impedance damping factor and reconance frequency */
      /* '<S31>:1:119' zeta = 0.9; */
      rtb_Divide = 0.9;

      /* '<S31>:1:120' omega_0 = 1.1; */
      rtb_Sum3_g = 1.1;

      /* System matrices of reference model */
      /* '<S31>:1:123' A_m = [-2*zeta*omega_0 1; */
      /* '<S31>:1:124'                             -omega_0^2 0]; */
      /* '<S31>:1:125' B_m = [0 omega_0^2]'; */
      /* '<S31>:1:126' C_m = [1 0]; */
      /* Position control */
      /* '<S31>:1:130' xm_dot(:,i) = A_m*xm + B_m*r_lp(i); */
      Controller_B.xm_dot[i << 1] = (rtb_Integrator2[i << 1] *
        -1.9800000000000002 + rtb_Integrator2[(i << 1) + 1]) + 0.0 *
        rtb_TmpSignalConversionAtSFu_gy[i];
      Controller_B.xm_dot[1 + (i << 1)] = (rtb_Integrator2[(i << 1) + 1] * 0.0 +
        rtb_Integrator2[i << 1] * -1.2100000000000002) + 1.2100000000000002 *
        rtb_TmpSignalConversionAtSFu_gy[i];

      /* '<S31>:1:132' ypm(i) = C_m*xm; */
      rtb_ypm[i] = rtb_Integrator2[(i << 1) + 1] * 0.0 + rtb_Integrator2[i << 1];

      /* '<S31>:1:134' frc_ctrl(i) = 0; */
      rtb_frc_ctrl[i] = 0.0;
    }

    /* '<S31>:1:138' Z_m(i) = 1; */
    rtb_Z_m[i] = 1.0;

    /* '<S31>:1:139' R_m(i,:) = [1 2*zeta*omega_0 omega_0^2]; */
    rtb_R_m[i] = 1.0;
    rtb_R_m[3 + i] = 2.0 * rtb_Divide * rtb_Sum3_g;
    rtb_R_m[6 + i] = rt_powd_snf(rtb_Sum3_g, 2.0);

    /* '<S31>:1:140' k_m_r(i) = omega_0^2; */
    rtb_k_m_r[i] = rt_powd_snf(rtb_Sum3_g, 2.0);
  }

  for (i = 0; i < 18; i++) {
    /* Integrator: '<S16>/Integrator10' */
    rtb_Integrator10[i] = Controller_X.Integrator10_CSTATE[i];

    /* Integrator: '<S16>/Integrator3' */
    rtb_Integrator3[i] = Controller_X.Integrator3_CSTATE[i];
  }

  /* MATLAB Function: '<S16>/Calculation of theta_p' incorporates:
   *  Integrator: '<S16>/Integrator10'
   *  Integrator: '<S16>/Integrator3'
   *  SignalConversion: '<S20>/TmpSignal ConversionAt SFunction Inport1'
   *  SignalConversion: '<S20>/TmpSignal ConversionAt SFunction Inport4'
   */
  /* MATLAB Function 'Controll system/Control law/Robust MRAC/Calculation of theta_p': '<S20>:1' */
  /* '<S20>:1:3' kp = zeros(3,3); */
  /* '<S20>:1:4' p21 = zeros(3,3); */
  /* '<S20>:1:5' p22 = zeros(3,3); */
  for (k = 0; k < 9; k++) {
    kp[k] = 0.0;
    p[k] = 0.0;
    p_0[k] = 0.0;
  }

  /* '<S20>:1:7' Me_hat = theta_e_hat(:,1:3); */
  /* '<S20>:1:8' De_hat = theta_e_hat(:,4:6); */
  /* '<S20>:1:10' M_hat = theta_ves_hat(1:3,:); */
  /* '<S20>:1:11' D_hat = theta_ves_hat(4:6,:); */
  /* '<S20>:1:13' for i=1:3 */
  /* '<S20>:1:15' if frc_ctrl(i) == 1 */
  if (rtb_frc_ctrl[0] == 1.0) {
    /* '<S20>:1:16' k_value = abs(F_C(i))/(4 - abs(eta_p(2))); */
    rtb_Divide = fabs(rtb_TransferFcn3) / (4.0 - fabs(rtb_Row2));

    /* '<S20>:1:18' kp(i,i) = k_value/M_hat(i,i); */
    kp[0] = rtb_Divide / Controller_X.Integrator3_CSTATE[0];

    /* '<S20>:1:19' p21(i,i) = D_hat(i,i)/M_hat(i,i); */
    p[0] = Controller_X.Integrator3_CSTATE[3] / Controller_X.Integrator3_CSTATE
      [0];

    /* '<S20>:1:20' p22(i,i) = k_value/M_hat(i,i); */
    p_0[0] = rtb_Divide / Controller_X.Integrator3_CSTATE[0];
  } else {
    /* '<S20>:1:21' else */
    /* '<S20>:1:22' kp(i,i) = 1/(M_hat(i,i) + Me_hat(i,i)); */
    kp[0] = 1.0 / (Controller_X.Integrator3_CSTATE[0] +
                   Controller_X.Integrator10_CSTATE[0]);

    /* '<S20>:1:23' p21(i,i) = kp(i,i)*(D_hat(i,i) + De_hat(i,i)); */
    p[0] = (Controller_X.Integrator3_CSTATE[3] +
            Controller_X.Integrator10_CSTATE[9]) * kp[0];
  }

  /* '<S20>:1:15' if frc_ctrl(i) == 1 */
  if (rtb_frc_ctrl[1] == 1.0) {
    /* '<S20>:1:16' k_value = abs(F_C(i))/(4 - abs(eta_p(2))); */
    rtb_Divide = fabs(rtb_TransferFcn4) / (4.0 - fabs(rtb_Row2));

    /* '<S20>:1:18' kp(i,i) = k_value/M_hat(i,i); */
    kp[4] = rtb_Divide / Controller_X.Integrator3_CSTATE[7];

    /* '<S20>:1:19' p21(i,i) = D_hat(i,i)/M_hat(i,i); */
    p[4] = Controller_X.Integrator3_CSTATE[10] /
      Controller_X.Integrator3_CSTATE[7];

    /* '<S20>:1:20' p22(i,i) = k_value/M_hat(i,i); */
    p_0[4] = rtb_Divide / Controller_X.Integrator3_CSTATE[7];
  } else {
    /* '<S20>:1:21' else */
    /* '<S20>:1:22' kp(i,i) = 1/(M_hat(i,i) + Me_hat(i,i)); */
    kp[4] = 1.0 / (Controller_X.Integrator3_CSTATE[7] +
                   Controller_X.Integrator10_CSTATE[4]);

    /* '<S20>:1:23' p21(i,i) = kp(i,i)*(D_hat(i,i) + De_hat(i,i)); */
    p[4] = (Controller_X.Integrator3_CSTATE[10] +
            Controller_X.Integrator10_CSTATE[13]) * kp[4];
  }

  /* '<S20>:1:15' if frc_ctrl(i) == 1 */
  if (rtb_frc_ctrl[2] == 1.0) {
    /* '<S20>:1:16' k_value = abs(F_C(i))/(4 - abs(eta_p(2))); */
    rtb_Divide = fabs(rtb_TransferFcn5) / (4.0 - fabs(rtb_Row2));

    /* '<S20>:1:18' kp(i,i) = k_value/M_hat(i,i); */
    kp[8] = rtb_Divide / Controller_X.Integrator3_CSTATE[14];

    /* '<S20>:1:19' p21(i,i) = D_hat(i,i)/M_hat(i,i); */
    p[8] = Controller_X.Integrator3_CSTATE[17] /
      Controller_X.Integrator3_CSTATE[14];

    /* '<S20>:1:20' p22(i,i) = k_value/M_hat(i,i); */
    p_0[8] = rtb_Divide / Controller_X.Integrator3_CSTATE[14];
  } else {
    /* '<S20>:1:21' else */
    /* '<S20>:1:22' kp(i,i) = 1/(M_hat(i,i) + Me_hat(i,i)); */
    kp[8] = 1.0 / (Controller_X.Integrator3_CSTATE[14] +
                   Controller_X.Integrator10_CSTATE[8]);

    /* '<S20>:1:23' p21(i,i) = kp(i,i)*(D_hat(i,i) + De_hat(i,i)); */
    p[8] = (Controller_X.Integrator3_CSTATE[17] +
            Controller_X.Integrator10_CSTATE[17]) * kp[8];
  }

  /* '<S20>:1:27' mrac_theta_p = [zeros(3,3); kp; p21; p22]; */
  for (k = 0; k < 3; k++) {
    rtb_mrac_theta_p[12 * k] = 0.0;
    rtb_mrac_theta_p[1 + 12 * k] = 0.0;
    rtb_mrac_theta_p[2 + 12 * k] = 0.0;
  }

  for (k = 0; k < 3; k++) {
    rtb_mrac_theta_p[3 + 12 * k] = kp[3 * k];
    rtb_mrac_theta_p[4 + 12 * k] = kp[3 * k + 1];
    rtb_mrac_theta_p[5 + 12 * k] = kp[3 * k + 2];
  }

  for (k = 0; k < 3; k++) {
    rtb_mrac_theta_p[6 + 12 * k] = p[3 * k];
    rtb_mrac_theta_p[7 + 12 * k] = p[3 * k + 1];
    rtb_mrac_theta_p[8 + 12 * k] = p[3 * k + 2];
  }

  for (k = 0; k < 3; k++) {
    rtb_mrac_theta_p[9 + 12 * k] = p_0[3 * k];
    rtb_mrac_theta_p[10 + 12 * k] = p_0[3 * k + 1];
    rtb_mrac_theta_p[11 + 12 * k] = p_0[3 * k + 2];
  }

  /* End of MATLAB Function: '<S16>/Calculation of theta_p' */

  /* MATLAB Function: '<S16>/Control law parameter calculation' */
  /* MATLAB Function 'Controll system/Control law/Robust MRAC/Control law parameter calculation': '<S21>:1' */
  /* Definition of reference model polynomials. Consider defining these */
  /* elsewhere somehow. */
  /* '<S21>:1:9' if isempty(first) */
  /* Initialization of controller coefficients */
  /* '<S21>:1:24' c_0 = zeros(3,1); */
  rtb_TmpSignalConversionAtSFun_g[0] = 0.0;
  rtb_TmpSignalConversionAtSFun_g[1] = 0.0;
  rtb_TmpSignalConversionAtSFun_g[2] = 0.0;

  /* '<S21>:1:25' theta_1 = zeros(3,1); */
  rtb_TmpSignalConversionAtSFu_gy[0] = 0.0;
  rtb_TmpSignalConversionAtSFu_gy[1] = 0.0;
  rtb_TmpSignalConversionAtSFu_gy[2] = 0.0;

  /* '<S21>:1:26' theta_2 = zeros(3,1); */
  rtb_TmpSignalConversionAtSFun_d[0] = 0.0;
  rtb_TmpSignalConversionAtSFun_d[1] = 0.0;
  rtb_TmpSignalConversionAtSFun_d[2] = 0.0;

  /* '<S21>:1:27' theta_3 = zeros(3,1); */
  rtb_TmpSignalConversionAtSFun_n[0] = 0.0;
  rtb_TmpSignalConversionAtSFun_n[1] = 0.0;
  rtb_TmpSignalConversionAtSFun_n[2] = 0.0;

  /* Input from adaptive law */
  /* '<S21>:1:30' k_p_hat = mrac_theta_p(4:6,:); */
  /* '<S21>:1:31' p21 = mrac_theta_p(7:9,:); */
  /* '<S21>:1:32' p22 = mrac_theta_p(10:12,:); */
  /* '<S21>:1:34' for i=1:3 */
  for (i = 0; i < 3; i++) {
    /* '<S21>:1:36' Lambda = conv(Lambda_0,Z_m(i)); */
    rtb_Divide = 0.0;
    for (k = 1; k + 1 < 3; k++) {
      rtb_Divide += Controller_DWork.Lambda_0[k] * rtb_Z_m[i];
    }

    rtb_Normalization_idx = rtb_Divide;

    /* Define the estimated plant polynomials */
    /* '<S21>:1:39' R_p_hat(i,:) = [1 p21(i,i) p22(i,i)]; */
    Controller_DWork.R_p_hat[i] = 1.0;
    Controller_DWork.R_p_hat[3 + i] = rtb_mrac_theta_p[(12 * i + i) + 6];
    Controller_DWork.R_p_hat[6 + i] = rtb_mrac_theta_p[(12 * i + i) + 9];

    /* '<S21>:1:40' Z_p_bar_hat(i) = k_p_hat(i,i); */
    Controller_DWork.Z_p_bar_hat[i] = rtb_mrac_theta_p[(12 * i + i) + 3];

    /* '<S21>:1:41' [Q(i,:),R] = deconv(conv(Lambda_0, R_m(i,:)),R_p_hat(i,:)); */
    rtb_VectorConcatenate_p_0[0] = rtb_R_m[i];
    rtb_VectorConcatenate_p_0[1] = rtb_R_m[i + 3];
    rtb_VectorConcatenate_p_0[2] = rtb_R_m[i + 6];
    Controller_conv(Controller_DWork.Lambda_0, rtb_VectorConcatenate_p_0,
                    diophantine_eq);
    omega_idx = Controller_DWork.R_p_hat[i + 3];
    rtb_Normalization_idx_0 = Controller_DWork.R_p_hat[i + 6];
    if (!((!((!rtIsInf(Controller_DWork.R_p_hat[i])) && (!rtIsNaN
            (Controller_DWork.R_p_hat[i])))) || (Controller_DWork.R_p_hat[i] ==
          0.0) || (!(Controller_DWork.R_p_hat[i] != 1.0)))) {
      diophantine_eq[0] /= Controller_DWork.R_p_hat[i];
      diophantine_eq[1] /= Controller_DWork.R_p_hat[i];
      diophantine_eq[2] /= Controller_DWork.R_p_hat[i];
      diophantine_eq[3] /= Controller_DWork.R_p_hat[i];
      omega_idx = Controller_DWork.R_p_hat[i + 3] / Controller_DWork.R_p_hat[i];
      rtb_Normalization_idx_0 = Controller_DWork.R_p_hat[i + 6] /
        Controller_DWork.R_p_hat[i];
    }

    rtb_Gain1_l_idx_0 = 0.0;
    rtb_Sum2_i = 0.0;
    rtb_Sum1_pd_idx = 0.0;
    for (k = 0; k < 2; k++) {
      rtb_Gain1_l_idx_1 = (1.0 - (real_T)k) * diophantine_eq[0] +
        rtb_Gain1_l_idx_0;
      rtb_Gain1_l_idx_0 = (1.0 - (real_T)k) * diophantine_eq[1] + rtb_Sum2_i;
      rtb_Sum2_i = (1.0 - (real_T)k) * diophantine_eq[2] + rtb_Sum1_pd_idx;
      rtb_Sum1_pd_idx = (1.0 - (real_T)k) * diophantine_eq[3];
      rtb_Gain1_l_idx_0 -= rtb_Gain1_l_idx_1 * omega_idx;
      rtb_Sum2_i -= rtb_Gain1_l_idx_1 * rtb_Normalization_idx_0;
      q[k] = rtb_Gain1_l_idx_1;
    }

    Controller_DWork.Q[i] = q[0];
    Controller_DWork.Q[i + 3] = q[1];

    /* Equation for theta_1 */
    /* '<S21>:1:44' theta_1_poly = Lambda - conv(Z_p_bar_hat(i), Q(i,:))/k_p_hat(i,i); */
    rtb_Divide = 0.0;
    idx2 = 1;
    while (idx2 <= 1) {
      rtb_Divide += Controller_DWork.Q[i + 3] * Controller_DWork.Z_p_bar_hat[i];
      idx2 = 2;
    }

    /* The Diophantine Equation:  theta_2 + theta_3(s+1) = as + b */
    /* has solution theta_2 = b-a, theta_3 = a */
    /* '<S21>:1:48' diophantine_eq = 1/k_p_hat(i,i)*(conv(Q(i,:),R_p_hat(i,:)) - conv(Lambda_0,R_m(i,:))); */
    rtb_Sum2_i = 1.0 / rtb_mrac_theta_p[(12 * i + i) + 3];
    tmp[0] = Controller_DWork.Q[i];
    tmp[1] = Controller_DWork.Q[i + 3];
    tmp_2[0] = Controller_DWork.R_p_hat[i];
    tmp_2[1] = Controller_DWork.R_p_hat[i + 3];
    tmp_2[2] = Controller_DWork.R_p_hat[i + 6];
    Controller_conv(tmp, tmp_2, tmp_0);
    rtb_VectorConcatenate_p_1[0] = rtb_R_m[i];
    rtb_VectorConcatenate_p_1[1] = rtb_R_m[i + 3];
    rtb_VectorConcatenate_p_1[2] = rtb_R_m[i + 6];
    Controller_conv(Controller_DWork.Lambda_0, rtb_VectorConcatenate_p_1, tmp_1);
    diophantine_eq[2] = (tmp_0[2] - tmp_1[2]) * rtb_Sum2_i;

    /* Solve for controller parameters */
    /* '<S21>:1:51' c_0(i) = k_m_r(i)/k_p_hat(i,i); */
    rtb_TmpSignalConversionAtSFun_g[i] = rtb_k_m_r[i] / rtb_mrac_theta_p[(12 * i
      + i) + 3];

    /* '<S21>:1:52' theta_1(i) = theta_1_poly(end); */
    rtb_TmpSignalConversionAtSFu_gy[i] = rtb_Normalization_idx - rtb_Divide /
      rtb_mrac_theta_p[(12 * i + i) + 3];

    /* '<S21>:1:53' theta_2(i) = diophantine_eq(end)-diophantine_eq(end-1); */
    rtb_TmpSignalConversionAtSFun_d[i] = (tmp_0[3] - tmp_1[3]) * rtb_Sum2_i -
      diophantine_eq[2];

    /* '<S21>:1:54' theta_3(i) = diophantine_eq(end-1); */
    rtb_TmpSignalConversionAtSFun_n[i] = diophantine_eq[2];
  }

  /* '<S21>:1:58' theta_ctrl_hat = [theta_1 theta_2 theta_3 c_0]; */
  rtb_theta_ctrl_hat[0] = rtb_TmpSignalConversionAtSFu_gy[0];
  rtb_theta_ctrl_hat[1] = rtb_TmpSignalConversionAtSFu_gy[1];
  rtb_theta_ctrl_hat[2] = rtb_TmpSignalConversionAtSFu_gy[2];
  rtb_theta_ctrl_hat[3] = rtb_TmpSignalConversionAtSFun_d[0];
  rtb_theta_ctrl_hat[4] = rtb_TmpSignalConversionAtSFun_d[1];
  rtb_theta_ctrl_hat[5] = rtb_TmpSignalConversionAtSFun_d[2];
  rtb_theta_ctrl_hat[6] = rtb_TmpSignalConversionAtSFun_n[0];
  rtb_theta_ctrl_hat[7] = rtb_TmpSignalConversionAtSFun_n[1];
  rtb_theta_ctrl_hat[8] = rtb_TmpSignalConversionAtSFun_n[2];
  rtb_theta_ctrl_hat[9] = rtb_TmpSignalConversionAtSFun_g[0];
  rtb_theta_ctrl_hat[10] = rtb_TmpSignalConversionAtSFun_g[1];
  rtb_theta_ctrl_hat[11] = rtb_TmpSignalConversionAtSFun_g[2];

  /* SignalConversion: '<S28>/TmpSignal ConversionAt SFunction Inport2' incorporates:
   *  Fcn: '<S26>/Row3'
   *  MATLAB Function: '<S16>/control_law'
   */
  rtb_TmpSignalConversionAtSFun_g[0] = rtb_Row1;
  rtb_TmpSignalConversionAtSFun_g[1] = rtb_Row2;
  rtb_TmpSignalConversionAtSFun_g[2] = rtb_TransferFcn2;

  /* SignalConversion: '<S28>/TmpSignal ConversionAt SFunction Inport3' incorporates:
   *  MATLAB Function: '<S16>/control_law'
   */
  rtb_TmpSignalConversionAtSFu_gy[0] = rtb_TransferFcn3;
  rtb_TmpSignalConversionAtSFu_gy[1] = rtb_TransferFcn4;
  rtb_TmpSignalConversionAtSFu_gy[2] = rtb_TransferFcn5;

  /* SignalConversion: '<S28>/TmpSignal ConversionAt SFunction Inport4' incorporates:
   *  MATLAB Function: '<S16>/control_law'
   */
  rtb_TmpSignalConversionAtSFun_d[0] = rtb_TransferFcn_j;
  rtb_TmpSignalConversionAtSFun_d[1] = rtb_TransferFcn1_n;
  rtb_TmpSignalConversionAtSFun_d[2] = rtb_TransferFcn2_b;

  /* MATLAB Function: '<S16>/control_law' incorporates:
   *  Constant: '<S16>/Constant16'
   *  Constant: '<S16>/Constant18'
   *  Fcn: '<S26>/Row3'
   *  Integrator: '<S16>/Integrator1'
   *  Integrator: '<S16>/Integrator10'
   *  SignalConversion: '<S28>/TmpSignal ConversionAt SFunction Inport2'
   *  SignalConversion: '<S28>/TmpSignal ConversionAt SFunction Inport3'
   */
  /* MATLAB Function 'Controll system/Control law/Robust MRAC/control_law': '<S28>:1' */
  /* '<S28>:1:4' theta_1 = theta_ctrl_r_hat(:,1); */
  /* '<S28>:1:5' theta_2 = theta_ctrl_r_hat(:,2); */
  /* '<S28>:1:6' theta_3 = theta_ctrl_r_hat(:,3); */
  /* '<S28>:1:7' c_0 = theta_ctrl_r_hat(:,4); */
  /* '<S28>:1:9' F_T = zeros(3,1); */
  rtb_Z_m[0] = 0.0;
  rtb_Z_m[1] = 0.0;
  rtb_Z_m[2] = 0.0;

  /* '<S28>:1:10' omega1_dot = zeros(1,3); */
  /* '<S28>:1:11' omega2_dot = zeros(1,3); */
  /* '<S28>:1:12' omega3_dot = zeros(1,3); */
  /* Constant ocean current and environmental damping */
  /* '<S28>:1:15' nu_c = -0.1; */
  /* '<S28>:1:16' D_e_hat = theta_e_hat(:,4:6); */
  /* Control laws */
  /* '<S28>:1:19' for i=1:3 */
  for (i = 0; i < 3; i++) {
    /* '<S28>:1:21' if frc_ctrl(i) == 1 */
    if (rtb_frc_ctrl[i] == 1.0) {
      /* Force control. Divide theta by c_0 as we are dealing with force reference */
      /* '<S28>:1:24' theta = [theta_1(i) theta_2(i) theta_3(i) c_0(i)]'./c_0(i); */
      rtb_Gain1_l_idx_1 = rtb_theta_ctrl_hat[i] / rtb_theta_ctrl_hat[9 + i];
      rtb_Gain1_l_idx_0 = rtb_theta_ctrl_hat[3 + i] / rtb_theta_ctrl_hat[9 + i];
      rtb_Sum2_i = rtb_theta_ctrl_hat[6 + i] / rtb_theta_ctrl_hat[9 + i];
      rtb_Sum1_pd_idx = rtb_theta_ctrl_hat[9 + i] / rtb_theta_ctrl_hat[9 + i];

      /* '<S28>:1:25' omega = [omega0(1,i) omega0(3,i) F_C(i) F_C(i)]'; */
      rtb_Normalization_idx_0 = Controller_X.Integrator1_CSTATE_m[3 * i];
      rtb_Normalization_idx = Controller_X.Integrator1_CSTATE_m[3 * i + 2];
      omega_idx = rtb_TmpSignalConversionAtSFu_gy[i];
      rtb_Sum3_g = rtb_TmpSignalConversionAtSFu_gy[i];
    } else {
      /* '<S28>:1:27' else */
      /* Position control. */
      /* '<S28>:1:30' theta = [theta_1(i) theta_2(i) theta_3(i) c_0(i)]'; */
      rtb_Gain1_l_idx_1 = rtb_theta_ctrl_hat[i];
      rtb_Gain1_l_idx_0 = rtb_theta_ctrl_hat[3 + i];
      rtb_Sum2_i = rtb_theta_ctrl_hat[6 + i];
      rtb_Sum1_pd_idx = rtb_theta_ctrl_hat[9 + i];

      /* '<S28>:1:31' omega = [omega0(1,i) omega0(2,i) eta_p(i) r(i)]'; */
      rtb_Normalization_idx_0 = Controller_X.Integrator1_CSTATE_m[3 * i];
      rtb_Normalization_idx = Controller_X.Integrator1_CSTATE_m[3 * i + 1];
      omega_idx = rtb_TmpSignalConversionAtSFun_g[i];
      rtb_Sum3_g = rtb_TmpSignalConversionAtSFun_d[i];
    }

    /* '<S28>:1:35' F_T(i) = theta'*omega; */
    rtb_Z_m[i] = ((rtb_Gain1_l_idx_1 * rtb_Normalization_idx_0 +
                   rtb_Gain1_l_idx_0 * rtb_Normalization_idx) + rtb_Sum2_i *
                  omega_idx) + rtb_Sum1_pd_idx * rtb_Sum3_g;
  }

  /* '<S28>:1:40' for i = 1:3 */
  /* Filtered thruster force for position/force control */
  /* '<S28>:1:43' if i == 1 */
  /* Subtract damping in surge to counteract constant ocean current */
  /* '<S28>:1:45' omega1_dot(i) = F*omega0(1,i)+g*(F_T(i) + nu_c*D_e_hat(i,i)); */
  /* Filtered position for position control */
  /* '<S28>:1:51' omega2_dot(i) = F*omega0(2,i)+g*eta_p(i); */
  /* Filtered environmental force for force control */
  /* '<S28>:1:54' omega3_dot(i) = F*omega0(3,i)+g*F_C(i); */
  /* Filtered thruster force for position/force control */
  /* '<S28>:1:43' if i == 1 */
  /* '<S28>:1:46' else */
  /* '<S28>:1:47' omega1_dot(i) = F*omega0(1,i)+g*F_T(i); */
  /* Filtered position for position control */
  /* '<S28>:1:51' omega2_dot(i) = F*omega0(2,i)+g*eta_p(i); */
  /* Filtered environmental force for force control */
  /* '<S28>:1:54' omega3_dot(i) = F*omega0(3,i)+g*F_C(i); */
  /* Filtered thruster force for position/force control */
  /* '<S28>:1:43' if i == 1 */
  /* '<S28>:1:46' else */
  /* '<S28>:1:47' omega1_dot(i) = F*omega0(1,i)+g*F_T(i); */
  /* Filtered position for position control */
  /* '<S28>:1:51' omega2_dot(i) = F*omega0(2,i)+g*eta_p(i); */
  /* Filtered environmental force for force control */
  /* '<S28>:1:54' omega3_dot(i) = F*omega0(3,i)+g*F_C(i); */
  /* '<S28>:1:58' omega0_dot = [omega1_dot; omega2_dot; omega3_dot]; */
  Controller_B.omega0_dot[0] = (-0.1 * Controller_X.Integrator10_CSTATE[9] +
    rtb_Z_m[0]) * Controller_P.Constant18_Value + Controller_P.Constant16_Value *
    Controller_X.Integrator1_CSTATE_m[0];
  Controller_B.omega0_dot[3] = Controller_P.Constant16_Value *
    Controller_X.Integrator1_CSTATE_m[3] + Controller_P.Constant18_Value *
    rtb_Z_m[1];
  Controller_B.omega0_dot[6] = Controller_P.Constant16_Value *
    Controller_X.Integrator1_CSTATE_m[6] + Controller_P.Constant18_Value *
    rtb_Z_m[2];
  Controller_B.omega0_dot[1] = Controller_P.Constant16_Value *
    Controller_X.Integrator1_CSTATE_m[1] + Controller_P.Constant18_Value *
    rtb_Row1;
  Controller_B.omega0_dot[4] = Controller_P.Constant16_Value *
    Controller_X.Integrator1_CSTATE_m[4] + Controller_P.Constant18_Value *
    rtb_Row2;
  Controller_B.omega0_dot[7] = Controller_P.Constant16_Value *
    Controller_X.Integrator1_CSTATE_m[7] + Controller_P.Constant18_Value *
    rtb_TransferFcn2;
  Controller_B.omega0_dot[2] = Controller_P.Constant16_Value *
    Controller_X.Integrator1_CSTATE_m[2] + Controller_P.Constant18_Value *
    rtb_TransferFcn3;
  Controller_B.omega0_dot[5] = Controller_P.Constant16_Value *
    Controller_X.Integrator1_CSTATE_m[5] + Controller_P.Constant18_Value *
    rtb_TransferFcn4;
  Controller_B.omega0_dot[8] = Controller_P.Constant16_Value *
    Controller_X.Integrator1_CSTATE_m[8] + Controller_P.Constant18_Value *
    rtb_TransferFcn5;

  /* SignalConversion: '<S133>/ConcatBufferAtVector ConcatenateIn1' incorporates:
   *  Inport: '<Root>/Ki_x'
   */
  rtb_VectorConcatenate_p[0] = Controller_U.Ki_x;

  /* SignalConversion: '<S133>/ConcatBufferAtVector ConcatenateIn2' incorporates:
   *  Constant: '<S6>/Constant2'
   */
  rtb_VectorConcatenate_p[1] = Controller_P.Constant2_Value;

  /* SignalConversion: '<S133>/ConcatBufferAtVector ConcatenateIn3' incorporates:
   *  Constant: '<S6>/Constant1'
   */
  rtb_VectorConcatenate_p[2] = Controller_P.Constant1_Value;

  /* SignalConversion: '<S133>/ConcatBufferAtVector ConcatenateIn4' incorporates:
   *  Constant: '<S6>/Constant2'
   */
  rtb_VectorConcatenate_p[3] = Controller_P.Constant2_Value;

  /* SignalConversion: '<S133>/ConcatBufferAtVector ConcatenateIn5' incorporates:
   *  Inport: '<Root>/Ki_y'
   */
  rtb_VectorConcatenate_p[4] = Controller_U.Ki_y;

  /* SignalConversion: '<S133>/ConcatBufferAtVector ConcatenateIn6' incorporates:
   *  Constant: '<S6>/Constant1'
   */
  rtb_VectorConcatenate_p[5] = Controller_P.Constant1_Value;

  /* SignalConversion: '<S133>/ConcatBufferAtVector ConcatenateIn7' incorporates:
   *  Constant: '<S6>/Constant2'
   */
  rtb_VectorConcatenate_p[6] = Controller_P.Constant2_Value;

  /* SignalConversion: '<S133>/ConcatBufferAtVector ConcatenateIn8' incorporates:
   *  Constant: '<S6>/Constant1'
   */
  rtb_VectorConcatenate_p[7] = Controller_P.Constant1_Value;

  /* SignalConversion: '<S133>/ConcatBufferAtVector ConcatenateIn9' incorporates:
   *  Inport: '<Root>/Ki_psi'
   */
  rtb_VectorConcatenate_p[8] = Controller_U.Ki_psi;

  /* SignalConversion: '<S132>/ConcatBufferAtVector ConcatenateIn1' incorporates:
   *  Inport: '<Root>/Kp_x'
   */
  rtb_VectorConcatenate_c[0] = Controller_U.Kp_x;

  /* SignalConversion: '<S132>/ConcatBufferAtVector ConcatenateIn2' incorporates:
   *  Constant: '<S5>/Constant2'
   */
  rtb_VectorConcatenate_c[1] = Controller_P.Constant2_Value_h;

  /* SignalConversion: '<S132>/ConcatBufferAtVector ConcatenateIn3' incorporates:
   *  Constant: '<S5>/Constant1'
   */
  rtb_VectorConcatenate_c[2] = Controller_P.Constant1_Value_c;

  /* SignalConversion: '<S132>/ConcatBufferAtVector ConcatenateIn4' incorporates:
   *  Constant: '<S5>/Constant2'
   */
  rtb_VectorConcatenate_c[3] = Controller_P.Constant2_Value_h;

  /* SignalConversion: '<S132>/ConcatBufferAtVector ConcatenateIn5' incorporates:
   *  Inport: '<Root>/Kp_y'
   */
  rtb_VectorConcatenate_c[4] = Controller_U.Kp_y;

  /* SignalConversion: '<S132>/ConcatBufferAtVector ConcatenateIn6' incorporates:
   *  Constant: '<S5>/Constant1'
   */
  rtb_VectorConcatenate_c[5] = Controller_P.Constant1_Value_c;

  /* SignalConversion: '<S132>/ConcatBufferAtVector ConcatenateIn7' incorporates:
   *  Constant: '<S5>/Constant2'
   */
  rtb_VectorConcatenate_c[6] = Controller_P.Constant2_Value_h;

  /* SignalConversion: '<S132>/ConcatBufferAtVector ConcatenateIn8' incorporates:
   *  Constant: '<S5>/Constant1'
   */
  rtb_VectorConcatenate_c[7] = Controller_P.Constant1_Value_c;

  /* SignalConversion: '<S132>/ConcatBufferAtVector ConcatenateIn9' incorporates:
   *  Inport: '<Root>/Kp_psi'
   */
  rtb_VectorConcatenate_c[8] = Controller_U.Kp_psi;

  /* SignalConversion: '<S15>/TmpSignal ConversionAtProduct1Inport2' incorporates:
   *  Fcn: '<S19>/Row1'
   *  Fcn: '<S19>/Row2'
   *  Fcn: '<S19>/Row3'
   */
  Controller_B.TmpSignalConversionAtProduct1In[0] = cos(rtb_TransferFcn2) *
    rtb_D[0] + sin(rtb_TransferFcn2) * rtb_D[1];
  Controller_B.TmpSignalConversionAtProduct1In[1] = -sin(rtb_TransferFcn2) *
    rtb_D[0] + cos(rtb_TransferFcn2) * rtb_D[1];
  Controller_B.TmpSignalConversionAtProduct1In[2] = rtb_D[2];

  /* SignalConversion: '<S134>/ConcatBufferAtVector ConcatenateIn1' incorporates:
   *  Inport: '<Root>/Kd_u'
   */
  rtb_VectorConcatenate_h[0] = Controller_U.Kd_u;

  /* SignalConversion: '<S134>/ConcatBufferAtVector ConcatenateIn2' incorporates:
   *  Constant: '<S7>/Constant2'
   */
  rtb_VectorConcatenate_h[1] = Controller_P.Constant2_Value_c;

  /* SignalConversion: '<S134>/ConcatBufferAtVector ConcatenateIn3' incorporates:
   *  Constant: '<S7>/Constant1'
   */
  rtb_VectorConcatenate_h[2] = Controller_P.Constant1_Value_g;

  /* SignalConversion: '<S134>/ConcatBufferAtVector ConcatenateIn4' incorporates:
   *  Constant: '<S7>/Constant2'
   */
  rtb_VectorConcatenate_h[3] = Controller_P.Constant2_Value_c;

  /* SignalConversion: '<S134>/ConcatBufferAtVector ConcatenateIn5' incorporates:
   *  Inport: '<Root>/Kd_v'
   */
  rtb_VectorConcatenate_h[4] = Controller_U.Kd_v;

  /* SignalConversion: '<S134>/ConcatBufferAtVector ConcatenateIn6' incorporates:
   *  Constant: '<S7>/Constant1'
   */
  rtb_VectorConcatenate_h[5] = Controller_P.Constant1_Value_g;

  /* SignalConversion: '<S134>/ConcatBufferAtVector ConcatenateIn7' incorporates:
   *  Constant: '<S7>/Constant2'
   */
  rtb_VectorConcatenate_h[6] = Controller_P.Constant2_Value_c;

  /* SignalConversion: '<S134>/ConcatBufferAtVector ConcatenateIn8' incorporates:
   *  Constant: '<S7>/Constant1'
   */
  rtb_VectorConcatenate_h[7] = Controller_P.Constant1_Value_g;

  /* SignalConversion: '<S134>/ConcatBufferAtVector ConcatenateIn9' incorporates:
   *  Inport: '<Root>/Kd_r'
   */
  rtb_VectorConcatenate_h[8] = Controller_U.Kd_r;

  /* Sum: '<S15>/Sum4' incorporates:
   *  Constant: '<S15>/Constant4'
   *  Product: '<S15>/Product2'
   */
  rtb_Normalization_idx_0 = Controller_P.Constant4_Value[0] - rtb_Sum_be[0];
  rtb_Normalization_idx = Controller_P.Constant4_Value[1] - rtb_Sum_be[1];
  omega_idx = Controller_P.Constant4_Value[2] - Controller_B.Integrator[2];

  /* Product: '<S15>/Product2' */
  for (k = 0; k < 3; k++) {
    rtb_D[k] = rtb_VectorConcatenate_h[k + 6] * omega_idx +
      (rtb_VectorConcatenate_h[k + 3] * rtb_Normalization_idx +
       rtb_VectorConcatenate_h[k] * rtb_Normalization_idx_0);
  }

  /* Integrator: '<S33>/Integrator1' */
  rtb_Integrator1_i = Controller_X.Integrator1_CSTATE_f;

  /* Sum: '<S38>/Sum2' incorporates:
   *  Constant: '<S38>/rho'
   *  Integrator: '<S33>/Integrator1'
   *  Product: '<S38>/Product'
   *  Trigonometry: '<S38>/Trigonometric Function'
   */
  rtb_Sum2_i = cos(Controller_X.Integrator1_CSTATE_f) * Controller_P.rho_Value +
    rtb_Sum_be[0];

  /* Sum: '<S36>/Sum' */
  rtb_Sum_k = rtb_Sum2_a_idx_1 - rtb_Sum2_i;

  /* Sum: '<S38>/Sum3' incorporates:
   *  Constant: '<S38>/rho'
   *  Integrator: '<S33>/Integrator1'
   *  Product: '<S38>/Product1'
   *  Trigonometry: '<S38>/Trigonometric Function1'
   */
  rtb_Sum3_g = Controller_P.rho_Value * sin(Controller_X.Integrator1_CSTATE_f) +
    rtb_Sum_be[1];

  /* Sum: '<S36>/Sum2' */
  rtb_TransferFcn2_h = rtb_Sum2_a_idx_0 - rtb_Sum3_g;

  /* Sum: '<S36>/Sum3' incorporates:
   *  Math: '<S36>/Math Function1'
   *  Math: '<S36>/Math Function2'
   */
  rtb_TransferFcn1_o = rtb_Sum_k * rtb_Sum_k + rtb_TransferFcn2_h *
    rtb_TransferFcn2_h;

  /* Sqrt: '<S36>/Sqrt' */
  rtb_TransferFcn1_o = sqrt(rtb_TransferFcn1_o);

  /* Product: '<S41>/Product' incorporates:
   *  Constant: '<S41>/rho'
   *  Trigonometry: '<S41>/Trigonometric Function'
   */
  rtb_Gain5_g = cos(rtb_TransferFcn2) * Controller_P.rho_Value_o;

  /* Sum: '<S35>/Sum4' */
  rtb_Normalization_idx_0 = rtb_Sum2_i - rtb_Sum2_a_idx_1;
  rtb_Normalization_idx = rtb_Sum3_g - rtb_Sum2_a_idx_0;

  /* S-Function (sdsp2norm2): '<S35>/Normalization' */
  rtb_Divide = rtb_Normalization_idx_0 * rtb_Normalization_idx_0 +
    rtb_Normalization_idx * rtb_Normalization_idx;
  rtb_Divide = 1.0 / (sqrt(rtb_Divide) + Controller_P.Normalization_BIAS);
  rtb_Normalization_idx_0 *= rtb_Divide;
  rtb_Normalization_idx *= rtb_Divide;

  /* DotProduct: '<S35>/Dot Product' incorporates:
   *  Constant: '<S41>/rho'
   *  Product: '<S41>/Product1'
   *  SignalConversion: '<S35>/TmpSignal ConversionAtDot ProductInport1'
   *  Trigonometry: '<S41>/Trigonometric Function1'
   */
  omega_idx = Controller_P.rho_Value_o * sin(rtb_TransferFcn2) *
    rtb_Normalization_idx + rtb_Gain5_g * rtb_Normalization_idx_0;

  /* Integrator: '<S33>/Integrator' */
  Controller_B.Integrator_n = Controller_X.Integrator_CSTATE_c;

  /* Product: '<S40>/Divide' incorporates:
   *  Constant: '<S37>/rho1'
   *  Gain: '<S37>/Gain1'
   *  Inport: '<Root>/eta_d_x'
   *  Integrator: '<S33>/Integrator1'
   *  Product: '<S37>/Product2'
   *  Product: '<S37>/Product3'
   *  Product: '<S40>/Product1'
   *  Product: '<S40>/Product2'
   *  Sum: '<S40>/Sum'
   *  Sum: '<S40>/Sum1'
   *  Sum: '<S40>/Sum2'
   *  Sum: '<S40>/Sum3'
   *  Sum: '<S40>/Sum4'
   *  Trigonometry: '<S37>/Trigonometric Function2'
   *  Trigonometry: '<S37>/Trigonometric Function3'
   */
  rtb_Divide = ((Controller_U.eta_d_x - Controller_P.Gain1_Gain_jx *
                 Controller_B.Integrator_n * sin
                 (Controller_X.Integrator1_CSTATE_f) * Controller_P.rho1_Value) *
                (rtb_Sum2_a_idx_1 - rtb_Sum2_i) + (rtb_Gain_ia -
    Controller_P.rho1_Value * cos(Controller_X.Integrator1_CSTATE_f) *
    Controller_B.Integrator_n) * (rtb_Sum2_a_idx_0 - rtb_Sum3_g)) /
    rtb_TransferFcn1_o;

  /* Gain: '<S32>/Gain' */
  rtb_Gain_ia *= Controller_P.Gain_Gain_k;

  /* Sum: '<S34>/Sum3' incorporates:
   *  Constant: '<S34>/Constant'
   *  Gain: '<S34>/Gain'
   *  Gain: '<S34>/Gain1'
   *  Gain: '<S34>/Gain2'
   *  Gain: '<S34>/Gain3'
   *  Sum: '<S34>/Sum'
   *  Sum: '<S34>/Sum1'
   *  Sum: '<S34>/Sum2'
   *  Sum: '<S34>/Sum4'
   *  Trigonometry: '<S34>/Trigonometric Function'
   */
  rtb_Gain5_g = (rt_atan2d_snf((rtb_Sum2_a_idx_0 - rtb_Sum3_g) *
    Controller_P.Gain3_Gain, (rtb_Sum2_a_idx_1 - rtb_Sum2_i) *
    Controller_P.Gain2_Gain_l) - rtb_TransferFcn2) * Controller_P.Gain_Gain_i +
    (Controller_P.Constant_Value - rtb_Gain1_f) * Controller_P.Gain1_Gain_p;

  /* Gain: '<S17>/Gain2' incorporates:
   *  Inport: '<Root>/AFF_on'
   *  Product: '<S17>/Product3'
   *  Sum: '<S17>/Sum2'
   */
  for (k = 0; k < 3; k++) {
    tmp_2[k] = Controller_P.Gain2_Gain_d[k + 6] * (Controller_B.Gain[2] *
      Controller_U.AFF_on) + (Controller_P.Gain2_Gain_d[k + 3] *
      (Controller_B.Gain[1] * Controller_U.AFF_on) + Controller_B.Gain[0] *
      Controller_U.AFF_on * Controller_P.Gain2_Gain_d[k]);
  }

  /* End of Gain: '<S17>/Gain2' */

  /* Step: '<S11>/Step' */
  if (Controller_M->Timing.t[0] < Controller_P.Step_Time_l) {
    rtb_Step = Controller_P.Step_Y0_k;
  } else {
    rtb_Step = Controller_P.Step_YFinal_j;
  }

  /* End of Step: '<S11>/Step' */

  /* Product: '<S15>/Product' incorporates:
   *  Integrator: '<S15>/Integrator'
   *  Product: '<S18>/Product4'
   */
  for (k = 0; k < 3; k++) {
    rtb_VectorConcatenate_p_0[k] = rtb_VectorConcatenate_p[k + 6] *
      Controller_X.Integrator_CSTATE_p[2] + (rtb_VectorConcatenate_p[k + 3] *
      Controller_X.Integrator_CSTATE_p[1] + rtb_VectorConcatenate_p[k] *
      Controller_X.Integrator_CSTATE_p[0]);
  }

  /* End of Product: '<S15>/Product' */

  /* Sum: '<S15>/Sum1' incorporates:
   *  Constant: '<S18>/Constant1'
   *  Gain: '<S11>/Gain'
   *  Gain: '<S18>/Gain'
   *  Inport: '<Root>/AFF_on'
   *  Inport: '<Root>/Ki_on'
   *  Product: '<S15>/Product1'
   *  Product: '<S18>/Product3'
   *  Product: '<S18>/Product4'
   *  Sum: '<S18>/Sum2'
   */
  for (k = 0; k < 3; k++) {
    rtb_VectorConcatenate_p_1[k] = (((rtb_VectorConcatenate_c[k + 3] *
      Controller_B.TmpSignalConversionAtProduct1In[1] +
      rtb_VectorConcatenate_c[k] * Controller_B.TmpSignalConversionAtProduct1In
      [0]) + rtb_VectorConcatenate_c[k + 6] *
      Controller_B.TmpSignalConversionAtProduct1In[2]) +
      ((rtb_VectorConcatenate_p_0[k] * Controller_U.Ki_on +
        Controller_P.Constant1_Value_e[k]) + Controller_P.Gain_Gain_b *
       Controller_B.Gain[k] * Controller_U.AFF_on)) + rtb_D[k];
  }

  /* End of Sum: '<S15>/Sum1' */

  /* Product: '<S11>/Product3' incorporates:
   *  Constant: '<S35>/rho'
   *  Constant: '<S35>/rho1'
   *  DotProduct: '<S35>/Dot Product'
   *  Gain: '<S11>/Gain'
   *  Gain: '<S11>/Gain1'
   *  Gain: '<S11>/Gain2'
   *  Gain: '<S35>/Kd'
   *  Gain: '<S35>/Kp'
   *  Product: '<S35>/Product'
   *  Sum: '<S11>/Sum'
   *  Sum: '<S17>/Sum2'
   *  Sum: '<S35>/Sum1'
   *  Sum: '<S35>/Sum2'
   *  Sum: '<S35>/Sum3'
   */
  Controller_B.Product3[0] = ((((Controller_P.rho_Value_c - rtb_TransferFcn1_o) *
    omega_idx * Controller_P.Kp_Gain + (Controller_P.rho1_Value_e - rtb_Divide) *
    Controller_P.Kd_Gain) + tmp_2[0]) * Controller_P.Gain1_Gain_k +
    (Controller_P.Gain2_Gain * rtb_Z_m[0] + Controller_P.Gain_Gain_c *
     rtb_VectorConcatenate_p_1[0])) * rtb_Step;
  Controller_B.Product3[1] = ((Controller_P.Gain2_Gain * rtb_Z_m[1] +
    Controller_P.Gain_Gain_c * rtb_VectorConcatenate_p_1[1]) + (rtb_Gain_ia +
    tmp_2[1]) * Controller_P.Gain1_Gain_k) * rtb_Step;
  Controller_B.Product3[2] = ((Controller_P.Gain2_Gain * rtb_Z_m[2] +
    Controller_P.Gain_Gain_c * rtb_VectorConcatenate_p_1[2]) + (rtb_Gain5_g +
    tmp_2[2]) * Controller_P.Gain1_Gain_k) * rtb_Step;

  /* MATLAB Function: '<S14>/MATLAB Function' */
  Controller_MATLABFunction();

  /* Gain: '<S14>/Gain' */
  for (k = 0; k < 3; k++) {
    rtb_Gain_pk[k] = 0.0;
    for (i = 0; i < 12; i++) {
      rtb_Gain_pk[k] += Controller_P.Gain_Gain_l[3 * i + k] * Controller_B.u[i];
    }
  }

  /* End of Gain: '<S14>/Gain' */

  /* Outport: '<Root>/X_com' */
  Controller_Y.X_com = rtb_Gain_pk[0];

  /* Outport: '<Root>/Y_com' */
  Controller_Y.Y_com = rtb_Gain_pk[1];

  /* Outport: '<Root>/N_com' */
  Controller_Y.N_com = rtb_Gain_pk[2];

  /* SignalConversion: '<S47>/TmpSignal ConversionAtsincosInport1' incorporates:
   *  Inport: '<Root>/pitch'
   *  Inport: '<Root>/roll'
   *  Inport: '<Root>/yaw'
   */
  rtb_k_m_r[0] = Controller_U.yaw;
  rtb_k_m_r[1] = Controller_U.pitch;
  rtb_k_m_r[2] = Controller_U.roll;

  /* Trigonometry: '<S136>/sincos' incorporates:
   *  Inport: '<Root>/pitch'
   *  Inport: '<Root>/roll'
   *  Inport: '<Root>/yaw'
   *  SignalConversion: '<S47>/TmpSignal ConversionAtsincosInport1'
   */
  rtb_D[0] = sin(Controller_U.yaw);
  rtb_Gain1_l_idx_1 = cos(Controller_U.yaw);
  rtb_D[1] = sin(Controller_U.pitch);
  rtb_Gain1_l_idx_0 = cos(Controller_U.pitch);
  rtb_D[2] = sin(Controller_U.roll);
  rtb_Gain1_l_idx = cos(Controller_U.roll);

  /* Fcn: '<S136>/Fcn11' */
  rtb_VectorConcatenate_n[0] = rtb_Gain1_l_idx_0 * rtb_Gain1_l_idx_1;

  /* Fcn: '<S136>/Fcn21' */
  rtb_VectorConcatenate_n[1] = rtb_D[2] * rtb_D[1] * rtb_Gain1_l_idx_1 -
    rtb_Gain1_l_idx * rtb_D[0];

  /* Fcn: '<S136>/Fcn31' */
  rtb_VectorConcatenate_n[2] = rtb_Gain1_l_idx * rtb_D[1] * rtb_Gain1_l_idx_1 +
    rtb_D[2] * rtb_D[0];

  /* Fcn: '<S136>/Fcn12' */
  rtb_VectorConcatenate_n[3] = rtb_Gain1_l_idx_0 * rtb_D[0];

  /* Fcn: '<S136>/Fcn22' */
  rtb_VectorConcatenate_n[4] = rtb_D[2] * rtb_D[1] * rtb_D[0] + rtb_Gain1_l_idx *
    rtb_Gain1_l_idx_1;

  /* Fcn: '<S136>/Fcn32' */
  rtb_VectorConcatenate_n[5] = rtb_Gain1_l_idx * rtb_D[1] * rtb_D[0] - rtb_D[2] *
    rtb_Gain1_l_idx_1;

  /* Fcn: '<S136>/Fcn13' */
  rtb_VectorConcatenate_n[6] = -rtb_D[1];

  /* Fcn: '<S136>/Fcn23' */
  rtb_VectorConcatenate_n[7] = rtb_D[2] * rtb_Gain1_l_idx_0;

  /* Fcn: '<S136>/Fcn33' */
  rtb_VectorConcatenate_n[8] = rtb_Gain1_l_idx * rtb_Gain1_l_idx_0;

  /* Step: '<S4>/Step' */
  if (Controller_M->Timing.t[0] < Controller_P.Step_Time_j) {
    rtb_Normalization_idx = Controller_P.Step_Y0_g;
  } else {
    rtb_Normalization_idx = Controller_P.Step_YFinal_g;
  }

  /* End of Step: '<S4>/Step' */

  /* SignalConversion: '<S10>/TmpSignal ConversionAtProductInport2' incorporates:
   *  Inport: '<Root>/u'
   *  Inport: '<Root>/v_r'
   *  Product: '<S4>/Product'
   *  Sum: '<S4>/Sum'
   */
  rtb_Gain1_l_idx_1 = Controller_U.v_r * rtb_Normalization_idx + Controller_U.u;

  /* Product: '<S10>/Product' incorporates:
   *  Inport: '<Root>/v'
   *  Inport: '<Root>/w'
   *  SignalConversion: '<S10>/TmpSignal ConversionAtProductInport2'
   */
  for (k = 0; k < 3; k++) {
    rtb_D[k] = rtb_VectorConcatenate_n[k + 6] * Controller_U.w +
      (rtb_VectorConcatenate_n[k + 3] * Controller_U.v +
       rtb_VectorConcatenate_n[k] * rtb_Gain1_l_idx_1);
  }

  /* End of Product: '<S10>/Product' */

  /* Outport: '<Root>/nu_sim_u' */
  Controller_Y.nu_sim_u = rtb_D[0];

  /* Outport: '<Root>/nu_sim_v' */
  Controller_Y.nu_sim_v = rtb_D[1];

  /* Trigonometry: '<S137>/sincos' incorporates:
   *  Inport: '<Root>/pitch'
   *  Inport: '<Root>/roll'
   *  Inport: '<Root>/yaw'
   *  SignalConversion: '<S47>/TmpSignal ConversionAtsincosInport1'
   */
  rtb_Gain1_l_idx_1 = sin(Controller_U.yaw);
  rtb_D[0] = cos(Controller_U.yaw);
  rtb_Gain1_l_idx_0 = sin(Controller_U.pitch);
  rtb_D[1] = cos(Controller_U.pitch);
  rtb_Gain1_l_idx = sin(Controller_U.roll);
  rtb_D[2] = cos(Controller_U.roll);

  /* Fcn: '<S137>/Fcn11' */
  rtb_VectorConcatenate_ck[0] = rtb_D[1] * rtb_D[0];

  /* Fcn: '<S137>/Fcn21' */
  rtb_VectorConcatenate_ck[1] = rtb_Gain1_l_idx * rtb_Gain1_l_idx_0 * rtb_D[0] -
    rtb_D[2] * rtb_Gain1_l_idx_1;

  /* Fcn: '<S137>/Fcn31' */
  rtb_VectorConcatenate_ck[2] = rtb_D[2] * rtb_Gain1_l_idx_0 * rtb_D[0] +
    rtb_Gain1_l_idx * rtb_Gain1_l_idx_1;

  /* Fcn: '<S137>/Fcn12' */
  rtb_VectorConcatenate_ck[3] = rtb_D[1] * rtb_Gain1_l_idx_1;

  /* Fcn: '<S137>/Fcn22' */
  rtb_VectorConcatenate_ck[4] = rtb_Gain1_l_idx * rtb_Gain1_l_idx_0 *
    rtb_Gain1_l_idx_1 + rtb_D[2] * rtb_D[0];

  /* Fcn: '<S137>/Fcn32' */
  rtb_VectorConcatenate_ck[5] = rtb_D[2] * rtb_Gain1_l_idx_0 * rtb_Gain1_l_idx_1
    - rtb_Gain1_l_idx * rtb_D[0];

  /* Fcn: '<S137>/Fcn13' */
  rtb_VectorConcatenate_ck[6] = -rtb_Gain1_l_idx_0;

  /* Fcn: '<S137>/Fcn23' */
  rtb_VectorConcatenate_ck[7] = rtb_Gain1_l_idx * rtb_D[1];

  /* Fcn: '<S137>/Fcn33' */
  rtb_VectorConcatenate_ck[8] = rtb_D[2] * rtb_D[1];

  /* SignalConversion: '<S46>/TmpSignal ConversionAtProduct2Inport2' incorporates:
   *  Inport: '<Root>/p'
   *  Inport: '<Root>/q'
   *  Inport: '<Root>/r'
   */
  rtb_Gain1_l_idx_1 = Controller_U.p;
  rtb_Gain1_l_idx_0 = Controller_U.q;
  rtb_Gain1_l_idx = Controller_U.r;

  /* Product: '<S10>/Product1' incorporates:
   *  Inport: '<Root>/p'
   *  Inport: '<Root>/q'
   *  Inport: '<Root>/r'
   *  SignalConversion: '<S46>/TmpSignal ConversionAtProduct2Inport2'
   */
  for (k = 0; k < 3; k++) {
    rtb_D[k] = rtb_VectorConcatenate_ck[k + 6] * Controller_U.r +
      (rtb_VectorConcatenate_ck[k + 3] * Controller_U.q +
       rtb_VectorConcatenate_ck[k] * Controller_U.p);
  }

  /* End of Product: '<S10>/Product1' */

  /* Outport: '<Root>/nu_sim_r' */
  Controller_Y.nu_sim_r = rtb_D[2];

  /* Sum: '<S3>/Sum' incorporates:
   *  Constant: '<S3>/Constant'
   *  Inport: '<Root>/N'
   *  Integrator: '<S3>/Integrator'
   *  Sum: '<S3>/Sum1'
   */
  rtb_Step = (Controller_X.Integrator_CSTATE_j - Controller_P.Constant_Value_g)
    + Controller_U.N;

  /* Outport: '<Root>/eta_sim_N' */
  Controller_Y.eta_sim_N = rtb_Step;

  /* Outport: '<Root>/eta_sim_E' incorporates:
   *  Inport: '<Root>/E'
   */
  Controller_Y.eta_sim_E = Controller_U.E;

  /* Outport: '<Root>/eta_sim_psi' incorporates:
   *  Inport: '<Root>/yaw'
   */
  Controller_Y.eta_sim_psi = Controller_U.yaw;

  /* Trigonometry: '<S128>/sincos' incorporates:
   *  Inport: '<Root>/pitch'
   *  Inport: '<Root>/roll'
   *  Inport: '<Root>/yaw'
   *  SignalConversion: '<S47>/TmpSignal ConversionAtsincosInport1'
   */
  rtb_D[0] = sin(Controller_U.yaw);
  rtb_Sum1_pd_idx = cos(Controller_U.yaw);
  rtb_D[1] = sin(Controller_U.pitch);
  rtb_Gain1_f = cos(Controller_U.pitch);
  rtb_D[2] = sin(Controller_U.roll);
  rtb_Gain_ia = cos(Controller_U.roll);

  /* Fcn: '<S128>/Fcn11' */
  rtb_VectorConcatenate_k[0] = rtb_Gain1_f * rtb_Sum1_pd_idx;

  /* Fcn: '<S128>/Fcn21' */
  rtb_VectorConcatenate_k[1] = rtb_D[2] * rtb_D[1] * rtb_Sum1_pd_idx -
    rtb_Gain_ia * rtb_D[0];

  /* Fcn: '<S128>/Fcn31' */
  rtb_VectorConcatenate_k[2] = rtb_Gain_ia * rtb_D[1] * rtb_Sum1_pd_idx + rtb_D
    [2] * rtb_D[0];

  /* Fcn: '<S128>/Fcn12' */
  rtb_VectorConcatenate_k[3] = rtb_Gain1_f * rtb_D[0];

  /* Fcn: '<S128>/Fcn22' */
  rtb_VectorConcatenate_k[4] = rtb_D[2] * rtb_D[1] * rtb_D[0] + rtb_Gain_ia *
    rtb_Sum1_pd_idx;

  /* Fcn: '<S128>/Fcn32' */
  rtb_VectorConcatenate_k[5] = rtb_Gain_ia * rtb_D[1] * rtb_D[0] - rtb_D[2] *
    rtb_Sum1_pd_idx;

  /* Fcn: '<S128>/Fcn13' */
  rtb_VectorConcatenate_k[6] = -rtb_D[1];

  /* Fcn: '<S128>/Fcn23' */
  rtb_VectorConcatenate_k[7] = rtb_D[2] * rtb_Gain1_f;

  /* Fcn: '<S128>/Fcn33' */
  rtb_VectorConcatenate_k[8] = rtb_Gain_ia * rtb_Gain1_f;

  /* Sum: '<S2>/Sum1' incorporates:
   *  Constant: '<S2>/Gravity'
   *  Inport: '<Root>/w_d'
   */
  rtb_Gain5_g = Controller_U.w_d + Controller_P.Gravity_Value;

  /* Product: '<S2>/Product' incorporates:
   *  Inport: '<Root>/u_d'
   *  Inport: '<Root>/v_d'
   *  SignalConversion: '<S2>/TmpSignal ConversionAtProductInport2'
   */
  for (k = 0; k < 3; k++) {
    rtb_D[k] = rtb_VectorConcatenate_k[k + 6] * rtb_Gain5_g +
      (rtb_VectorConcatenate_k[k + 3] * Controller_U.v_d +
       rtb_VectorConcatenate_k[k] * Controller_U.u_d);
  }

  /* End of Product: '<S2>/Product' */

  /* Outport: '<Root>/nu_d_sim_u' */
  Controller_Y.nu_d_sim_u = rtb_D[0];

  /* Outport: '<Root>/nu_d_sim_v' */
  Controller_Y.nu_d_sim_v = rtb_D[1];

  /* Trigonometry: '<S129>/sincos' incorporates:
   *  Inport: '<Root>/pitch'
   *  Inport: '<Root>/roll'
   *  Inport: '<Root>/yaw'
   *  SignalConversion: '<S47>/TmpSignal ConversionAtsincosInport1'
   */
  rtb_Sum1_pd_idx = sin(Controller_U.yaw);
  rtb_D[0] = cos(Controller_U.yaw);
  rtb_Gain1_f = sin(Controller_U.pitch);
  rtb_D[1] = cos(Controller_U.pitch);
  rtb_Gain_ia = sin(Controller_U.roll);
  rtb_D[2] = cos(Controller_U.roll);

  /* Fcn: '<S129>/Fcn11' */
  rtb_VectorConcatenate_nu[0] = rtb_D[1] * rtb_D[0];

  /* Fcn: '<S129>/Fcn21' */
  rtb_VectorConcatenate_nu[1] = rtb_Gain_ia * rtb_Gain1_f * rtb_D[0] - rtb_D[2] *
    rtb_Sum1_pd_idx;

  /* Fcn: '<S129>/Fcn31' */
  rtb_VectorConcatenate_nu[2] = rtb_D[2] * rtb_Gain1_f * rtb_D[0] + rtb_Gain_ia *
    rtb_Sum1_pd_idx;

  /* Fcn: '<S129>/Fcn12' */
  rtb_VectorConcatenate_nu[3] = rtb_D[1] * rtb_Sum1_pd_idx;

  /* Fcn: '<S129>/Fcn22' */
  rtb_VectorConcatenate_nu[4] = rtb_Gain_ia * rtb_Gain1_f * rtb_Sum1_pd_idx +
    rtb_D[2] * rtb_D[0];

  /* Fcn: '<S129>/Fcn32' */
  rtb_VectorConcatenate_nu[5] = rtb_D[2] * rtb_Gain1_f * rtb_Sum1_pd_idx -
    rtb_Gain_ia * rtb_D[0];

  /* Fcn: '<S129>/Fcn13' */
  rtb_VectorConcatenate_nu[6] = -rtb_Gain1_f;

  /* Fcn: '<S129>/Fcn23' */
  rtb_VectorConcatenate_nu[7] = rtb_Gain_ia * rtb_D[1];

  /* Fcn: '<S129>/Fcn33' */
  rtb_VectorConcatenate_nu[8] = rtb_D[2] * rtb_D[1];

  /* SignalConversion: '<S43>/TmpSignal ConversionAtProduct1Inport2' incorporates:
   *  Inport: '<Root>/p_d'
   *  Inport: '<Root>/q_d'
   *  Inport: '<Root>/r_d'
   */
  rtb_Sum1_pd_idx = Controller_U.p_d;
  rtb_Gain1_f = Controller_U.q_d;
  rtb_Gain_ia = Controller_U.r_d;

  /* Product: '<S2>/Product1' incorporates:
   *  Inport: '<Root>/p_d'
   *  Inport: '<Root>/q_d'
   *  Inport: '<Root>/r_d'
   *  Outport: '<Root>/nu_d_sim_r'
   *  SignalConversion: '<S43>/TmpSignal ConversionAtProduct1Inport2'
   */
  for (k = 0; k < 3; k++) {
    rtb_VectorConcatenate_p_0[k] = rtb_VectorConcatenate_nu[k + 6] *
      Controller_U.r_d + (rtb_VectorConcatenate_nu[k + 3] * Controller_U.q_d +
                          rtb_VectorConcatenate_nu[k] * Controller_U.p_d);
  }

  /* End of Product: '<S2>/Product1' */

  /* Outport: '<Root>/nu_d_sim_r' */
  Controller_Y.nu_d_sim_r = rtb_VectorConcatenate_p_0[2];

  /* Integrator: '<S84>/Integrator1' */
  Controller_B.Integrator1[0] = Controller_X.Integrator1_CSTATE_k[0];
  Controller_B.Integrator1[1] = Controller_X.Integrator1_CSTATE_k[1];
  Controller_B.Integrator1[2] = Controller_X.Integrator1_CSTATE_k[2];

  /* Integrator: '<S84>/Integrator' */
  Controller_B.Integrator_o[0] = Controller_X.Integrator_CSTATE_px[0];
  Controller_B.Integrator_o[1] = Controller_X.Integrator_CSTATE_px[1];
  Controller_B.Integrator_o[2] = Controller_X.Integrator_CSTATE_px[2];

  /* Gain: '<S84>/D' */
  for (k = 0; k < 3; k++) {
    rtb_D[k] = Controller_P.D_Gain[k + 6] * Controller_B.Integrator_o[2] +
      (Controller_P.D_Gain[k + 3] * Controller_B.Integrator_o[1] +
       Controller_P.D_Gain[k] * Controller_B.Integrator_o[0]);
  }

  /* End of Gain: '<S84>/D' */

  /* Gain: '<S13>/Gain' incorporates:
   *  Inport: '<Root>/E'
   */
  rtb_Integrator6[0] = Controller_P.Gain_Gain_f * rtb_Step;
  rtb_Integrator6[1] = Controller_P.Gain_Gain_f * Controller_U.E;
  rtb_Integrator6[3] = Controller_P.Gain_Gain_f * rtb_TransferFcn;
  rtb_Integrator6[4] = Controller_P.Gain_Gain_f * rtb_TransferFcn1;
  rtb_Integrator6[5] = Controller_P.Gain_Gain_f * rtb_TransferFcn2;

  /* SignalConversion: '<S120>/TmpSignal ConversionAtsincosInport1' incorporates:
   *  Gain: '<S13>/Gain'
   */
  rtb_sincos_o1_e_idx = Controller_P.Gain_Gain_f * rtb_TransferFcn1;

  /* Trigonometry: '<S123>/sincos' incorporates:
   *  SignalConversion: '<S120>/TmpSignal ConversionAtsincosInport1'
   */
  rtb_sincos_o2[0] = sin(rtb_Integrator6[5]);
  rtb_Integrator2_n_idx_1 = cos(rtb_Integrator6[5]);
  rtb_sincos_o2[1] = sin(rtb_Integrator6[4]);
  rtb_Integrator2_n_idx_0 = cos(rtb_Integrator6[4]);
  rtb_sincos_o2[2] = sin(rtb_Integrator6[3]);
  rtb_Integrator2_n_idx = cos(rtb_Integrator6[3]);

  /* Fcn: '<S123>/Fcn11' */
  rtb_VectorConcatenate_kf[0] = rtb_Integrator2_n_idx_0 *
    rtb_Integrator2_n_idx_1;

  /* Fcn: '<S123>/Fcn21' */
  rtb_VectorConcatenate_kf[1] = rtb_sincos_o2[2] * rtb_sincos_o2[1] *
    rtb_Integrator2_n_idx_1 - rtb_Integrator2_n_idx * rtb_sincos_o2[0];

  /* Fcn: '<S123>/Fcn31' */
  rtb_VectorConcatenate_kf[2] = rtb_Integrator2_n_idx * rtb_sincos_o2[1] *
    rtb_Integrator2_n_idx_1 + rtb_sincos_o2[2] * rtb_sincos_o2[0];

  /* Fcn: '<S123>/Fcn12' */
  rtb_VectorConcatenate_kf[3] = rtb_Integrator2_n_idx_0 * rtb_sincos_o2[0];

  /* Fcn: '<S123>/Fcn22' */
  rtb_VectorConcatenate_kf[4] = rtb_sincos_o2[2] * rtb_sincos_o2[1] *
    rtb_sincos_o2[0] + rtb_Integrator2_n_idx * rtb_Integrator2_n_idx_1;

  /* Fcn: '<S123>/Fcn32' */
  rtb_VectorConcatenate_kf[5] = rtb_Integrator2_n_idx * rtb_sincos_o2[1] *
    rtb_sincos_o2[0] - rtb_sincos_o2[2] * rtb_Integrator2_n_idx_1;

  /* Fcn: '<S123>/Fcn13' */
  rtb_VectorConcatenate_kf[6] = -rtb_sincos_o2[1];

  /* Fcn: '<S123>/Fcn23' */
  rtb_VectorConcatenate_kf[7] = rtb_sincos_o2[2] * rtb_Integrator2_n_idx_0;

  /* Fcn: '<S123>/Fcn33' */
  rtb_VectorConcatenate_kf[8] = rtb_Integrator2_n_idx * rtb_Integrator2_n_idx_0;

  /* Integrator: '<S119>/Integrator2' */
  rtb_Integrator2_n_idx_1 = Controller_X.Integrator2_CSTATE_i[0];
  rtb_Integrator2_n_idx_0 = Controller_X.Integrator2_CSTATE_i[1];
  rtb_Integrator2_n_idx = Controller_X.Integrator2_CSTATE_i[2];

  /* Product: '<S117>/Product' incorporates:
   *  Gain: '<S84>/Gain4'
   *  Integrator: '<S119>/Integrator2'
   */
  for (k = 0; k < 3; k++) {
    rtb_VectorConcatenate_p_0[k] = rtb_VectorConcatenate_kf[k + 6] *
      Controller_X.Integrator2_CSTATE_i[2] + (rtb_VectorConcatenate_kf[k + 3] *
      Controller_X.Integrator2_CSTATE_i[1] + rtb_VectorConcatenate_kf[k] *
      Controller_X.Integrator2_CSTATE_i[0]);
  }

  /* End of Product: '<S117>/Product' */

  /* Gain: '<S84>/Gain4' */
  for (k = 0; k < 3; k++) {
    Controller_B.Gain4[k] = 0.0;
    Controller_B.Gain4[k] += Controller_P.Gain4_Gain[k] *
      rtb_VectorConcatenate_p_0[0];
    Controller_B.Gain4[k] += Controller_P.Gain4_Gain[k + 3] *
      rtb_VectorConcatenate_p_0[1];
    Controller_B.Gain4[k] += Controller_P.Gain4_Gain[k + 6] *
      rtb_VectorConcatenate_p_0[2];
  }

  /* Gain: '<S13>/Gain7' incorporates:
   *  Constant: '<S85>/Constant'
   *  Sum: '<S84>/Sum4'
   */
  Controller_B.Gain7[0] = Controller_P.Gain7_Gain * Controller_B.Integrator1[0];
  Controller_B.Gain7[1] = Controller_P.Gain7_Gain * Controller_B.Integrator1[1];
  Controller_B.Gain7[2] = Controller_P.Gain7_Gain *
    Controller_P.Constant_Value_m;
  Controller_B.Gain7[3] = Controller_P.Gain7_Gain *
    Controller_P.Constant_Value_m;
  Controller_B.Gain7[4] = Controller_P.Gain7_Gain *
    Controller_P.Constant_Value_m;
  Controller_B.Gain7[5] = Controller_P.Gain7_Gain * Controller_B.Integrator1[2];
  Controller_B.Gain7[6] = Controller_P.Gain7_Gain * Controller_B.Integrator_o[0];
  Controller_B.Gain7[7] = Controller_P.Gain7_Gain * Controller_B.Integrator_o[1];
  Controller_B.Gain7[8] = Controller_P.Gain7_Gain *
    Controller_P.Constant_Value_m;
  Controller_B.Gain7[9] = Controller_P.Gain7_Gain *
    Controller_P.Constant_Value_m;
  Controller_B.Gain7[10] = Controller_P.Gain7_Gain *
    Controller_P.Constant_Value_m;
  Controller_B.Gain7[11] = Controller_P.Gain7_Gain * Controller_B.Integrator_o[2];
  Controller_B.Gain7[12] = (Controller_B.Gain4[0] - rtb_D[0]) *
    Controller_P.Gain7_Gain;
  Controller_B.Gain7[13] = (Controller_B.Gain4[1] - rtb_D[1]) *
    Controller_P.Gain7_Gain;
  Controller_B.Gain7[14] = (Controller_B.Gain4[2] - rtb_D[2]) *
    Controller_P.Gain7_Gain;

  /* Outport: '<Root>/eta_e_N_NL' */
  Controller_Y.eta_e_N_NL = Controller_B.Gain7[0];

  /* Outport: '<Root>/eta_e_E_NL' */
  Controller_Y.eta_e_E_NL = Controller_B.Gain7[1];

  /* Outport: '<Root>/eta_e_psi_NL' */
  Controller_Y.eta_e_psi_NL = Controller_B.Gain7[5];

  /* Outport: '<Root>/nu_e_u_NL' */
  Controller_Y.nu_e_u_NL = Controller_B.Gain7[6];

  /* Outport: '<Root>/nu_e_v_NL' */
  Controller_Y.nu_e_v_NL = Controller_B.Gain7[7];

  /* Outport: '<Root>/nu_e_r_NL' */
  Controller_Y.nu_e_r_NL = Controller_B.Gain7[11];

  /* Outport: '<Root>/d_e_x_NL' */
  Controller_Y.d_e_x_NL = Controller_B.Gain7[12];

  /* Outport: '<Root>/d_e_y_NL' */
  Controller_Y.d_e_y_NL = Controller_B.Gain7[13];

  /* Outport: '<Root>/d_e_psi_NL' */
  Controller_Y.d_e_psi_NL = Controller_B.Gain7[14];

  /* TransportDelay: '<S93>/Transport Delay' */
  {
    real_T **uBuffer = (real_T**)
      &Controller_DWork.TransportDelay_PWORK.TUbufferPtrs[0];
    real_T **tBuffer = (real_T**)
      &Controller_DWork.TransportDelay_PWORK.TUbufferPtrs[3];
    real_T simTime = Controller_M->Timing.t[0];
    real_T tMinusDelay ;

    {
      int_T i1;
      real_T *y0 = Controller_B.TransportDelay;
      int_T *iw_Tail = &Controller_DWork.TransportDelay_IWORK.Tail[0];
      int_T *iw_Head = &Controller_DWork.TransportDelay_IWORK.Head[0];
      int_T *iw_Last = &Controller_DWork.TransportDelay_IWORK.Last[0];
      int_T *iw_CircularBufSize =
        &Controller_DWork.TransportDelay_IWORK.CircularBufSize[0];
      for (i1=0; i1 < 3; i1++) {
        tMinusDelay = ((Controller_P.TransportDelay_Delay > 0.0) ?
                       Controller_P.TransportDelay_Delay : 0.0);
        tMinusDelay = simTime - tMinusDelay;
        y0[i1] = rt_TDelayInterpolate(
          tMinusDelay,
          0.0,
          *tBuffer,
          *uBuffer,
          iw_CircularBufSize[i1],
          &iw_Last[i1],
          iw_Tail[i1],
          iw_Head[i1],
          Controller_P.TransportDelay_InitOutput,
          0,
          0);
        tBuffer++;
        uBuffer++;
      }
    }
  }

  /* Gain: '<S13>/Gain3' incorporates:
   *  Inport: '<Root>/D'
   *  Inport: '<Root>/E'
   */
  Controller_B.Gain3[0] = Controller_P.Gain3_Gain_d * rtb_Step;
  Controller_B.Gain3[1] = Controller_P.Gain3_Gain_d * Controller_U.E;
  Controller_B.Gain3[2] = Controller_P.Gain3_Gain_d * Controller_U.D;
  Controller_B.Gain3[3] = Controller_P.Gain3_Gain_d * rtb_TransferFcn;
  Controller_B.Gain3[4] = Controller_P.Gain3_Gain_d * rtb_TransferFcn1;
  Controller_B.Gain3[5] = Controller_P.Gain3_Gain_d * rtb_TransferFcn2;

  /* Integrator: '<S93>/Integrator1' */
  if (rtmIsMajorTimeStep(Controller_M)) {
    ZCEventType zcEvent;
    zcEvent = rt_ZCFcn(RISING_ZERO_CROSSING,
                       &Controller_PrevZCSigState.Integrator1_Reset_ZCE,
                       Controller_B.TransportDelay[0]);

    /* evaluate zero-crossings */
    if (zcEvent || Controller_DWork.Integrator1_IWORK.IcNeedsLoading) {
      Controller_X.Integrator1_CSTATE_g = Controller_B.Gain3[0];
    }
  }

  Controller_B.Integrator1_h = Controller_X.Integrator1_CSTATE_g;

  /* Integrator: '<S93>/Integrator2' */
  if (rtmIsMajorTimeStep(Controller_M)) {
    ZCEventType zcEvent;
    zcEvent = rt_ZCFcn(RISING_ZERO_CROSSING,
                       &Controller_PrevZCSigState.Integrator2_Reset_ZCE,
                       Controller_B.TransportDelay[1]);

    /* evaluate zero-crossings */
    if (zcEvent || Controller_DWork.Integrator2_IWORK.IcNeedsLoading) {
      Controller_X.Integrator2_CSTATE_n = Controller_B.Gain3[1];
    }
  }

  Controller_B.Integrator2 = Controller_X.Integrator2_CSTATE_n;

  /* Integrator: '<S93>/Integrator3' */
  if (rtmIsMajorTimeStep(Controller_M)) {
    ZCEventType zcEvent;
    zcEvent = rt_ZCFcn(RISING_ZERO_CROSSING,
                       &Controller_PrevZCSigState.Integrator3_Reset_ZCE,
                       Controller_B.TransportDelay[2]);

    /* evaluate zero-crossings */
    if (zcEvent || Controller_DWork.Integrator3_IWORK.IcNeedsLoading) {
      Controller_X.Integrator3_CSTATE_m = Controller_B.Gain3[5];
    }
  }

  Controller_B.Integrator3 = Controller_X.Integrator3_CSTATE_m;

  /* Sum: '<S82>/Sum3' */
  rtb_Sum3_c_idx_1 = Controller_B.Gain3[0] - Controller_B.Integrator1_h;
  rtb_Sum3_c_idx_0 = Controller_B.Gain3[1] - Controller_B.Integrator2;
  rtb_Sum3_c_idx = Controller_B.Gain3[5] - Controller_B.Integrator3;

  /* Saturate: '<S92>/Saturation' */
  if (rtb_Sum3_c_idx_1 >= Controller_P.Saturation_UpperSat) {
    rtb_Normalization_idx_0 = Controller_P.Saturation_UpperSat;
  } else if (rtb_Sum3_c_idx_1 <= Controller_P.Saturation_LowerSat) {
    rtb_Normalization_idx_0 = Controller_P.Saturation_LowerSat;
  } else {
    rtb_Normalization_idx_0 = rtb_Sum3_c_idx_1;
  }

  if (rtb_Sum3_c_idx_0 >= Controller_P.Saturation_UpperSat) {
    rtb_Normalization_idx = Controller_P.Saturation_UpperSat;
  } else if (rtb_Sum3_c_idx_0 <= Controller_P.Saturation_LowerSat) {
    rtb_Normalization_idx = Controller_P.Saturation_LowerSat;
  } else {
    rtb_Normalization_idx = rtb_Sum3_c_idx_0;
  }

  if (rtb_Sum3_c_idx >= Controller_P.Saturation_UpperSat) {
    omega_idx = Controller_P.Saturation_UpperSat;
  } else if (rtb_Sum3_c_idx <= Controller_P.Saturation_LowerSat) {
    omega_idx = Controller_P.Saturation_LowerSat;
  } else {
    omega_idx = rtb_Sum3_c_idx;
  }

  /* Clock: '<S82>/Clock' */
  rtb_Clock = Controller_M->Timing.t[0];

  /* MATLAB Function: '<S82>/MATLAB Function' incorporates:
   *  Constant: '<S82>/Constant'
   *  Constant: '<S82>/Constant1'
   */
  /* MATLAB Function 'Controll system/Observers/Hybrid nonlinear observer/MATLAB Function': '<S87>:1' */
  /* '<S87>:1:5' if isempty(time_reset_x) || time < 1 */
  if ((!Controller_DWork.time_reset_x_not_empty) || (rtb_Clock < 1.0)) {
    /* '<S87>:1:6' time_reset_x = 0; */
    Controller_DWork.time_reset_x = 0.0;
    Controller_DWork.time_reset_x_not_empty = TRUE;
  }

  /* '<S87>:1:10' if isempty(time_reset_y) || time < 1 */
  if ((!Controller_DWork.time_reset_y_not_empty) || (rtb_Clock < 1.0)) {
    /* '<S87>:1:11' time_reset_y = 0; */
    Controller_DWork.time_reset_y = 0.0;
    Controller_DWork.time_reset_y_not_empty = TRUE;
  }

  /* '<S87>:1:15' if isempty(time_reset_psi) || time < 1 */
  if ((!Controller_DWork.time_reset_psi_not_empty) || (rtb_Clock < 1.0)) {
    /* '<S87>:1:16' time_reset_psi = 0; */
    Controller_DWork.time_reset_psi = 0.0;
    Controller_DWork.time_reset_psi_not_empty = TRUE;
  }

  /* '<S87>:1:19' rst = [0 0 0]; */
  Controller_B.rst[0] = 0.0;
  Controller_B.rst[1] = 0.0;
  Controller_B.rst[2] = 0.0;

  /* '<S87>:1:21' if abs(eta_tilde(1)) > limits(1) && time-time_reset_x > time_rst */
  if ((fabs(rtb_Sum3_c_idx_1) > Controller_P.Constant_Value_l[0]) && (rtb_Clock
       - Controller_DWork.time_reset_x > Controller_P.Constant1_Value_o)) {
    /* '<S87>:1:22' rst(1) = 1; */
    Controller_B.rst[0] = 1.0;

    /* '<S87>:1:23' time_reset_x = time; */
    Controller_DWork.time_reset_x = rtb_Clock;
  }

  /* '<S87>:1:28' if abs(eta_tilde(2)) > limits(2) && time-time_reset_y > time_rst */
  if ((fabs(rtb_Sum3_c_idx_0) > Controller_P.Constant_Value_l[1]) && (rtb_Clock
       - Controller_DWork.time_reset_y > Controller_P.Constant1_Value_o)) {
    /* '<S87>:1:29' rst(2) = 1; */
    Controller_B.rst[1] = 1.0;

    /* '<S87>:1:30' time_reset_y = time; */
    Controller_DWork.time_reset_y = rtb_Clock;
  }

  /* '<S87>:1:35' if abs(eta_tilde(3)) > limits(3) && time-time_reset_psi > time_rst */
  if ((fabs(rtb_Sum3_c_idx) > Controller_P.Constant_Value_l[2]) && (rtb_Clock -
       Controller_DWork.time_reset_psi > Controller_P.Constant1_Value_o)) {
    /* '<S87>:1:36' rst(3) = 1; */
    Controller_B.rst[2] = 1.0;

    /* '<S87>:1:37' time_reset_psi = time; */
    Controller_DWork.time_reset_psi = rtb_Clock;
  }

  /* End of MATLAB Function: '<S82>/MATLAB Function' */

  /* Clock: '<S92>/Clock' */
  rtb_Clock_m = Controller_M->Timing.t[0];

  /* MATLAB Function: '<S92>/MATLAB Function' incorporates:
   *  Constant: '<S92>/Constant'
   *  Saturate: '<S92>/Saturation'
   */
  /* MATLAB Function 'Controll system/Observers/Hybrid nonlinear observer/Subsystem1/MATLAB Function': '<S102>:1' */
  /* '<S102>:1:5' if isempty(nu_x) || time < 1 */
  if ((!Controller_DWork.nu_x_not_empty) || (rtb_Clock_m < 1.0)) {
    /* '<S102>:1:6' nu_x = 0; */
    Controller_DWork.nu_x = 0.0;
    Controller_DWork.nu_x_not_empty = TRUE;
  }

  /* '<S102>:1:10' if isempty(nu_y) || time < 1 */
  if ((!Controller_DWork.nu_y_not_empty) || (rtb_Clock_m < 1.0)) {
    /* '<S102>:1:11' nu_y = 0; */
    Controller_DWork.nu_y = 0.0;
    Controller_DWork.nu_y_not_empty = TRUE;
  }

  /* '<S102>:1:15' if isempty(nu_psi) || time < 1 */
  if ((!Controller_DWork.nu_psi_not_empty) || (rtb_Clock_m < 1.0)) {
    /* '<S102>:1:16' nu_psi = 0; */
    Controller_DWork.nu_psi = 0.0;
    Controller_DWork.nu_psi_not_empty = TRUE;
  }

  /*  */
  /* '<S102>:1:21' if rst(1) > 0.1 */
  if (Controller_B.rst[0] > 0.1) {
    /* '<S102>:1:22' nu_x = nu_x + gain(1)*eta_tilde(1); */
    Controller_DWork.nu_x += Controller_P.Constant_Value_b[0] *
      rtb_Normalization_idx_0;
  }

  /* '<S102>:1:25' if rst(2) > 0.1 */
  if (Controller_B.rst[1] > 0.1) {
    /* '<S102>:1:26' nu_y = nu_y + gain(2)*eta_tilde(2); */
    Controller_DWork.nu_y += Controller_P.Constant_Value_b[1] *
      rtb_Normalization_idx;
  }

  /* '<S102>:1:29' if rst(3) > 0.1 */
  if (Controller_B.rst[2] > 0.1) {
    /* '<S102>:1:30' nu_psi = nu_psi + gain(3)*eta_tilde(3); */
    Controller_DWork.nu_psi += Controller_P.Constant_Value_b[2] * omega_idx;
  }

  /* Sum: '<S92>/Sum' incorporates:
   *  Gain: '<S92>/Gain'
   *  Integrator: '<S92>/Integrator'
   *  MATLAB Function: '<S92>/MATLAB Function'
   */
  /* '<S102>:1:33' d_hybrid = [nu_x nu_y nu_psi]'; */
  Controller_B.Sum[0] = Controller_P.Gain_Gain_g * Controller_DWork.nu_x +
    Controller_X.Integrator_CSTATE_d[0];
  Controller_B.Sum[1] = Controller_P.Gain_Gain_g * Controller_DWork.nu_y +
    Controller_X.Integrator_CSTATE_d[1];
  Controller_B.Sum[2] = Controller_P.Gain_Gain_g * Controller_DWork.nu_psi +
    Controller_X.Integrator_CSTATE_d[2];

  /* Gain: '<S82>/D' */
  for (k = 0; k < 3; k++) {
    rtb_sincos_o2[k] = Controller_P.D_Gain_l[k + 6] * Controller_B.Sum[2] +
      (Controller_P.D_Gain_l[k + 3] * Controller_B.Sum[1] +
       Controller_P.D_Gain_l[k] * Controller_B.Sum[0]);
  }

  /* End of Gain: '<S82>/D' */

  /* SignalConversion: '<S94>/TmpSignal ConversionAtsincosInport1' */
  rtb_frc_ctrl[0] = Controller_B.Gain3[5];
  rtb_frc_ctrl[1] = Controller_B.Gain3[4];
  rtb_frc_ctrl[2] = Controller_B.Gain3[3];

  /* Trigonometry: '<S97>/sincos' incorporates:
   *  SignalConversion: '<S94>/TmpSignal ConversionAtsincosInport1'
   */
  rtb_Sum_g[0] = sin(Controller_B.Gain3[5]);
  rtb_Gain6[0] = cos(Controller_B.Gain3[5]);
  rtb_Sum_g[1] = sin(Controller_B.Gain3[4]);
  rtb_Gain6[1] = cos(Controller_B.Gain3[4]);
  rtb_Sum_g[2] = sin(Controller_B.Gain3[3]);
  rtb_Gain6[2] = cos(Controller_B.Gain3[3]);

  /* Fcn: '<S97>/Fcn11' */
  rtb_VectorConcatenate_nt[0] = rtb_Gain6[1] * rtb_Gain6[0];

  /* Fcn: '<S97>/Fcn21' */
  rtb_VectorConcatenate_nt[1] = rtb_Sum_g[2] * rtb_Sum_g[1] * rtb_Gain6[0] -
    rtb_Gain6[2] * rtb_Sum_g[0];

  /* Fcn: '<S97>/Fcn31' */
  rtb_VectorConcatenate_nt[2] = rtb_Gain6[2] * rtb_Sum_g[1] * rtb_Gain6[0] +
    rtb_Sum_g[2] * rtb_Sum_g[0];

  /* Fcn: '<S97>/Fcn12' */
  rtb_VectorConcatenate_nt[3] = rtb_Gain6[1] * rtb_Sum_g[0];

  /* Fcn: '<S97>/Fcn22' */
  rtb_VectorConcatenate_nt[4] = rtb_Sum_g[2] * rtb_Sum_g[1] * rtb_Sum_g[0] +
    rtb_Gain6[2] * rtb_Gain6[0];

  /* Fcn: '<S97>/Fcn32' */
  rtb_VectorConcatenate_nt[5] = rtb_Gain6[2] * rtb_Sum_g[1] * rtb_Sum_g[0] -
    rtb_Sum_g[2] * rtb_Gain6[0];

  /* Fcn: '<S97>/Fcn13' */
  rtb_VectorConcatenate_nt[6] = -rtb_Sum_g[1];

  /* Fcn: '<S97>/Fcn23' */
  rtb_VectorConcatenate_nt[7] = rtb_Sum_g[2] * rtb_Gain6[1];

  /* Fcn: '<S97>/Fcn33' */
  rtb_VectorConcatenate_nt[8] = rtb_Gain6[2] * rtb_Gain6[1];

  /* Gain: '<S82>/Gain6' */
  for (k = 0; k < 3; k++) {
    rtb_Gain6[k] = Controller_P.Gain6_Gain[k + 6] * rtb_Sum3_c_idx +
      (Controller_P.Gain6_Gain[k + 3] * rtb_Sum3_c_idx_0 +
       Controller_P.Gain6_Gain[k] * rtb_Sum3_c_idx_1);
  }

  /* End of Gain: '<S82>/Gain6' */

  /* Saturate: '<S91>/Saturation' */
  if (rtb_Gain6[0] >= Controller_P.Saturation_UpperSat_m) {
    rtb_Normalization_idx_0 = Controller_P.Saturation_UpperSat_m;
  } else if (rtb_Gain6[0] <= Controller_P.Saturation_LowerSat_m) {
    rtb_Normalization_idx_0 = Controller_P.Saturation_LowerSat_m;
  } else {
    rtb_Normalization_idx_0 = rtb_Gain6[0];
  }

  if (rtb_Gain6[1] >= Controller_P.Saturation_UpperSat_m) {
    rtb_Normalization_idx = Controller_P.Saturation_UpperSat_m;
  } else if (rtb_Gain6[1] <= Controller_P.Saturation_LowerSat_m) {
    rtb_Normalization_idx = Controller_P.Saturation_LowerSat_m;
  } else {
    rtb_Normalization_idx = rtb_Gain6[1];
  }

  if (rtb_Gain6[2] >= Controller_P.Saturation_UpperSat_m) {
    omega_idx = Controller_P.Saturation_UpperSat_m;
  } else if (rtb_Gain6[2] <= Controller_P.Saturation_LowerSat_m) {
    omega_idx = Controller_P.Saturation_LowerSat_m;
  } else {
    omega_idx = rtb_Gain6[2];
  }

  /* Clock: '<S91>/Clock' */
  rtb_Clock_f = Controller_M->Timing.t[0];

  /* MATLAB Function: '<S91>/MATLAB Function' incorporates:
   *  Constant: '<S91>/Constant1'
   *  Saturate: '<S91>/Saturation'
   */
  /* MATLAB Function 'Controll system/Observers/Hybrid nonlinear observer/Subsystem/MATLAB Function': '<S101>:1' */
  /* '<S101>:1:5' if isempty(d_x) || time < 1 */
  if ((!Controller_DWork.d_x_not_empty) || (rtb_Clock_f < 1.0)) {
    /* '<S101>:1:6' d_x = 0; */
    Controller_DWork.d_x = 0.0;
    Controller_DWork.d_x_not_empty = TRUE;
  }

  /* '<S101>:1:10' if isempty(d_y) || time < 1 */
  if ((!Controller_DWork.d_y_not_empty) || (rtb_Clock_f < 1.0)) {
    /* '<S101>:1:11' d_y = 0; */
    Controller_DWork.d_y = 0.0;
    Controller_DWork.d_y_not_empty = TRUE;
  }

  /* '<S101>:1:15' if isempty(d_psi) || time < 1 */
  if ((!Controller_DWork.d_psi_not_empty) || (rtb_Clock_f < 1.0)) {
    /* '<S101>:1:16' d_psi = 0; */
    Controller_DWork.d_psi = 0.0;
    Controller_DWork.d_psi_not_empty = TRUE;
  }

  /* '<S101>:1:19' if rst(1) > 0.1 */
  if (Controller_B.rst[0] > 0.1) {
    /* '<S101>:1:20' d_x = d_x + gain(1)*eta_tilde(1); */
    Controller_DWork.d_x += Controller_P.Constant1_Value_eh[0] *
      rtb_Normalization_idx_0;
  }

  /* '<S101>:1:23' if rst(2) > 0.1 */
  if (Controller_B.rst[1] > 0.1) {
    /* '<S101>:1:24' d_y = d_y + gain(2)*eta_tilde(2); */
    Controller_DWork.d_y += Controller_P.Constant1_Value_eh[1] *
      rtb_Normalization_idx;
  }

  /* '<S101>:1:27' if rst(3) > 0.1 */
  if (Controller_B.rst[2] > 0.1) {
    /* '<S101>:1:28' d_psi = d_psi + gain(3)*eta_tilde(3); */
    Controller_DWork.d_psi += Controller_P.Constant1_Value_eh[2] * omega_idx;
  }

  /* Sum: '<S91>/Sum1' incorporates:
   *  Gain: '<S91>/Gain'
   *  Integrator: '<S91>/Integrator2'
   *  MATLAB Function: '<S91>/MATLAB Function'
   */
  /* '<S101>:1:31' d_hybrid = [d_x d_y d_psi]'; */
  rtb_Sum_g[0] = Controller_P.Gain_Gain_h * Controller_DWork.d_x +
    Controller_X.Integrator2_CSTATE_n4[0];
  rtb_Sum_g[1] = Controller_P.Gain_Gain_h * Controller_DWork.d_y +
    Controller_X.Integrator2_CSTATE_n4[1];
  rtb_Sum_g[2] = Controller_P.Gain_Gain_h * Controller_DWork.d_psi +
    Controller_X.Integrator2_CSTATE_n4[2];

  /* Product: '<S89>/Product' incorporates:
   *  Gain: '<S82>/Gain4'
   */
  for (k = 0; k < 3; k++) {
    rtb_VectorConcatenate_p_0[k] = rtb_VectorConcatenate_nt[k + 6] * rtb_Sum_g[2]
      + (rtb_VectorConcatenate_nt[k + 3] * rtb_Sum_g[1] +
         rtb_VectorConcatenate_nt[k] * rtb_Sum_g[0]);
  }

  /* End of Product: '<S89>/Product' */

  /* Gain: '<S82>/Gain4' */
  for (k = 0; k < 3; k++) {
    Controller_B.Gain4_k[k] = 0.0;
    Controller_B.Gain4_k[k] += Controller_P.Gain4_Gain_h[k] *
      rtb_VectorConcatenate_p_0[0];
    Controller_B.Gain4_k[k] += Controller_P.Gain4_Gain_h[k + 3] *
      rtb_VectorConcatenate_p_0[1];
    Controller_B.Gain4_k[k] += Controller_P.Gain4_Gain_h[k + 6] *
      rtb_VectorConcatenate_p_0[2];
  }

  /* Gain: '<S13>/Gain6' incorporates:
   *  Constant: '<S86>/Constant'
   *  Sum: '<S82>/Sum4'
   */
  Controller_B.Gain6[0] = Controller_P.Gain6_Gain_d * Controller_B.Integrator1_h;
  Controller_B.Gain6[1] = Controller_P.Gain6_Gain_d * Controller_B.Integrator2;
  Controller_B.Gain6[2] = Controller_P.Gain6_Gain_d *
    Controller_P.Constant_Value_e;
  Controller_B.Gain6[3] = Controller_P.Gain6_Gain_d *
    Controller_P.Constant_Value_e;
  Controller_B.Gain6[4] = Controller_P.Gain6_Gain_d *
    Controller_P.Constant_Value_e;
  Controller_B.Gain6[5] = Controller_P.Gain6_Gain_d * Controller_B.Integrator3;
  Controller_B.Gain6[6] = Controller_P.Gain6_Gain_d * Controller_B.Sum[0];
  Controller_B.Gain6[7] = Controller_P.Gain6_Gain_d * Controller_B.Sum[1];
  Controller_B.Gain6[8] = Controller_P.Gain6_Gain_d *
    Controller_P.Constant_Value_e;
  Controller_B.Gain6[9] = Controller_P.Gain6_Gain_d *
    Controller_P.Constant_Value_e;
  Controller_B.Gain6[10] = Controller_P.Gain6_Gain_d *
    Controller_P.Constant_Value_e;
  Controller_B.Gain6[11] = Controller_P.Gain6_Gain_d * Controller_B.Sum[2];
  Controller_B.Gain6[12] = (Controller_B.Gain4_k[0] - rtb_sincos_o2[0]) *
    Controller_P.Gain6_Gain_d;
  Controller_B.Gain6[13] = (Controller_B.Gain4_k[1] - rtb_sincos_o2[1]) *
    Controller_P.Gain6_Gain_d;
  Controller_B.Gain6[14] = (Controller_B.Gain4_k[2] - rtb_sincos_o2[2]) *
    Controller_P.Gain6_Gain_d;

  /* Outport: '<Root>/eta_e_N_HB' */
  Controller_Y.eta_e_N_HB = Controller_B.Gain6[0];

  /* Outport: '<Root>/eta_e_E_HB' */
  Controller_Y.eta_e_E_HB = Controller_B.Gain6[1];

  /* Outport: '<Root>/eta_e_psi_HB' */
  Controller_Y.eta_e_psi_HB = Controller_B.Gain6[5];

  /* Outport: '<Root>/nu_e_u_HB' */
  Controller_Y.nu_e_u_HB = Controller_B.Gain6[6];

  /* Outport: '<Root>/nu_e_v_HB' */
  Controller_Y.nu_e_v_HB = Controller_B.Gain6[7];

  /* Outport: '<Root>/nu_e_r_HB' */
  Controller_Y.nu_e_r_HB = Controller_B.Gain6[11];

  /* Outport: '<Root>/d_e_x_HB' */
  Controller_Y.d_e_x_HB = Controller_B.Gain6[12];

  /* Outport: '<Root>/d_e_y_HB' */
  Controller_Y.d_e_y_HB = Controller_B.Gain6[13];

  /* Outport: '<Root>/d_e_psi_HB' */
  Controller_Y.d_e_psi_HB = Controller_B.Gain6[14];

  /* MATLAB Function: '<S16>/System parameter calculation' */
  /* MATLAB Function 'Controll system/Control law/Robust MRAC/System parameter calculation': '<S24>:1' */
  /* '<S24>:1:4' M = theta_v_hat_in(1:3,:); */
  /* '<S24>:1:5' D = theta_v_hat_in(4:6,:); */
  /* '<S24>:1:7' theta_v_hat_out = [diag(M)' diag(D)']'; */
  for (k = 0; k < 3; k++) {
    rtb_R_m[3 * k] = rtb_Integrator3[6 * k];
    rtb_R_m[1 + 3 * k] = rtb_Integrator3[6 * k + 1];
    rtb_R_m[2 + 3 * k] = rtb_Integrator3[6 * k + 2];
  }

  for (k = 0; k < 3; k++) {
    kp[3 * k] = rtb_Integrator3[6 * k + 3];
    kp[1 + 3 * k] = rtb_Integrator3[6 * k + 4];
    kp[2 + 3 * k] = rtb_Integrator3[6 * k + 5];
  }

  /* Outport: '<Root>/M_v_x' incorporates:
   *  MATLAB Function: '<S16>/System parameter calculation'
   */
  Controller_Y.M_v_x = rtb_R_m[0];

  /* Outport: '<Root>/M_v_y' incorporates:
   *  MATLAB Function: '<S16>/System parameter calculation'
   */
  Controller_Y.M_v_y = rtb_R_m[4];

  /* Outport: '<Root>/M_v_n' incorporates:
   *  MATLAB Function: '<S16>/System parameter calculation'
   */
  Controller_Y.M_v_n = rtb_R_m[8];

  /* Outport: '<Root>/D_v_x' incorporates:
   *  MATLAB Function: '<S16>/System parameter calculation'
   */
  Controller_Y.D_v_x = kp[0];

  /* Outport: '<Root>/D_v_y' incorporates:
   *  MATLAB Function: '<S16>/System parameter calculation'
   */
  Controller_Y.D_v_y = kp[4];

  /* Outport: '<Root>/D_v_n' incorporates:
   *  MATLAB Function: '<S16>/System parameter calculation'
   */
  Controller_Y.D_v_n = kp[8];

  /* MATLAB Function: '<S16>/System parameter calculation1' */
  /* MATLAB Function 'Controll system/Control law/Robust MRAC/System parameter calculation1': '<S25>:1' */
  /* '<S25>:1:4' M_e = theta_e_hat_in(:,1:3); */
  /* '<S25>:1:5' D_e = theta_e_hat_in(:,4:6); */
  /* '<S25>:1:7' theta_e_hat_out = [diag(M_e)' diag(D_e)']'; */
  for (k = 0; k < 3; k++) {
    rtb_R_m[3 * k] = rtb_Integrator10[3 * k];
    rtb_R_m[1 + 3 * k] = rtb_Integrator10[3 * k + 1];
    rtb_R_m[2 + 3 * k] = rtb_Integrator10[3 * k + 2];
  }

  for (k = 0; k < 3; k++) {
    kp[3 * k] = rtb_Integrator10[(3 + k) * 3];
    kp[1 + 3 * k] = rtb_Integrator10[(3 + k) * 3 + 1];
    kp[2 + 3 * k] = rtb_Integrator10[(3 + k) * 3 + 2];
  }

  /* Outport: '<Root>/D_e_x' incorporates:
   *  MATLAB Function: '<S16>/System parameter calculation1'
   */
  Controller_Y.D_e_x = rtb_R_m[0];

  /* Outport: '<Root>/D_e_y' incorporates:
   *  MATLAB Function: '<S16>/System parameter calculation1'
   */
  Controller_Y.D_e_y = rtb_R_m[4];

  /* Outport: '<Root>/D_e_n' incorporates:
   *  MATLAB Function: '<S16>/System parameter calculation1'
   */
  Controller_Y.D_e_n = rtb_R_m[8];

  /* Outport: '<Root>/K_e_x' incorporates:
   *  MATLAB Function: '<S16>/System parameter calculation1'
   */
  Controller_Y.K_e_x = kp[0];

  /* Outport: '<Root>/K_e_y' incorporates:
   *  MATLAB Function: '<S16>/System parameter calculation1'
   */
  Controller_Y.K_e_y = kp[4];

  /* Outport: '<Root>/K_e_n' incorporates:
   *  MATLAB Function: '<S16>/System parameter calculation1'
   */
  Controller_Y.K_e_n = kp[8];

  /* Gain: '<S16>/Gain' */
  rtb_ypm[0] *= Controller_P.Gain_Gain_ix[0];
  rtb_ypm[1] *= Controller_P.Gain_Gain_ix[1];

  /* Fcn: '<S23>/Fcn' */
  rtb_Gain5_g = cos(rtb_TransferFcn2) * rtb_ypm[0] - sin(rtb_TransferFcn2) *
    rtb_ypm[1];

  /* Outport: '<Root>/pref_x' */
  Controller_Y.pref_x = rtb_Gain5_g;

  /* Fcn: '<S23>/Fcn1' */
  rtb_Gain5_g = sin(rtb_TransferFcn2) * rtb_ypm[0] + cos(rtb_TransferFcn2) *
    rtb_ypm[1];

  /* Outport: '<Root>/pref_y' */
  Controller_Y.pref_y = rtb_Gain5_g;

  /* Fcn: '<S23>/Fcn2' incorporates:
   *  Gain: '<S16>/Gain'
   */
  rtb_Gain5_g = Controller_P.Gain_Gain_ix[2] * rtb_ypm[2];

  /* Outport: '<Root>/pref_n' */
  Controller_Y.pref_n = rtb_Gain5_g;

  /* Outport: '<Root>/fref_x' */
  Controller_Y.fref_x = rtb_yFm[0];

  /* Outport: '<Root>/fref_y' */
  Controller_Y.fref_y = rtb_yFm[1];

  /* Outport: '<Root>/fref_n' */
  Controller_Y.fref_n = rtb_yFm[2];

  /* Outport: '<Root>/T_c_1x' incorporates:
   *  S-Function (sdspmultiportsel): '<Root>/Multiport Selector'
   */
  Controller_Y.T_c_1x = rtb_theta_ctrl_hat[0];

  /* Outport: '<Root>/T_c_2x' incorporates:
   *  S-Function (sdspmultiportsel): '<Root>/Multiport Selector'
   */
  Controller_Y.T_c_2x = rtb_theta_ctrl_hat[3];

  /* Outport: '<Root>/T_c_3x' incorporates:
   *  MATLAB Function: '<S16>/Control law parameter calculation'
   */
  Controller_Y.T_c_3x = rtb_TmpSignalConversionAtSFun_n[0];

  /* Outport: '<Root>/C_c_0x' incorporates:
   *  S-Function (sdspmultiportsel): '<Root>/Multiport Selector'
   */
  Controller_Y.C_c_0x = rtb_theta_ctrl_hat[9];

  /* Outport: '<Root>/T_c_4y' incorporates:
   *  S-Function (sdspmultiportsel): '<Root>/Multiport Selector'
   */
  Controller_Y.T_c_4y = rtb_theta_ctrl_hat[1];

  /* Outport: '<Root>/T_c_5y' incorporates:
   *  S-Function (sdspmultiportsel): '<Root>/Multiport Selector'
   */
  Controller_Y.T_c_5y = rtb_theta_ctrl_hat[4];

  /* Outport: '<Root>/T_c_6y' incorporates:
   *  MATLAB Function: '<S16>/Control law parameter calculation'
   */
  Controller_Y.T_c_6y = rtb_TmpSignalConversionAtSFun_n[1];

  /* Outport: '<Root>/C_c_1y' incorporates:
   *  S-Function (sdspmultiportsel): '<Root>/Multiport Selector'
   */
  Controller_Y.C_c_1y = rtb_theta_ctrl_hat[10];

  /* Outport: '<Root>/T_c_7n' incorporates:
   *  S-Function (sdspmultiportsel): '<Root>/Multiport Selector'
   */
  Controller_Y.T_c_7n = rtb_theta_ctrl_hat[2];

  /* Outport: '<Root>/T_c_8n' incorporates:
   *  S-Function (sdspmultiportsel): '<Root>/Multiport Selector'
   */
  Controller_Y.T_c_8n = rtb_theta_ctrl_hat[5];

  /* Outport: '<Root>/T_c_9n' incorporates:
   *  MATLAB Function: '<S16>/Control law parameter calculation'
   */
  Controller_Y.T_c_9n = rtb_TmpSignalConversionAtSFun_n[2];

  /* Outport: '<Root>/C_c_2n' incorporates:
   *  S-Function (sdspmultiportsel): '<Root>/Multiport Selector'
   */
  Controller_Y.C_c_2n = rtb_theta_ctrl_hat[11];

  /* Step: '<S11>/Step1' */
  if (Controller_M->Timing.t[0] < Controller_P.Step1_Time_n) {
    rtb_Gain5_g = Controller_P.Step1_Y0_e;
  } else {
    rtb_Gain5_g = Controller_P.Step1_YFinal_p;
  }

  /* End of Step: '<S11>/Step1' */

  /* Sum: '<S16>/Sum' incorporates:
   *  Constant: '<S16>/Ocean current  compensation'
   *  Product: '<S11>/Product1'
   */
  rtb_TmpSignalConversionAtSFun_n[0] = rtb_Sum_be[0] * rtb_Gain5_g +
    Controller_P.Oceancurrentcompensation_Value[0];
  rtb_TmpSignalConversionAtSFun_n[1] = rtb_Sum_be[1] * rtb_Gain5_g +
    Controller_P.Oceancurrentcompensation_Value[1];
  rtb_TmpSignalConversionAtSFun_n[2] = Controller_B.Integrator[2] * rtb_Gain5_g
    + Controller_P.Oceancurrentcompensation_Value[2];

  /* MATLAB Function: '<S16>/environment_estimation' incorporates:
   *  Constant: '<S16>/Constant17'
   *  Constant: '<S16>/Constant5'
   *  Constant: '<S16>/Constant6'
   *  Constant: '<S16>/Constant7'
   *  Constant: '<S16>/Constant8'
   *  Constant: '<S16>/Constant9'
   *  Integrator: '<S16>/Integrator11'
   *  Integrator: '<S16>/Integrator9'
   */
  /* MATLAB Function 'Controll system/Control law/Robust MRAC/environment_estimation': '<S29>:1' */
  /* '<S29>:1:5' if isempty(first) */
  /* Parameter estimates */
  /* '<S29>:1:18' M_e = theta_hat(:,1:3); */
  /* '<S29>:1:19' D_e = theta_hat(:,4:6); */
  /* Initializing filter outputs */
  /* '<S29>:1:22' z = zeros(3,1); */
  /* '<S29>:1:23' phi1 = zeros(3,1); */
  rtb_TmpSignalConversionAtSFun_g[0] = 0.0;
  rtb_TmpSignalConversionAtSFun_g[1] = 0.0;
  rtb_TmpSignalConversionAtSFun_g[2] = 0.0;

  /* '<S29>:1:24' phi2 = zeros(3,1); */
  rtb_TmpSignalConversionAtSFu_gy[0] = 0.0;
  rtb_TmpSignalConversionAtSFu_gy[1] = 0.0;
  rtb_TmpSignalConversionAtSFu_gy[2] = 0.0;

  /* Filter states */
  /* '<S29>:1:27' z1 = phi0(1:2,:); */
  /* '<S29>:1:28' phi01 = phi0(3:4,:); */
  /* '<S29>:1:29' phi02 = phi0(5:6,:); */
  /* '<S29>:1:31' phi = zeros(3,1); */
  /* Initializing derivative of theta estimate */
  /* '<S29>:1:34' theta_hat_dot = zeros(3,6); */
  memset(&Controller_B.theta_hat_dot[0], 0, 18U * sizeof(real_T));

  /* Initializing normalizing term derivative */
  /* '<S29>:1:37' m_s_dot = zeros(3,1); */
  /* '<S29>:1:39' for i=1:3 */
  for (i = 0; i < 3; i++) {
    /* '<S29>:1:41' z1_dot(:,i) = A01*z1(:,i)+B01*(F_C(i)); */
    Controller_DWork.z1_dot[i << 1] = (Controller_X.Integrator9_CSTATE[6 * i + 1]
      * Controller_P.Constant5_Value[2] + Controller_X.Integrator9_CSTATE[6 * i]
      * Controller_P.Constant5_Value[0]) + Controller_P.Constant6_Value[0] *
      Controller_B.Gain[i];
    Controller_DWork.z1_dot[1 + (i << 1)] = (Controller_X.Integrator9_CSTATE[6 *
      i + 1] * Controller_P.Constant5_Value[3] +
      Controller_X.Integrator9_CSTATE[6 * i] * Controller_P.Constant5_Value[1])
      + Controller_P.Constant6_Value[1] * Controller_B.Gain[i];

    /* '<S29>:1:42' z(i) = C01'*z1(:,i); */
    rtb_TmpSignalConversionAtSFun_d[i] = Controller_X.Integrator9_CSTATE[6 * i +
      1] * Controller_P.Constant7_Value[1] + Controller_X.Integrator9_CSTATE[6 *
      i] * Controller_P.Constant7_Value[0];

    /* '<S29>:1:44' phi01_dot(:,i) = A11*phi01(:,i)+B11*nu_c(i); */
    Controller_DWork.phi01_dot[i << 1] = (Controller_X.Integrator9_CSTATE[6 * i
      + 2] * Controller_P.Constant8_Value_i[0] +
      Controller_X.Integrator9_CSTATE[6 * i + 3] *
      Controller_P.Constant8_Value_i[2]) + Controller_P.Constant9_Value[0] *
      rtb_TmpSignalConversionAtSFun_n[i];
    Controller_DWork.phi01_dot[1 + (i << 1)] = (Controller_X.Integrator9_CSTATE
      [6 * i + 2] * Controller_P.Constant8_Value_i[1] +
      Controller_X.Integrator9_CSTATE[6 * i + 3] *
      Controller_P.Constant8_Value_i[3]) + Controller_P.Constant9_Value[1] *
      rtb_TmpSignalConversionAtSFun_n[i];

    /* '<S29>:1:45' phi1(i) = C11'*phi01(:,i); */
    rtb_Normalization_idx_0 = Controller_X.Integrator9_CSTATE[6 * i + 2] *
      Controller_P.Constant17_Value[0] + Controller_X.Integrator9_CSTATE[6 * i +
      3] * Controller_P.Constant17_Value[1];

    /* '<S29>:1:47' phi02_dot(:,i) = A01*phi02(:,i)+B01*nu_c(i); */
    Controller_DWork.phi02_dot[i << 1] = (Controller_X.Integrator9_CSTATE[6 * i
      + 4] * Controller_P.Constant5_Value[0] + Controller_X.Integrator9_CSTATE[6
      * i + 5] * Controller_P.Constant5_Value[2]) +
      Controller_P.Constant6_Value[0] * rtb_TmpSignalConversionAtSFun_n[i];
    Controller_DWork.phi02_dot[1 + (i << 1)] = (Controller_X.Integrator9_CSTATE
      [6 * i + 4] * Controller_P.Constant5_Value[1] +
      Controller_X.Integrator9_CSTATE[6 * i + 5] * Controller_P.Constant5_Value
      [3]) + Controller_P.Constant6_Value[1] * rtb_TmpSignalConversionAtSFun_n[i];

    /* '<S29>:1:48' phi2(i) = C01'*phi02(:,i); */
    rtb_Normalization_idx = Controller_X.Integrator9_CSTATE[6 * i + 4] *
      Controller_P.Constant7_Value[0] + Controller_X.Integrator9_CSTATE[6 * i +
      5] * Controller_P.Constant7_Value[1];

    /* '<S29>:1:50' phi_n = [-phi1(i) -phi2(i)]'; */
    /* m_s_dot(i) = -delta_0*m_s(i) + z(i)^2 + phi1(i)^2 + phi2(i)^2; */
    /* '<S29>:1:53' m_s_dot(i) = -delta_0*m_s(i) + phi_n'*phi_n; */
    Controller_B.m_s_dot_l[i] = (-rtb_Normalization_idx_0 *
      -rtb_Normalization_idx_0 + -rtb_Normalization_idx * -rtb_Normalization_idx)
      + -10.0 * Controller_X.Integrator11_CSTATE[i];
    rtb_TmpSignalConversionAtSFun_g[i] = rtb_Normalization_idx_0;
    rtb_TmpSignalConversionAtSFu_gy[i] = rtb_Normalization_idx;
  }

  /* Adaptive gain */
  /* '<S29>:1:58' Gamma = diag([700 200]); */
  /* Upper bounds for leakage term */
  /* '<S29>:1:61' M_0deu = [10000 10000 12000]'; */
  /* '<S29>:1:62' M_0meu = [30000 30000 30000]'; */
  /* Lower bounds for leakage term */
  /* '<S29>:1:65' M_0del = [0 0 0]'; */
  /* '<S29>:1:66' M_0mel = [10 10 10]'; */
  /* '<S29>:1:68' w_0de = 1; */
  /* '<S29>:1:69' w_0me = 1; */
  /* '<S29>:1:71' for i=1:3 */
  for (idx2 = 0; idx2 < 3; idx2++) {
    /* Regressor */
    /* '<S29>:1:74' phi = [-phi1(i) -phi2(i)]'; */
    /* Parameter estimate */
    /* '<S29>:1:77' theta_e_hat = [M_e(i,i) D_e(i,i)]'; */
    /* Normalizing factor */
    /* '<S29>:1:80' m = 1 + phi'*phi + m_s(i); */
    rtb_Normalization_data[0] = -rtb_TmpSignalConversionAtSFun_g[idx2];
    rtb_Normalization_data[1] = -rtb_TmpSignalConversionAtSFu_gy[idx2];
    for (k = 0; k < 2; k++) {
      for (i = 0; i < 1; i++) {
        a_data[k] = rtb_Normalization_data[k];
      }
    }

    /* Estimate of error */
    /* '<S29>:1:83' z_hat = theta_e_hat'*phi; */
    /* '<S29>:1:84' eps = (z(i) - z_hat)/m; */
    rtb_Sum3_g = (rtb_TmpSignalConversionAtSFun_d[idx2] - (rtb_Integrator10[(3 +
      idx2) * 3 + idx2] * -rtb_TmpSignalConversionAtSFu_gy[idx2] +
      rtb_Integrator10[3 * idx2 + idx2] * -rtb_TmpSignalConversionAtSFun_g[idx2]))
      / (((a_data[0] * -rtb_TmpSignalConversionAtSFun_g[idx2] + a_data[1] *
           -rtb_TmpSignalConversionAtSFu_gy[idx2]) + 1.0) +
         Controller_X.Integrator11_CSTATE[idx2]);

    /* Switching leakage for M_e */
    /* '<S29>:1:87' if and(M_0mel(i) < M_e(i,i), M_e(i,i) < M_0meu(i)) */
    if ((10.0 < rtb_Integrator10[3 * idx2 + idx2]) && (rtb_Integrator10[3 * idx2
         + idx2] < 30000.0)) {
      /* '<S29>:1:88' w_sme = 0; */
      rtb_Divide = 0.0;
    } else if (((30000.0 <= rtb_Integrator10[3 * idx2 + idx2]) &&
                (rtb_Integrator10[3 * idx2 + idx2] <= 60000.0)) || ((5.0 <=
                 rtb_Integrator10[3 * idx2 + idx2]) && (rtb_Integrator10[3 *
                 idx2 + idx2] <= 10.0))) {
      /* '<S29>:1:89' elseif or(and(M_0meu(i) <= M_e(i,i), M_e(i,i) <= 2*M_0meu(i)), and(M_0mel(i)/2 <= M_e(i,i), M_e(i,i) <= M_0mel(i))) */
      /* '<S29>:1:90' w_sme = (abs(M_e(i,i))/M_0meu(i) - 1)*w_0me; */
      rtb_Divide = fabs(rtb_Integrator10[3 * idx2 + idx2]) / 30000.0 - 1.0;
    } else {
      /* '<S29>:1:91' else */
      /* '<S29>:1:92' w_sme = w_0me; */
      rtb_Divide = 1.0;
    }

    /* Switching leakage for D_e */
    /* '<S29>:1:96' if and(M_0del(i) < D_e(i,i), D_e(i,i) < M_0deu(i)) */
    if ((0.0 < rtb_Integrator10[(3 + idx2) * 3 + idx2]) && (rtb_Integrator10[(3
          + idx2) * 3 + idx2] < (real_T)M_0deu[idx2])) {
      /* '<S29>:1:97' w_sde = 0; */
      rtb_Sum2_i = 0.0;
    } else if ((((real_T)M_0deu[idx2] <= rtb_Integrator10[(3 + idx2) * 3 + idx2])
                && (rtb_Integrator10[(3 + idx2) * 3 + idx2] <= 2.0 * (real_T)
                    M_0deu[idx2])) || ((0.0 <= rtb_Integrator10[(3 + idx2) * 3 +
      idx2]) && (rtb_Integrator10[(3 + idx2) * 3 + idx2] <= 0.0))) {
      /* '<S29>:1:98' elseif or(and(M_0deu(i) <= D_e(i,i), D_e(i,i) <= 2*M_0deu(i)), and(M_0del(i)/2 <= D_e(i,i), D_e(i,i) <= M_0del(i))) */
      /* '<S29>:1:99' w_sde = (abs(D_e(i,i))/M_0deu(i) - 1)*w_0de; */
      rtb_Sum2_i = fabs(rtb_Integrator10[(3 + idx2) * 3 + idx2]) / (real_T)
        M_0deu[idx2] - 1.0;
    } else {
      /* '<S29>:1:100' else */
      /* '<S29>:1:101' w_sde = w_0de; */
      rtb_Sum2_i = 1.0;
    }

    /* '<S29>:1:104' W_se = diag([w_sme w_sde]); */
    /* '<S29>:1:107' theta_hat_dot(i,i:3:end) = Gamma*eps*phi - Gamma*W_se*theta_e_hat; */
    for (k = 0; k < 2; k++) {
      diophantine_eq[k] = 0.0;
      diophantine_eq[k] += (real_T)b_a[k] * rtb_Divide;
      diophantine_eq[k + 2] = 0.0;
      diophantine_eq[k + 2] += (real_T)b_a[k + 2] * rtb_Sum2_i;
    }

    Controller_B.theta_hat_dot[idx2 + 3 * idx2] = (700.0 * rtb_Sum3_g *
      -rtb_TmpSignalConversionAtSFun_g[idx2] + 0.0 * rtb_Sum3_g *
      -rtb_TmpSignalConversionAtSFu_gy[idx2]) - (rtb_Integrator10[(3 + idx2) * 3
      + idx2] * diophantine_eq[2] + rtb_Integrator10[3 * idx2 + idx2] *
      diophantine_eq[0]);
    Controller_B.theta_hat_dot[idx2 + 3 * (idx2 + 3)] = (0.0 * rtb_Sum3_g *
      -rtb_TmpSignalConversionAtSFun_g[idx2] + 200.0 * rtb_Sum3_g *
      -rtb_TmpSignalConversionAtSFu_gy[idx2]) - (rtb_Integrator10[(3 + idx2) * 3
      + idx2] * diophantine_eq[3] + rtb_Integrator10[3 * idx2 + idx2] *
      diophantine_eq[1]);
  }

  /* '<S29>:1:111' phi_dot = [z1_dot; phi01_dot; phi02_dot]; */
  /* '<S29>:1:112' theta_e_hat = [M_e; D_e]; */
  for (k = 0; k < 3; k++) {
    Controller_B.phi_dot_e[6 * k] = Controller_DWork.z1_dot[k << 1];
    Controller_B.phi_dot_e[1 + 6 * k] = Controller_DWork.z1_dot[(k << 1) + 1];
  }

  for (k = 0; k < 3; k++) {
    Controller_B.phi_dot_e[2 + 6 * k] = Controller_DWork.phi01_dot[k << 1];
    Controller_B.phi_dot_e[3 + 6 * k] = Controller_DWork.phi01_dot[(k << 1) + 1];
  }

  for (k = 0; k < 3; k++) {
    Controller_B.phi_dot_e[4 + 6 * k] = Controller_DWork.phi02_dot[k << 1];
    Controller_B.phi_dot_e[5 + 6 * k] = Controller_DWork.phi02_dot[(k << 1) + 1];
  }

  /* End of MATLAB Function: '<S16>/environment_estimation' */

  /* SignalConversion: '<S30>/TmpSignal ConversionAt SFunction Inport10' incorporates:
   *  MATLAB Function: '<S16>/normalized _adaptive_law1'
   */
  rtb_TmpSignalConversionAtSFun_g[0] = rtb_Row1;
  rtb_TmpSignalConversionAtSFun_g[1] = rtb_Row2;
  rtb_TmpSignalConversionAtSFun_g[2] = rtb_Row3;

  /* MATLAB Function: '<S16>/normalized _adaptive_law1' incorporates:
   *  Constant: '<S16>/Constant1'
   *  Constant: '<S16>/Constant11'
   *  Constant: '<S16>/Constant12'
   *  Constant: '<S16>/Constant2'
   *  Constant: '<S16>/Constant3'
   *  Constant: '<S16>/Constant4'
   *  Integrator: '<S16>/Integrator4'
   *  Integrator: '<S16>/Integrator5'
   */
  /* MATLAB Function 'Controll system/Control law/Robust MRAC/normalized _adaptive_law1': '<S30>:1' */
  /* '<S30>:1:5' if isempty(first) */
  /*  Initializing parameter derivative */
  /* '<S30>:1:32' theta_ves_hat_dot = zeros(6,3); */
  memset(&rtb_Integrator10[0], 0, 18U * sizeof(real_T));

  /*  Parameter estimates */
  /* '<S30>:1:35' M = theta_ves_hat(1:3,:); */
  /* '<S30>:1:36' D = theta_ves_hat(4:6,:); */
  /* '<S30>:1:38' kp = M\eye(3); */
  /* '<S30>:1:39' p2 = kp*D; */
  /*  Filter states */
  /* '<S30>:1:42' phi01=phi(1:2,:); */
  /* '<S30>:1:43' phi02=phi(3:4,:); */
  /* '<S30>:1:44' phi03=phi(5:6,:); */
  /* '<S30>:1:45' phi04=phi(7:8,:); */
  /* '<S30>:1:46' phi05=phi(9:10,:); */
  /* Initializing normalizing term derivative */
  /* '<S30>:1:49' m_s_dot = zeros(3,1); */
  /* '<S30>:1:51' for i=1:3 */
  for (i = 0; i < 3; i++) {
    /*  sF_T/Lambda(s) */
    /* '<S30>:1:54' dphi01(:,i) = A11*phi01(:,i)+B11*F_T(i); */
    Controller_DWork.dphi01[i << 1] = (Controller_X.Integrator4_CSTATE[10 * i +
      1] * Controller_P.Constant4_Value_p[2] + Controller_X.Integrator4_CSTATE
      [10 * i] * Controller_P.Constant4_Value_p[0]) +
      Controller_P.Constant3_Value_f[0] * rtb_Z_m[i];
    Controller_DWork.dphi01[1 + (i << 1)] = (Controller_X.Integrator4_CSTATE[10 *
      i + 1] * Controller_P.Constant4_Value_p[3] +
      Controller_X.Integrator4_CSTATE[10 * i] * Controller_P.Constant4_Value_p[1])
      + Controller_P.Constant3_Value_f[1] * rtb_Z_m[i];

    /* '<S30>:1:55' phi1(i) = C11'*phi01(:,i); */
    Controller_DWork.phi1[i] = Controller_X.Integrator4_CSTATE[10 * i + 1] *
      Controller_P.Constant2_Value_g[1] + Controller_X.Integrator4_CSTATE[10 * i]
      * Controller_P.Constant2_Value_g[0];

    /*  F_T/Lambda(s) */
    /* '<S30>:1:58' dphi02(:,i) = A01*phi02(:,i)+B01*F_T(i); */
    Controller_DWork.dphi02[i << 1] = (Controller_X.Integrator4_CSTATE[10 * i +
      2] * Controller_P.Constant1_Value_o3[0] + Controller_X.Integrator4_CSTATE
      [10 * i + 3] * Controller_P.Constant1_Value_o3[2]) +
      Controller_P.Constant12_Value[0] * rtb_Z_m[i];
    Controller_DWork.dphi02[1 + (i << 1)] = (Controller_X.Integrator4_CSTATE[10 *
      i + 2] * Controller_P.Constant1_Value_o3[1] +
      Controller_X.Integrator4_CSTATE[10 * i + 3] *
      Controller_P.Constant1_Value_o3[3]) + Controller_P.Constant12_Value[1] *
      rtb_Z_m[i];

    /* '<S30>:1:59' phi2(i) = C01'*phi02(:,i); */
    Controller_DWork.phi2[i] = Controller_X.Integrator4_CSTATE[10 * i + 2] *
      Controller_P.Constant11_Value[0] + Controller_X.Integrator4_CSTATE[10 * i
      + 3] * Controller_P.Constant11_Value[1];

    /*  nu/Lambda(s) */
    /* '<S30>:1:62' dphi03(:,i) = A01*phi03(:,i)+B01*nu(i); */
    Controller_DWork.dphi03[i << 1] = (Controller_X.Integrator4_CSTATE[10 * i +
      4] * Controller_P.Constant1_Value_o3[0] + Controller_X.Integrator4_CSTATE
      [10 * i + 5] * Controller_P.Constant1_Value_o3[2]) +
      Controller_P.Constant12_Value[0] * rtb_TmpSignalConversionAtSFun_n[i];
    Controller_DWork.dphi03[1 + (i << 1)] = (Controller_X.Integrator4_CSTATE[10 *
      i + 4] * Controller_P.Constant1_Value_o3[1] +
      Controller_X.Integrator4_CSTATE[10 * i + 5] *
      Controller_P.Constant1_Value_o3[3]) + Controller_P.Constant12_Value[1] *
      rtb_TmpSignalConversionAtSFun_n[i];

    /* '<S30>:1:63' phi3(i) = C01'*phi03(:,i); */
    Controller_DWork.phi3[i] = Controller_X.Integrator4_CSTATE[10 * i + 4] *
      Controller_P.Constant11_Value[0] + Controller_X.Integrator4_CSTATE[10 * i
      + 5] * Controller_P.Constant11_Value[1];

    /*  eta_p/Lambda(s) */
    /* '<S30>:1:66' dphi04(:,i) = A01*phi04(:,i)+B01*eta_p(i); */
    Controller_DWork.dphi04[i << 1] = (Controller_X.Integrator4_CSTATE[10 * i +
      6] * Controller_P.Constant1_Value_o3[0] + Controller_X.Integrator4_CSTATE
      [10 * i + 7] * Controller_P.Constant1_Value_o3[2]) +
      Controller_P.Constant12_Value[0] * rtb_TmpSignalConversionAtSFun_g[i];
    Controller_DWork.dphi04[1 + (i << 1)] = (Controller_X.Integrator4_CSTATE[10 *
      i + 6] * Controller_P.Constant1_Value_o3[1] +
      Controller_X.Integrator4_CSTATE[10 * i + 7] *
      Controller_P.Constant1_Value_o3[3]) + Controller_P.Constant12_Value[1] *
      rtb_TmpSignalConversionAtSFun_g[i];

    /* '<S30>:1:67' phi4(i) = C01'*phi04(:,i); */
    /*  snu/Lambda(s) */
    /* '<S30>:1:70' dphi05(:,i) = A11*phi05(:,i)+B11*nu(i); */
    Controller_DWork.dphi05[i << 1] = (Controller_X.Integrator4_CSTATE[10 * i +
      8] * Controller_P.Constant4_Value_p[0] + Controller_X.Integrator4_CSTATE
      [10 * i + 9] * Controller_P.Constant4_Value_p[2]) +
      Controller_P.Constant3_Value_f[0] * rtb_TmpSignalConversionAtSFun_n[i];
    Controller_DWork.dphi05[1 + (i << 1)] = (Controller_X.Integrator4_CSTATE[10 *
      i + 8] * Controller_P.Constant4_Value_p[1] +
      Controller_X.Integrator4_CSTATE[10 * i + 9] *
      Controller_P.Constant4_Value_p[3]) + Controller_P.Constant3_Value_f[1] *
      rtb_TmpSignalConversionAtSFun_n[i];

    /* '<S30>:1:71' phi5(i) = C11'*phi05(:,i); */
    Controller_DWork.phi5[i] = Controller_X.Integrator4_CSTATE[10 * i + 8] *
      Controller_P.Constant2_Value_g[0] + Controller_X.Integrator4_CSTATE[10 * i
      + 9] * Controller_P.Constant2_Value_g[1];

    /* '<S30>:1:73' phi_1(i,:) = [phi1(i) phi2(i)]; */
    /* '<S30>:1:74' phi_2(i,:) = [-phi3(i) -phi5(i)]; */
    /* Dynamic normalization */
    /* m_s_dot(i) = -delta_0*m_s(i) + phi2(i)*phi2(i)' + phi_2(i,:)*phi_2(i,:)'; */
    /* '<S30>:1:78' m_s_dot(i) = -delta_0*m_s(i) + F_T(i)^2 + nu(i)^2; */
    Controller_B.m_s_dot[i] = (-10.0 * Controller_X.Integrator5_CSTATE[i] +
      rt_powd_snf(rtb_Z_m[i], 2.0)) + rt_powd_snf
      (rtb_TmpSignalConversionAtSFun_n[i], 2.0);
  }

  /* Filter vectors */
  /* '<S30>:1:82' phi_0 = phi_1; */
  /* '<S30>:1:83' phi_1bar = zeros(3,1); */
  /* '<S30>:1:84' phi_1m = phi_0(:,2); */
  /* Adaption gain */
  /* '<S30>:1:87' Gamma = diag([6100 200]); */
  /* Upper bounds for switching term */
  /* '<S30>:1:90' M_0du = [10000 10000 12000]'; */
  /* '<S30>:1:91' M_0mu = [30000 30000 30000]'; */
  /* Lower bounds for switching term */
  /* '<S30>:1:94' M_0dl = [0 0 0]'; */
  /* '<S30>:1:95' M_0ml = [200 200 200]'; */
  /* '<S30>:1:97' w_0d = 1; */
  /* '<S30>:1:98' w_0m = 1; */
  /* '<S30>:1:100' for i=1:3 */
  for (idx2 = 0; idx2 < 3; idx2++) {
    /* Parameter estimate and regressor */
    /* '<S30>:1:103' theta_p_hat = [M(i,i) D(i,i)]'; */
    /* '<S30>:1:104' phi = [phi5(i) phi3(i)]'; */
    /* Measurement and estimate of this */
    /* '<S30>:1:107' z = phi2(i); */
    /* '<S30>:1:108' z_hat = theta_p_hat'*phi; */
    /*  Normalizing factor */
    /* '<S30>:1:111' m = 1 + m_s(i); */
    /* Estimation error */
    /* '<S30>:1:114' eps = (z - z_hat)/m; */
    rtb_Sum3_g = (Controller_DWork.phi2[idx2] - (rtb_Integrator3[(6 * idx2 +
      idx2) + 3] * Controller_DWork.phi3[idx2] + rtb_Integrator3[6 * idx2 + idx2]
      * Controller_DWork.phi5[idx2])) / (1.0 +
      Controller_X.Integrator5_CSTATE[idx2]);

    /* Switching leakage for M */
    /* '<S30>:1:117' if and(M_0ml(i) < M(i,i), M(i,i) < M_0mu(i)) */
    if ((200.0 < rtb_Integrator3[6 * idx2 + idx2]) && (rtb_Integrator3[6 * idx2
         + idx2] < 30000.0)) {
      /* '<S30>:1:118' w_sm = 0; */
      rtb_Divide = 0.0;
    } else if (((30000.0 <= rtb_Integrator3[6 * idx2 + idx2]) &&
                (rtb_Integrator3[6 * idx2 + idx2] <= 60000.0)) || ((100.0 <=
                 rtb_Integrator3[6 * idx2 + idx2]) && (rtb_Integrator3[6 * idx2
                 + idx2] <= 200.0))) {
      /* '<S30>:1:119' elseif or(and(M_0mu(i) <= M(i,i), M(i,i) <= 2*M_0mu(i)), and(M_0ml(i)/2 <= M(i,i), M(i,i) <= M_0ml(i))) */
      /* '<S30>:1:120' w_sm = (abs(M(i,i))/M_0mu(i) - 1)*w_0m; */
      rtb_Divide = fabs(rtb_Integrator3[6 * idx2 + idx2]) / 30000.0 - 1.0;
    } else {
      /* '<S30>:1:121' else */
      /* '<S30>:1:122' w_sm = w_0m; */
      rtb_Divide = 1.0;
    }

    /* Switching leakage for D */
    /* '<S30>:1:126' if and(M_0dl(i) < D(i,i), D(i,i) < M_0du(i)) */
    if ((0.0 < rtb_Integrator3[(6 * idx2 + idx2) + 3]) && (rtb_Integrator3[(6 *
          idx2 + idx2) + 3] < (real_T)M_0du[idx2])) {
      /* '<S30>:1:127' w_sd = 0; */
      rtb_Sum2_i = 0.0;
    } else if ((((real_T)M_0du[idx2] <= rtb_Integrator3[(6 * idx2 + idx2) + 3]) &&
                (rtb_Integrator3[(6 * idx2 + idx2) + 3] <= 2.0 * (real_T)
                 M_0du[idx2])) || ((0.0 <= rtb_Integrator3[(6 * idx2 + idx2) + 3])
                && (rtb_Integrator3[(6 * idx2 + idx2) + 3] <= 0.0))) {
      /* '<S30>:1:128' elseif or(and(M_0du(i) <= D(i,i), D(i,i) <= 2*M_0du(i)), and(M_0dl(i)/2 <= D(i,i), D(i,i) <= M_0dl(i))) */
      /* '<S30>:1:129' w_sd = (abs(D(i,i))/M_0du(i) - 1)*w_0d; */
      rtb_Sum2_i = fabs(rtb_Integrator3[(6 * idx2 + idx2) + 3]) / (real_T)
        M_0du[idx2] - 1.0;
    } else {
      /* '<S30>:1:130' else */
      /* '<S30>:1:131' w_sd = w_0d; */
      rtb_Sum2_i = 1.0;
    }

    /* '<S30>:1:134' W_s = diag([w_sm w_sd]); */
    /* Update law */
    /* '<S30>:1:137' theta_ves_hat_dot(i:3:end,i) = Gamma*phi*eps - Gamma*W_s*theta_p_hat; */
    for (k = 0; k < 2; k++) {
      diophantine_eq[k] = 0.0;
      diophantine_eq[k] += (real_T)a[k] * rtb_Divide;
      diophantine_eq[k + 2] = 0.0;
      diophantine_eq[k + 2] += (real_T)a[k + 2] * rtb_Sum2_i;
    }

    rtb_Integrator10[idx2 + 6 * idx2] = (6100.0 * Controller_DWork.phi5[idx2] +
      0.0 * Controller_DWork.phi3[idx2]) * rtb_Sum3_g - (rtb_Integrator3[(6 *
      idx2 + idx2) + 3] * diophantine_eq[2] + rtb_Integrator3[6 * idx2 + idx2] *
      diophantine_eq[0]);
    rtb_Integrator10[(idx2 + 6 * idx2) + 3] = (0.0 * Controller_DWork.phi5[idx2]
      + 200.0 * Controller_DWork.phi3[idx2]) * rtb_Sum3_g - (rtb_Integrator3[(6 *
      idx2 + idx2) + 3] * diophantine_eq[3] + rtb_Integrator3[6 * idx2 + idx2] *
      diophantine_eq[1]);
  }

  /*  Stack the derivatives. */
  /* '<S30>:1:142' phi_dot = [dphi01; dphi02; dphi03; dphi04; dphi05]; */
  for (k = 0; k < 18; k++) {
    Controller_B.theta_ves_hat_dot[k] = rtb_Integrator10[k];
  }

  for (k = 0; k < 3; k++) {
    Controller_B.phi_dot[10 * k] = Controller_DWork.dphi01[k << 1];
    Controller_B.phi_dot[1 + 10 * k] = Controller_DWork.dphi01[(k << 1) + 1];
  }

  for (k = 0; k < 3; k++) {
    Controller_B.phi_dot[2 + 10 * k] = Controller_DWork.dphi02[k << 1];
    Controller_B.phi_dot[3 + 10 * k] = Controller_DWork.dphi02[(k << 1) + 1];
  }

  for (k = 0; k < 3; k++) {
    Controller_B.phi_dot[4 + 10 * k] = Controller_DWork.dphi03[k << 1];
    Controller_B.phi_dot[5 + 10 * k] = Controller_DWork.dphi03[(k << 1) + 1];
  }

  for (k = 0; k < 3; k++) {
    Controller_B.phi_dot[6 + 10 * k] = Controller_DWork.dphi04[k << 1];
    Controller_B.phi_dot[7 + 10 * k] = Controller_DWork.dphi04[(k << 1) + 1];
  }

  for (k = 0; k < 3; k++) {
    Controller_B.phi_dot[8 + 10 * k] = Controller_DWork.dphi05[k << 1];
    Controller_B.phi_dot[9 + 10 * k] = Controller_DWork.dphi05[(k << 1) + 1];
  }

  /* Gain: '<S33>/Gain1' incorporates:
   *  Constant: '<S33>/Constant'
   *  Gain: '<S33>/Gain'
   *  Gain: '<S33>/Gain2'
   *  Sum: '<S33>/Sum'
   *  Sum: '<S33>/Sum1'
   *  Sum: '<S33>/Sum2'
   *  Trigonometry: '<S36>/Trigonometric Function'
   */
  Controller_B.Gain1 = (((rt_atan2d_snf(rtb_TransferFcn2_h, rtb_Sum_k) -
    Controller_P.Constant_Value_p) * Controller_P.Gain2_Gain_m -
    rtb_Integrator1_i) - Controller_P.Gain_Gain_bs * Controller_B.Integrator_n) *
    Controller_P.Gain1_Gain_f;

  /* Trigonometry: '<S47>/sincos' */
  rtb_ypm[0] = sin(rtb_k_m_r[0]);
  rtb_Sum_g[0] = cos(rtb_k_m_r[0]);
  rtb_ypm[1] = sin(rtb_k_m_r[1]);
  rtb_Sum_g[1] = cos(rtb_k_m_r[1]);
  rtb_ypm[2] = sin(rtb_k_m_r[2]);
  rtb_Sum_g[2] = cos(rtb_k_m_r[2]);

  /* Fcn: '<S47>/Fcn11' */
  rtb_VectorConcatenate_g[0] = rtb_Sum_g[1] * rtb_Sum_g[0];

  /* Fcn: '<S47>/Fcn21' */
  rtb_VectorConcatenate_g[1] = rtb_ypm[2] * rtb_ypm[1] * rtb_Sum_g[0] -
    rtb_Sum_g[2] * rtb_ypm[0];

  /* Fcn: '<S47>/Fcn31' */
  rtb_VectorConcatenate_g[2] = rtb_Sum_g[2] * rtb_ypm[1] * rtb_Sum_g[0] +
    rtb_ypm[2] * rtb_ypm[0];

  /* Fcn: '<S47>/Fcn12' */
  rtb_VectorConcatenate_g[3] = rtb_Sum_g[1] * rtb_ypm[0];

  /* Fcn: '<S47>/Fcn22' */
  rtb_VectorConcatenate_g[4] = rtb_ypm[2] * rtb_ypm[1] * rtb_ypm[0] + rtb_Sum_g
    [2] * rtb_Sum_g[0];

  /* Fcn: '<S47>/Fcn32' */
  rtb_VectorConcatenate_g[5] = rtb_Sum_g[2] * rtb_ypm[1] * rtb_ypm[0] - rtb_ypm
    [2] * rtb_Sum_g[0];

  /* Fcn: '<S47>/Fcn13' */
  rtb_VectorConcatenate_g[6] = -rtb_ypm[1];

  /* Fcn: '<S47>/Fcn23' */
  rtb_VectorConcatenate_g[7] = rtb_ypm[2] * rtb_Sum_g[1];

  /* Fcn: '<S47>/Fcn33' */
  rtb_VectorConcatenate_g[8] = rtb_Sum_g[2] * rtb_Sum_g[1];

  /* Sum: '<S43>/Sum1' incorporates:
   *  Constant: '<S43>/Gravity'
   *  Inport: '<Root>/w_d'
   */
  rtb_Gain5_g = Controller_U.w_d + Controller_P.Gravity_Value_n;

  /* Product: '<S43>/Product' incorporates:
   *  Inport: '<Root>/u_d'
   *  Inport: '<Root>/v_d'
   *  SignalConversion: '<S43>/TmpSignal ConversionAtProductInport2'
   */
  for (k = 0; k < 3; k++) {
    rtb_Sum_g[k] = rtb_VectorConcatenate_g[k + 6] * rtb_Gain5_g +
      (rtb_VectorConcatenate_g[k + 3] * Controller_U.v_d +
       rtb_VectorConcatenate_g[k] * Controller_U.u_d);
  }

  /* End of Product: '<S43>/Product' */

  /* Trigonometry: '<S48>/sincos' */
  rtb_ypm[0] = sin(rtb_k_m_r[0]);
  rtb_Sum_be[0] = cos(rtb_k_m_r[0]);
  rtb_ypm[1] = sin(rtb_k_m_r[1]);
  rtb_Sum_be[1] = cos(rtb_k_m_r[1]);
  rtb_ypm[2] = sin(rtb_k_m_r[2]);
  rtb_Sum_be[2] = cos(rtb_k_m_r[2]);

  /* Fcn: '<S48>/Fcn11' */
  rtb_VectorConcatenate_pj[0] = rtb_Sum_be[1] * rtb_Sum_be[0];

  /* Fcn: '<S48>/Fcn21' */
  rtb_VectorConcatenate_pj[1] = rtb_ypm[2] * rtb_ypm[1] * rtb_Sum_be[0] -
    rtb_Sum_be[2] * rtb_ypm[0];

  /* Fcn: '<S48>/Fcn31' */
  rtb_VectorConcatenate_pj[2] = rtb_Sum_be[2] * rtb_ypm[1] * rtb_Sum_be[0] +
    rtb_ypm[2] * rtb_ypm[0];

  /* Fcn: '<S48>/Fcn12' */
  rtb_VectorConcatenate_pj[3] = rtb_Sum_be[1] * rtb_ypm[0];

  /* Fcn: '<S48>/Fcn22' */
  rtb_VectorConcatenate_pj[4] = rtb_ypm[2] * rtb_ypm[1] * rtb_ypm[0] +
    rtb_Sum_be[2] * rtb_Sum_be[0];

  /* Fcn: '<S48>/Fcn32' */
  rtb_VectorConcatenate_pj[5] = rtb_Sum_be[2] * rtb_ypm[1] * rtb_ypm[0] -
    rtb_ypm[2] * rtb_Sum_be[0];

  /* Fcn: '<S48>/Fcn13' */
  rtb_VectorConcatenate_pj[6] = -rtb_ypm[1];

  /* Fcn: '<S48>/Fcn23' */
  rtb_VectorConcatenate_pj[7] = rtb_ypm[2] * rtb_Sum_be[1];

  /* Fcn: '<S48>/Fcn33' */
  rtb_VectorConcatenate_pj[8] = rtb_Sum_be[2] * rtb_Sum_be[1];

  /* Product: '<S43>/Product1' */
  for (k = 0; k < 3; k++) {
    rtb_ypm[k] = rtb_VectorConcatenate_pj[k + 6] * rtb_Gain_ia +
      (rtb_VectorConcatenate_pj[k + 3] * rtb_Gain1_f +
       rtb_VectorConcatenate_pj[k] * rtb_Sum1_pd_idx);
  }

  /* End of Product: '<S43>/Product1' */

  /* Sum: '<S55>/Sum' incorporates:
   *  Constant: '<S44>/Accelerometer position'
   *  Product: '<S55>/Product'
   *  Product: '<S55>/Product1'
   */
  rtb_TmpSignalConversionAtSFun_g[0] = rtb_ypm[1] *
    Controller_P.Accelerometerposition_Value[2] - rtb_ypm[2] *
    Controller_P.Accelerometerposition_Value[1];
  rtb_TmpSignalConversionAtSFun_g[1] = rtb_ypm[2] *
    Controller_P.Accelerometerposition_Value[0] - rtb_ypm[0] *
    Controller_P.Accelerometerposition_Value[2];
  rtb_TmpSignalConversionAtSFun_g[2] = rtb_ypm[0] *
    Controller_P.Accelerometerposition_Value[1] - rtb_ypm[1] *
    Controller_P.Accelerometerposition_Value[0];

  /* Trigonometry: '<S79>/sincos' */
  rtb_Sum1_pd_idx = sin(rtb_k_m_r[0]);
  rtb_Sum_be[0] = cos(rtb_k_m_r[0]);
  rtb_Gain1_f = sin(rtb_k_m_r[1]);
  rtb_Sum_be[1] = cos(rtb_k_m_r[1]);
  rtb_Gain_ia = sin(rtb_k_m_r[2]);
  rtb_Sum_be[2] = cos(rtb_k_m_r[2]);

  /* Fcn: '<S79>/Fcn11' */
  rtb_VectorConcatenate_a[0] = rtb_Sum_be[1] * rtb_Sum_be[0];

  /* Fcn: '<S79>/Fcn21' */
  rtb_VectorConcatenate_a[1] = rtb_Gain_ia * rtb_Gain1_f * rtb_Sum_be[0] -
    rtb_Sum_be[2] * rtb_Sum1_pd_idx;

  /* Fcn: '<S79>/Fcn31' */
  rtb_VectorConcatenate_a[2] = rtb_Sum_be[2] * rtb_Gain1_f * rtb_Sum_be[0] +
    rtb_Gain_ia * rtb_Sum1_pd_idx;

  /* Fcn: '<S79>/Fcn12' */
  rtb_VectorConcatenate_a[3] = rtb_Sum_be[1] * rtb_Sum1_pd_idx;

  /* Fcn: '<S79>/Fcn22' */
  rtb_VectorConcatenate_a[4] = rtb_Gain_ia * rtb_Gain1_f * rtb_Sum1_pd_idx +
    rtb_Sum_be[2] * rtb_Sum_be[0];

  /* Fcn: '<S79>/Fcn32' */
  rtb_VectorConcatenate_a[5] = rtb_Sum_be[2] * rtb_Gain1_f * rtb_Sum1_pd_idx -
    rtb_Gain_ia * rtb_Sum_be[0];

  /* Fcn: '<S79>/Fcn13' */
  rtb_VectorConcatenate_a[6] = -rtb_Gain1_f;

  /* Fcn: '<S79>/Fcn23' */
  rtb_VectorConcatenate_a[7] = rtb_Gain_ia * rtb_Sum_be[1];

  /* Fcn: '<S79>/Fcn33' */
  rtb_VectorConcatenate_a[8] = rtb_Sum_be[2] * rtb_Sum_be[1];

  /* Product: '<S46>/Product2' */
  for (k = 0; k < 3; k++) {
    Controller_B.Product2[k] = 0.0;
    Controller_B.Product2[k] += rtb_VectorConcatenate_a[k] * rtb_Gain1_l_idx_1;
    Controller_B.Product2[k] += rtb_VectorConcatenate_a[k + 3] *
      rtb_Gain1_l_idx_0;
    Controller_B.Product2[k] += rtb_VectorConcatenate_a[k + 6] * rtb_Gain1_l_idx;
  }

  /* End of Product: '<S46>/Product2' */

  /* Sum: '<S57>/Sum' incorporates:
   *  Constant: '<S44>/Accelerometer position'
   *  Product: '<S57>/Product'
   *  Product: '<S57>/Product1'
   */
  rtb_Sum1_pd_idx = Controller_B.Product2[1] *
    Controller_P.Accelerometerposition_Value[2] - Controller_B.Product2[2] *
    Controller_P.Accelerometerposition_Value[1];
  rtb_Gain1_f = Controller_B.Product2[2] *
    Controller_P.Accelerometerposition_Value[0] - Controller_B.Product2[0] *
    Controller_P.Accelerometerposition_Value[2];
  rtb_Gain_ia = Controller_B.Product2[0] *
    Controller_P.Accelerometerposition_Value[1] - Controller_B.Product2[1] *
    Controller_P.Accelerometerposition_Value[0];

  /* Product: '<S56>/Product' */
  rtb_Gain1_l_idx_1 = Controller_B.Product2[1] * rtb_Gain_ia;
  rtb_Gain1_l_idx_0 = Controller_B.Product2[2] * rtb_Sum1_pd_idx;
  rtb_Gain1_l_idx = Controller_B.Product2[0] * rtb_Gain1_f;

  /* Product: '<S56>/Product1' */
  rtb_Sum_be[0] = Controller_B.Product2[2] * rtb_Gain1_f;
  rtb_Sum_be[1] = Controller_B.Product2[0] * rtb_Gain_ia;
  rtb_Sum_be[2] = Controller_B.Product2[1] * rtb_Sum1_pd_idx;
  if (rtmIsMajorTimeStep(Controller_M)) {
    /* Gain: '<S58>/Output' incorporates:
     *  RandomNumber: '<S58>/White Noise'
     */
    Controller_B.Output = Controller_P.Output_Gain * Controller_DWork.NextOutput;
  }

  /* TransferFcn: '<S59>/Transfer Fcn' */
  rtb_Gain5_g = Controller_P.TransferFcn_C_n[0]*
    Controller_X.TransferFcn_CSTATE_en[0]
    + Controller_P.TransferFcn_C_n[1]*Controller_X.TransferFcn_CSTATE_en[1];

  /* TransferFcn: '<S59>/Transfer Fcn1' */
  rtb_TransferFcn1_o = Controller_P.TransferFcn1_C_e[0]*
    Controller_X.TransferFcn1_CSTATE_m[0]
    + Controller_P.TransferFcn1_C_e[1]*Controller_X.TransferFcn1_CSTATE_m[1];

  /* TransferFcn: '<S59>/Transfer Fcn2' */
  rtb_TransferFcn2_h = Controller_P.TransferFcn2_C_c[0]*
    Controller_X.TransferFcn2_CSTATE_j[0]
    + Controller_P.TransferFcn2_C_c[1]*Controller_X.TransferFcn2_CSTATE_j[1];

  /* Sum: '<S51>/Sum' incorporates:
   *  Sum: '<S56>/Sum'
   */
  Controller_B.Sum_a[0] = (rtb_TmpSignalConversionAtSFun_g[0] + rtb_Sum_g[0]) +
    (rtb_Gain1_l_idx_1 - rtb_Sum_be[0]);
  Controller_B.Sum_a[1] = (rtb_TmpSignalConversionAtSFun_g[1] + rtb_Sum_g[1]) +
    (rtb_Gain1_l_idx_0 - rtb_Sum_be[1]);
  Controller_B.Sum_a[2] = (rtb_TmpSignalConversionAtSFun_g[2] + rtb_Sum_g[2]) +
    (rtb_Gain1_l_idx - rtb_Sum_be[2]);

  /* Sum: '<S51>/Sum1' */
  rtb_Sum1_pd_idx = rtb_Gain5_g + Controller_B.Output;
  rtb_Gain1_f = rtb_TransferFcn1_o + Controller_B.Output;
  rtb_Gain_ia = rtb_TransferFcn2_h + Controller_B.Output;

  /* Sum: '<S60>/Sum' incorporates:
   *  Constant: '<S44>/Accelerometer position1'
   *  Product: '<S60>/Product'
   *  Product: '<S60>/Product1'
   */
  rtb_TmpSignalConversionAtSFun_g[0] = rtb_ypm[1] *
    Controller_P.Accelerometerposition1_Value[2] - rtb_ypm[2] *
    Controller_P.Accelerometerposition1_Value[1];
  rtb_TmpSignalConversionAtSFun_g[1] = rtb_ypm[2] *
    Controller_P.Accelerometerposition1_Value[0] - rtb_ypm[0] *
    Controller_P.Accelerometerposition1_Value[2];
  rtb_TmpSignalConversionAtSFun_g[2] = rtb_ypm[0] *
    Controller_P.Accelerometerposition1_Value[1] - rtb_ypm[1] *
    Controller_P.Accelerometerposition1_Value[0];

  /* Sum: '<S62>/Sum' incorporates:
   *  Constant: '<S44>/Accelerometer position1'
   *  Product: '<S62>/Product'
   *  Product: '<S62>/Product1'
   */
  rtb_Gain1_l_idx_1 = Controller_B.Product2[1] *
    Controller_P.Accelerometerposition1_Value[2] - Controller_B.Product2[2] *
    Controller_P.Accelerometerposition1_Value[1];
  rtb_Gain1_l_idx_0 = Controller_B.Product2[2] *
    Controller_P.Accelerometerposition1_Value[0] - Controller_B.Product2[0] *
    Controller_P.Accelerometerposition1_Value[2];
  rtb_Gain1_l_idx = Controller_B.Product2[0] *
    Controller_P.Accelerometerposition1_Value[1] - Controller_B.Product2[1] *
    Controller_P.Accelerometerposition1_Value[0];

  /* Product: '<S61>/Product' */
  rtb_Sum_be[0] = Controller_B.Product2[1] * rtb_Gain1_l_idx;
  rtb_Sum_be[1] = Controller_B.Product2[2] * rtb_Gain1_l_idx_1;
  rtb_Sum_be[2] = Controller_B.Product2[0] * rtb_Gain1_l_idx_0;

  /* Product: '<S61>/Product1' */
  rtb_TmpSignalConversionAtSFun_d[0] = Controller_B.Product2[2] *
    rtb_Gain1_l_idx_0;
  rtb_TmpSignalConversionAtSFun_d[1] = Controller_B.Product2[0] *
    rtb_Gain1_l_idx;
  rtb_TmpSignalConversionAtSFun_d[2] = Controller_B.Product2[1] *
    rtb_Gain1_l_idx_1;
  if (rtmIsMajorTimeStep(Controller_M)) {
    /* Gain: '<S63>/Output' incorporates:
     *  RandomNumber: '<S63>/White Noise'
     */
    Controller_B.Output_g = Controller_P.Output_Gain_b *
      Controller_DWork.NextOutput_k;
  }

  /* TransferFcn: '<S64>/Transfer Fcn' */
  rtb_Gain5_g = Controller_P.TransferFcn_C_c[0]*
    Controller_X.TransferFcn_CSTATE_d[0]
    + Controller_P.TransferFcn_C_c[1]*Controller_X.TransferFcn_CSTATE_d[1];

  /* TransferFcn: '<S64>/Transfer Fcn1' */
  rtb_TransferFcn1_o = Controller_P.TransferFcn1_C_o2[0]*
    Controller_X.TransferFcn1_CSTATE_e[0]
    + Controller_P.TransferFcn1_C_o2[1]*Controller_X.TransferFcn1_CSTATE_e[1];

  /* TransferFcn: '<S64>/Transfer Fcn2' */
  rtb_TransferFcn2_h = Controller_P.TransferFcn2_C_e[0]*
    Controller_X.TransferFcn2_CSTATE_c[0]
    + Controller_P.TransferFcn2_C_e[1]*Controller_X.TransferFcn2_CSTATE_c[1];

  /* Sum: '<S52>/Sum' incorporates:
   *  Sum: '<S61>/Sum'
   */
  Controller_B.Sum_f[0] = (rtb_TmpSignalConversionAtSFun_g[0] + rtb_Sum_g[0]) +
    (rtb_Sum_be[0] - rtb_TmpSignalConversionAtSFun_d[0]);
  Controller_B.Sum_f[1] = (rtb_TmpSignalConversionAtSFun_g[1] + rtb_Sum_g[1]) +
    (rtb_Sum_be[1] - rtb_TmpSignalConversionAtSFun_d[1]);
  Controller_B.Sum_f[2] = (rtb_TmpSignalConversionAtSFun_g[2] + rtb_Sum_g[2]) +
    (rtb_Sum_be[2] - rtb_TmpSignalConversionAtSFun_d[2]);

  /* Sum: '<S52>/Sum1' */
  rtb_TmpSignalConversionAtSFun_d[0] = rtb_Gain5_g + Controller_B.Output_g;
  rtb_TmpSignalConversionAtSFun_d[1] = rtb_TransferFcn1_o +
    Controller_B.Output_g;
  rtb_TmpSignalConversionAtSFun_d[2] = rtb_TransferFcn2_h +
    Controller_B.Output_g;

  /* Sum: '<S65>/Sum' incorporates:
   *  Constant: '<S44>/Accelerometer position3'
   *  Product: '<S65>/Product'
   *  Product: '<S65>/Product1'
   */
  rtb_TmpSignalConversionAtSFun_g[0] = rtb_ypm[1] *
    Controller_P.Accelerometerposition3_Value[2] - rtb_ypm[2] *
    Controller_P.Accelerometerposition3_Value[1];
  rtb_TmpSignalConversionAtSFun_g[1] = rtb_ypm[2] *
    Controller_P.Accelerometerposition3_Value[0] - rtb_ypm[0] *
    Controller_P.Accelerometerposition3_Value[2];
  rtb_TmpSignalConversionAtSFun_g[2] = rtb_ypm[0] *
    Controller_P.Accelerometerposition3_Value[1] - rtb_ypm[1] *
    Controller_P.Accelerometerposition3_Value[0];

  /* Sum: '<S67>/Sum' incorporates:
   *  Constant: '<S44>/Accelerometer position3'
   *  Product: '<S67>/Product'
   *  Product: '<S67>/Product1'
   */
  rtb_Gain1_l_idx_1 = Controller_B.Product2[1] *
    Controller_P.Accelerometerposition3_Value[2] - Controller_B.Product2[2] *
    Controller_P.Accelerometerposition3_Value[1];
  rtb_Gain1_l_idx_0 = Controller_B.Product2[2] *
    Controller_P.Accelerometerposition3_Value[0] - Controller_B.Product2[0] *
    Controller_P.Accelerometerposition3_Value[2];
  rtb_Gain1_l_idx = Controller_B.Product2[0] *
    Controller_P.Accelerometerposition3_Value[1] - Controller_B.Product2[1] *
    Controller_P.Accelerometerposition3_Value[0];

  /* Product: '<S66>/Product' */
  rtb_Sum_be[0] = Controller_B.Product2[1] * rtb_Gain1_l_idx;
  rtb_Sum_be[1] = Controller_B.Product2[2] * rtb_Gain1_l_idx_1;
  rtb_Sum_be[2] = Controller_B.Product2[0] * rtb_Gain1_l_idx_0;

  /* Product: '<S66>/Product1' */
  rtb_TmpSignalConversionAtSFu_gy[0] = Controller_B.Product2[2] *
    rtb_Gain1_l_idx_0;
  rtb_TmpSignalConversionAtSFu_gy[1] = Controller_B.Product2[0] *
    rtb_Gain1_l_idx;
  rtb_TmpSignalConversionAtSFu_gy[2] = Controller_B.Product2[1] *
    rtb_Gain1_l_idx_1;
  if (rtmIsMajorTimeStep(Controller_M)) {
    /* Gain: '<S68>/Output' incorporates:
     *  RandomNumber: '<S68>/White Noise'
     */
    Controller_B.Output_c = Controller_P.Output_Gain_g *
      Controller_DWork.NextOutput_f;
  }

  /* TransferFcn: '<S69>/Transfer Fcn' */
  rtb_Gain5_g = Controller_P.TransferFcn_C_e[0]*
    Controller_X.TransferFcn_CSTATE_o[0]
    + Controller_P.TransferFcn_C_e[1]*Controller_X.TransferFcn_CSTATE_o[1];

  /* TransferFcn: '<S69>/Transfer Fcn1' */
  rtb_TransferFcn1_o = Controller_P.TransferFcn1_C_m[0]*
    Controller_X.TransferFcn1_CSTATE_g[0]
    + Controller_P.TransferFcn1_C_m[1]*Controller_X.TransferFcn1_CSTATE_g[1];

  /* TransferFcn: '<S69>/Transfer Fcn2' */
  rtb_TransferFcn2_h = Controller_P.TransferFcn2_C_m[0]*
    Controller_X.TransferFcn2_CSTATE_i[0]
    + Controller_P.TransferFcn2_C_m[1]*Controller_X.TransferFcn2_CSTATE_i[1];

  /* Sum: '<S53>/Sum' incorporates:
   *  Sum: '<S66>/Sum'
   */
  Controller_B.Sum_l[0] = (rtb_TmpSignalConversionAtSFun_g[0] + rtb_Sum_g[0]) +
    (rtb_Sum_be[0] - rtb_TmpSignalConversionAtSFu_gy[0]);
  Controller_B.Sum_l[1] = (rtb_TmpSignalConversionAtSFun_g[1] + rtb_Sum_g[1]) +
    (rtb_Sum_be[1] - rtb_TmpSignalConversionAtSFu_gy[1]);
  Controller_B.Sum_l[2] = (rtb_TmpSignalConversionAtSFun_g[2] + rtb_Sum_g[2]) +
    (rtb_Sum_be[2] - rtb_TmpSignalConversionAtSFu_gy[2]);

  /* Sum: '<S53>/Sum1' */
  rtb_TmpSignalConversionAtSFu_gy[0] = rtb_Gain5_g + Controller_B.Output_c;
  rtb_TmpSignalConversionAtSFu_gy[1] = rtb_TransferFcn1_o +
    Controller_B.Output_c;
  rtb_TmpSignalConversionAtSFu_gy[2] = rtb_TransferFcn2_h +
    Controller_B.Output_c;

  /* Sum: '<S70>/Sum' incorporates:
   *  Constant: '<S44>/Accelerometer position2'
   *  Product: '<S70>/Product'
   *  Product: '<S70>/Product1'
   */
  rtb_TmpSignalConversionAtSFun_g[0] = rtb_ypm[1] *
    Controller_P.Accelerometerposition2_Value[2] - rtb_ypm[2] *
    Controller_P.Accelerometerposition2_Value[1];
  rtb_TmpSignalConversionAtSFun_g[1] = rtb_ypm[2] *
    Controller_P.Accelerometerposition2_Value[0] - rtb_ypm[0] *
    Controller_P.Accelerometerposition2_Value[2];
  rtb_TmpSignalConversionAtSFun_g[2] = rtb_ypm[0] *
    Controller_P.Accelerometerposition2_Value[1] - rtb_ypm[1] *
    Controller_P.Accelerometerposition2_Value[0];

  /* Sum: '<S72>/Sum' incorporates:
   *  Constant: '<S44>/Accelerometer position2'
   *  Product: '<S72>/Product'
   *  Product: '<S72>/Product1'
   */
  rtb_ypm[0] = Controller_B.Product2[1] *
    Controller_P.Accelerometerposition2_Value[2] - Controller_B.Product2[2] *
    Controller_P.Accelerometerposition2_Value[1];
  rtb_ypm[1] = Controller_B.Product2[2] *
    Controller_P.Accelerometerposition2_Value[0] - Controller_B.Product2[0] *
    Controller_P.Accelerometerposition2_Value[2];
  rtb_ypm[2] = Controller_B.Product2[0] *
    Controller_P.Accelerometerposition2_Value[1] - Controller_B.Product2[1] *
    Controller_P.Accelerometerposition2_Value[0];

  /* Product: '<S71>/Product' */
  rtb_Gain1_l_idx_1 = Controller_B.Product2[1] * rtb_ypm[2];
  rtb_Gain1_l_idx_0 = Controller_B.Product2[2] * rtb_ypm[0];
  rtb_Gain1_l_idx = Controller_B.Product2[0] * rtb_ypm[1];

  /* Product: '<S71>/Product1' */
  rtb_Sum_be[0] = Controller_B.Product2[2] * rtb_ypm[1];
  rtb_Sum_be[1] = Controller_B.Product2[0] * rtb_ypm[2];
  rtb_Sum_be[2] = Controller_B.Product2[1] * rtb_ypm[0];
  if (rtmIsMajorTimeStep(Controller_M)) {
    /* Gain: '<S73>/Output' incorporates:
     *  RandomNumber: '<S73>/White Noise'
     */
    Controller_B.Output_o = Controller_P.Output_Gain_e *
      Controller_DWork.NextOutput_c;
  }

  /* TransferFcn: '<S74>/Transfer Fcn' */
  rtb_Gain5_g = Controller_P.TransferFcn_C_dx[0]*
    Controller_X.TransferFcn_CSTATE_c[0]
    + Controller_P.TransferFcn_C_dx[1]*Controller_X.TransferFcn_CSTATE_c[1];

  /* TransferFcn: '<S74>/Transfer Fcn1' */
  rtb_TransferFcn1_o = Controller_P.TransferFcn1_C_e2[0]*
    Controller_X.TransferFcn1_CSTATE_l[0]
    + Controller_P.TransferFcn1_C_e2[1]*Controller_X.TransferFcn1_CSTATE_l[1];

  /* TransferFcn: '<S74>/Transfer Fcn2' */
  rtb_TransferFcn2_h = Controller_P.TransferFcn2_C_h[0]*
    Controller_X.TransferFcn2_CSTATE_h[0]
    + Controller_P.TransferFcn2_C_h[1]*Controller_X.TransferFcn2_CSTATE_h[1];

  /* Sum: '<S54>/Sum' incorporates:
   *  Sum: '<S71>/Sum'
   */
  Controller_B.Sum_aq[0] = (rtb_TmpSignalConversionAtSFun_g[0] + rtb_Sum_g[0]) +
    (rtb_Gain1_l_idx_1 - rtb_Sum_be[0]);
  Controller_B.Sum_aq[1] = (rtb_TmpSignalConversionAtSFun_g[1] + rtb_Sum_g[1]) +
    (rtb_Gain1_l_idx_0 - rtb_Sum_be[1]);
  Controller_B.Sum_aq[2] = (rtb_TmpSignalConversionAtSFun_g[2] + rtb_Sum_g[2]) +
    (rtb_Gain1_l_idx - rtb_Sum_be[2]);

  /* Sum: '<S54>/Sum1' */
  rtb_ypm[0] = rtb_Gain5_g + Controller_B.Output_o;
  rtb_ypm[1] = rtb_TransferFcn1_o + Controller_B.Output_o;
  rtb_ypm[2] = rtb_TransferFcn2_h + Controller_B.Output_o;
  if (rtmIsMajorTimeStep(Controller_M)) {
    /* Gain: '<S75>/Output' incorporates:
     *  RandomNumber: '<S75>/White Noise'
     */
    Controller_B.Output_h[0] = Controller_P.Output_Gain_p[0] *
      Controller_DWork.NextOutput_m[0];
    Controller_B.Output_h[1] = Controller_P.Output_Gain_p[1] *
      Controller_DWork.NextOutput_m[1];
    Controller_B.Output_h[2] = Controller_P.Output_Gain_p[2] *
      Controller_DWork.NextOutput_m[2];
  }

  /* TransferFcn: '<S76>/Transfer Fcn' */
  rtb_Gain5_g = Controller_P.TransferFcn_C_a[0]*
    Controller_X.TransferFcn_CSTATE_n[0]
    + Controller_P.TransferFcn_C_a[1]*Controller_X.TransferFcn_CSTATE_n[1];

  /* TransferFcn: '<S76>/Transfer Fcn1' */
  rtb_TransferFcn1_o = Controller_P.TransferFcn1_C_l[0]*
    Controller_X.TransferFcn1_CSTATE_p[0]
    + Controller_P.TransferFcn1_C_l[1]*Controller_X.TransferFcn1_CSTATE_p[1];

  /* TransferFcn: '<S76>/Transfer Fcn2' */
  rtb_TransferFcn2_h = Controller_P.TransferFcn2_C_j[0]*
    Controller_X.TransferFcn2_CSTATE_ck[0]
    + Controller_P.TransferFcn2_C_j[1]*Controller_X.TransferFcn2_CSTATE_ck[1];

  /* Sum: '<S45>/Sum' */
  rtb_Sum_g[0] = rtb_Gain5_g + Controller_B.Output_h[0];
  rtb_Sum_g[1] = rtb_TransferFcn1_o + Controller_B.Output_h[1];
  rtb_Sum_g[2] = rtb_TransferFcn2_h + Controller_B.Output_h[2];
  if (rtmIsMajorTimeStep(Controller_M)) {
  }

  /* Gain: '<S13>/Gain1' */
  rtb_Gain1_l_idx = Controller_P.Gain1_Gain_fn * rtb_Sum_g[2];

  /* Gain: '<S13>/Gain2' */
  rtb_TmpSignalConversionAtSFun_n[0] = Controller_P.Gain2_Gain_k *
    rtb_Integrator_idx_1;
  rtb_TmpSignalConversionAtSFun_n[1] = Controller_P.Gain2_Gain_k *
    rtb_Integrator_idx_0;
  rtb_TmpSignalConversionAtSFun_n[2] = Controller_P.Gain2_Gain_k *
    rtb_Integrator_idx;

  /* Gain: '<S13>/Gain4' */
  rtb_TmpSignalConversionAtSFun_g[0] = Controller_P.Gain4_Gain_j *
    rtb_Integrator_idx_1;
  rtb_TmpSignalConversionAtSFun_g[1] = Controller_P.Gain4_Gain_j *
    rtb_Integrator_idx_0;
  rtb_TmpSignalConversionAtSFun_g[2] = Controller_P.Gain4_Gain_j *
    rtb_Integrator_idx;

  /* Gain: '<S13>/Gain5' */
  rtb_k_m_r[2] = Controller_P.Gain5_Gain * rtb_Sum_g[2];
  if (rtmIsMajorTimeStep(Controller_M)) {
  }

  /* Trigonometry: '<S99>/sincos' */
  rtb_Sum_be[0] = sin(rtb_frc_ctrl[0]);
  rtb_Product_g[0] = cos(rtb_frc_ctrl[0]);
  rtb_Sum_be[1] = sin(rtb_frc_ctrl[1]);
  rtb_Product_g[1] = cos(rtb_frc_ctrl[1]);
  rtb_Sum_be[2] = sin(rtb_frc_ctrl[2]);
  rtb_Product_g[2] = cos(rtb_frc_ctrl[2]);

  /* Fcn: '<S99>/Fcn11' */
  rtb_VectorConcatenate_l[0] = rtb_Product_g[1] * rtb_Product_g[0];

  /* Fcn: '<S99>/Fcn21' */
  rtb_VectorConcatenate_l[1] = rtb_Sum_be[2] * rtb_Sum_be[1] * rtb_Product_g[0]
    - rtb_Product_g[2] * rtb_Sum_be[0];

  /* Fcn: '<S99>/Fcn31' */
  rtb_VectorConcatenate_l[2] = rtb_Product_g[2] * rtb_Sum_be[1] * rtb_Product_g
    [0] + rtb_Sum_be[2] * rtb_Sum_be[0];

  /* Fcn: '<S99>/Fcn12' */
  rtb_VectorConcatenate_l[3] = rtb_Product_g[1] * rtb_Sum_be[0];

  /* Fcn: '<S99>/Fcn22' */
  rtb_VectorConcatenate_l[4] = rtb_Sum_be[2] * rtb_Sum_be[1] * rtb_Sum_be[0] +
    rtb_Product_g[2] * rtb_Product_g[0];

  /* Fcn: '<S99>/Fcn32' */
  rtb_VectorConcatenate_l[5] = rtb_Product_g[2] * rtb_Sum_be[1] * rtb_Sum_be[0]
    - rtb_Sum_be[2] * rtb_Product_g[0];

  /* Fcn: '<S99>/Fcn13' */
  rtb_VectorConcatenate_l[6] = -rtb_Sum_be[1];

  /* Fcn: '<S99>/Fcn23' */
  rtb_VectorConcatenate_l[7] = rtb_Sum_be[2] * rtb_Product_g[1];

  /* Fcn: '<S99>/Fcn33' */
  rtb_VectorConcatenate_l[8] = rtb_Product_g[2] * rtb_Product_g[1];

  /* Sum: '<S82>/Sum1' */
  rtb_Gain5_g = rtb_k_m_r[2] - Controller_B.Sum[2];

  /* Gain: '<S82>/Gain2' */
  rtb_Divide = Controller_P.Gain2_Gain_n * rtb_Gain5_g;

  /* Gain: '<S82>/Gain5' */
  rtb_Gain5_g *= Controller_P.Gain5_Gain_l;

  /* Product: '<S90>/Product' incorporates:
   *  Gain: '<S82>/Gain1'
   */
  for (k = 0; k < 3; k++) {
    rtb_VectorConcatenate_p_0[k] = rtb_VectorConcatenate_l[k + 6] *
      rtb_Sum3_c_idx + (rtb_VectorConcatenate_l[k + 3] * rtb_Sum3_c_idx_0 +
                        rtb_VectorConcatenate_l[k] * rtb_Sum3_c_idx_1);
  }

  /* End of Product: '<S90>/Product' */

  /* Sum: '<S82>/Sum' incorporates:
   *  Gain: '<S82>/Gain1'
   *  Gain: '<S82>/M'
   */
  for (k = 0; k < 3; k++) {
    tmp_2[k] = (((((Controller_P.Gain1_Gain_c[k + 3] *
                    rtb_VectorConcatenate_p_0[1] + Controller_P.Gain1_Gain_c[k] *
                    rtb_VectorConcatenate_p_0[0]) + Controller_P.Gain1_Gain_c[k
                   + 6] * rtb_VectorConcatenate_p_0[2]) + Controller_B.Gain4_k[k])
                 + rtb_TmpSignalConversionAtSFun_g[k]) + rtb_Divide) -
      rtb_sincos_o2[k];
  }

  /* End of Sum: '<S82>/Sum' */

  /* Gain: '<S82>/M' */
  for (k = 0; k < 3; k++) {
    Controller_B.M[k] = 0.0;
    Controller_B.M[k] += Controller_P.M_Gain[k] * tmp_2[0];
    Controller_B.M[k] += Controller_P.M_Gain[k + 3] * tmp_2[1];
    Controller_B.M[k] += Controller_P.M_Gain[k + 6] * tmp_2[2];
  }

  /* Trigonometry: '<S94>/sincos' */
  rtb_sincos_o2[0] = cos(rtb_frc_ctrl[0]);
  rtb_frc_ctrl[0] = sin(rtb_frc_ctrl[0]);
  rtb_sincos_o2[1] = cos(rtb_frc_ctrl[1]);
  rtb_frc_ctrl[1] = sin(rtb_frc_ctrl[1]);
  rtb_Divide = cos(rtb_frc_ctrl[2]);
  rtb_Normalization_idx_0 = sin(rtb_frc_ctrl[2]);

  /* Fcn: '<S94>/Fcn11' */
  rtb_VectorConcatenate_o[0] = rtb_sincos_o2[1] * rtb_sincos_o2[0];

  /* Fcn: '<S94>/Fcn21' incorporates:
   *  Trigonometry: '<S94>/sincos'
   */
  rtb_VectorConcatenate_o[1] = rtb_Normalization_idx_0 * rtb_frc_ctrl[1] *
    rtb_sincos_o2[0] - rtb_Divide * rtb_frc_ctrl[0];

  /* Fcn: '<S94>/Fcn31' incorporates:
   *  Trigonometry: '<S94>/sincos'
   */
  rtb_VectorConcatenate_o[2] = rtb_Divide * rtb_frc_ctrl[1] * rtb_sincos_o2[0] +
    rtb_Normalization_idx_0 * rtb_frc_ctrl[0];

  /* Fcn: '<S94>/Fcn12' */
  rtb_VectorConcatenate_o[3] = rtb_sincos_o2[1] * rtb_frc_ctrl[0];

  /* Fcn: '<S94>/Fcn22' incorporates:
   *  Trigonometry: '<S94>/sincos'
   */
  rtb_VectorConcatenate_o[4] = rtb_Normalization_idx_0 * rtb_frc_ctrl[1] *
    rtb_frc_ctrl[0] + rtb_Divide * rtb_sincos_o2[0];

  /* Fcn: '<S94>/Fcn32' incorporates:
   *  Trigonometry: '<S94>/sincos'
   */
  rtb_VectorConcatenate_o[5] = rtb_Divide * rtb_frc_ctrl[1] * rtb_frc_ctrl[0] -
    rtb_Normalization_idx_0 * rtb_sincos_o2[0];

  /* Fcn: '<S94>/Fcn13' */
  rtb_VectorConcatenate_o[6] = -rtb_frc_ctrl[1];

  /* Fcn: '<S94>/Fcn23' */
  rtb_VectorConcatenate_o[7] = rtb_Normalization_idx_0 * rtb_sincos_o2[1];

  /* Fcn: '<S94>/Fcn33' incorporates:
   *  Trigonometry: '<S94>/sincos'
   */
  rtb_VectorConcatenate_o[8] = rtb_Divide * rtb_sincos_o2[1];

  /* Sum: '<S91>/Sum' incorporates:
   *  Constant: '<S91>/Constant'
   */
  Controller_B.Sum_k[0] = rtb_Gain6[0] + Controller_P.Constant_Value_c;
  Controller_B.Sum_k[1] = rtb_Gain6[1] + Controller_P.Constant_Value_c;
  Controller_B.Sum_k[2] = rtb_Gain6[2] + rtb_Gain5_g;

  /* Gain: '<S93>/Gain' */
  rtb_Gain_i[0] = Controller_P.Gain_Gain_bh * Controller_B.rst[0];
  rtb_Gain_i[1] = Controller_P.Gain_Gain_bh * Controller_B.rst[1];
  rtb_Gain_i[2] = Controller_P.Gain_Gain_bh * Controller_B.rst[2];

  /* Gain: '<S82>/Gain3' incorporates:
   *  Sum: '<S82>/Sum2'
   */
  for (k = 0; k < 3; k++) {
    tmp_2[k] = Controller_P.Gain3_Gain_b[k + 6] * rtb_Sum3_c_idx +
      (Controller_P.Gain3_Gain_b[k + 3] * rtb_Sum3_c_idx_0 +
       Controller_P.Gain3_Gain_b[k] * rtb_Sum3_c_idx_1);
  }

  /* End of Gain: '<S82>/Gain3' */

  /* Product: '<S88>/Product' incorporates:
   *  Math: '<S95>/Math Function'
   *  Sum: '<S82>/Sum2'
   */
  for (k = 0; k < 3; k++) {
    rtb_VectorConcatenate_p_0[k] = rtb_VectorConcatenate_o[3 * k + 2] *
      Controller_B.Sum[2] + (rtb_VectorConcatenate_o[3 * k + 1] *
      Controller_B.Sum[1] + rtb_VectorConcatenate_o[3 * k] * Controller_B.Sum[0]);
  }

  /* End of Product: '<S88>/Product' */

  /* Sum: '<S82>/Sum2' */
  Controller_B.Sum2[0] = tmp_2[0] + rtb_VectorConcatenate_p_0[0];
  Controller_B.Sum2[1] = tmp_2[1] + rtb_VectorConcatenate_p_0[1];
  Controller_B.Sum2[2] = tmp_2[2] + rtb_VectorConcatenate_p_0[2];

  /* SignalConversion: '<S103>/TmpSignal ConversionAtGainInport1' */
  rtb_Sum1_pd_0[0] = rtb_Sum1_pd_idx;
  rtb_Sum1_pd_0[1] = rtb_Gain1_f;
  rtb_Sum1_pd_0[2] = rtb_Gain_ia;
  rtb_Sum1_pd_0[3] = rtb_TmpSignalConversionAtSFun_d[0];
  rtb_Sum1_pd_0[4] = rtb_TmpSignalConversionAtSFun_d[1];
  rtb_Sum1_pd_0[5] = rtb_TmpSignalConversionAtSFun_d[2];
  rtb_Sum1_pd_0[6] = rtb_TmpSignalConversionAtSFu_gy[0];
  rtb_Sum1_pd_0[7] = rtb_TmpSignalConversionAtSFu_gy[1];
  rtb_Sum1_pd_0[8] = rtb_TmpSignalConversionAtSFu_gy[2];
  rtb_Sum1_pd_0[9] = rtb_ypm[0];
  rtb_Sum1_pd_0[10] = rtb_ypm[1];
  rtb_Sum1_pd_0[11] = rtb_ypm[2];

  /* Gain: '<S103>/Gain' incorporates:
   *  SignalConversion: '<S103>/TmpSignal ConversionAtGainInport1'
   */
  for (k = 0; k < 12; k++) {
    rtb_theta_ctrl_hat[k] = 0.0;
    for (i = 0; i < 12; i++) {
      rtb_theta_ctrl_hat[k] += Controller_P.Gain_Gain_n[12 * i + k] *
        rtb_Sum1_pd_0[i];
    }
  }

  /* End of Gain: '<S103>/Gain' */

  /* Sum: '<S104>/Sum2' incorporates:
   *  Inport: '<Root>/D'
   *  Inport: '<Root>/E'
   */
  rtb_Sum2_a_idx_1 = rtb_Step - rtb_Sum2_a_idx_1;
  rtb_Sum2_a_idx_0 = Controller_U.E - rtb_Sum2_a_idx_0;
  rtb_Normalization_idx = Controller_U.D - rtb_Sum2_a_idx;

  /* Trigonometry: '<S109>/sincos' */
  rtb_TmpSignalConversionAtSFun_d[0] = cos(rtb_sincos_o1_idx_1);
  rtb_sincos_o1_idx_1 = sin(rtb_sincos_o1_idx_1);
  rtb_TmpSignalConversionAtSFun_d[1] = cos(rtb_sincos_o1_idx_0);
  rtb_sincos_o1_idx_0 = sin(rtb_sincos_o1_idx_0);
  rtb_Divide = cos(rtb_sincos_o1_idx);
  rtb_Normalization_idx_0 = sin(rtb_sincos_o1_idx);

  /* Fcn: '<S109>/Fcn11' */
  rtb_VectorConcatenate_kr[0] = rtb_TmpSignalConversionAtSFun_d[1] *
    rtb_TmpSignalConversionAtSFun_d[0];

  /* Fcn: '<S109>/Fcn21' incorporates:
   *  Trigonometry: '<S109>/sincos'
   */
  rtb_VectorConcatenate_kr[1] = rtb_Normalization_idx_0 * rtb_sincos_o1_idx_0 *
    rtb_TmpSignalConversionAtSFun_d[0] - rtb_Divide * rtb_sincos_o1_idx_1;

  /* Fcn: '<S109>/Fcn31' incorporates:
   *  Trigonometry: '<S109>/sincos'
   */
  rtb_VectorConcatenate_kr[2] = rtb_Divide * rtb_sincos_o1_idx_0 *
    rtb_TmpSignalConversionAtSFun_d[0] + rtb_Normalization_idx_0 *
    rtb_sincos_o1_idx_1;

  /* Fcn: '<S109>/Fcn12' */
  rtb_VectorConcatenate_kr[3] = rtb_TmpSignalConversionAtSFun_d[1] *
    rtb_sincos_o1_idx_1;

  /* Fcn: '<S109>/Fcn22' incorporates:
   *  Trigonometry: '<S109>/sincos'
   */
  rtb_VectorConcatenate_kr[4] = rtb_Normalization_idx_0 * rtb_sincos_o1_idx_0 *
    rtb_sincos_o1_idx_1 + rtb_Divide * rtb_TmpSignalConversionAtSFun_d[0];

  /* Fcn: '<S109>/Fcn32' incorporates:
   *  Trigonometry: '<S109>/sincos'
   */
  rtb_VectorConcatenate_kr[5] = rtb_Divide * rtb_sincos_o1_idx_0 *
    rtb_sincos_o1_idx_1 - rtb_Normalization_idx_0 *
    rtb_TmpSignalConversionAtSFun_d[0];

  /* Fcn: '<S109>/Fcn13' */
  rtb_VectorConcatenate_kr[6] = -rtb_sincos_o1_idx_0;

  /* Fcn: '<S109>/Fcn23' */
  rtb_VectorConcatenate_kr[7] = rtb_Normalization_idx_0 *
    rtb_TmpSignalConversionAtSFun_d[1];

  /* Fcn: '<S109>/Fcn33' incorporates:
   *  Trigonometry: '<S109>/sincos'
   */
  rtb_VectorConcatenate_kr[8] = rtb_Divide * rtb_TmpSignalConversionAtSFun_d[1];

  /* Sum: '<S104>/Sum1' incorporates:
   *  Integrator: '<S108>/Integrator'
   *  Math: '<S105>/transpose'
   *  Product: '<S104>/Product'
   */
  for (k = 0; k < 3; k++) {
    rtb_ypm[k] = ((rtb_VectorConcatenate_kr[3 * k + 1] * rtb_theta_ctrl_hat[1] +
                   rtb_VectorConcatenate_kr[3 * k] * rtb_theta_ctrl_hat[0]) +
                  rtb_VectorConcatenate_kr[3 * k + 2] * rtb_theta_ctrl_hat[2]) +
      Controller_X.Integrator_CSTATE_l[k];
  }

  /* End of Sum: '<S104>/Sum1' */

  /* Sum: '<S104>/Sum3' incorporates:
   *  Gain: '<S104>/Gain1'
   */
  for (k = 0; k < 3; k++) {
    Controller_B.Sum3[k] = ((Controller_P.Gain1_Gain_g[k + 3] * rtb_Sum2_a_idx_0
      + Controller_P.Gain1_Gain_g[k] * rtb_Sum2_a_idx_1) +
      Controller_P.Gain1_Gain_g[k + 6] * rtb_Normalization_idx) +
      rtb_Integrator_d[k];
  }

  /* End of Sum: '<S104>/Sum3' */

  /* Sum: '<S104>/Sum4' incorporates:
   *  Gain: '<S104>/Gain'
   */
  for (k = 0; k < 3; k++) {
    Controller_B.Sum4[k] = ((Controller_P.Gain_Gain_hw[k + 3] * rtb_Sum2_a_idx_0
      + Controller_P.Gain_Gain_hw[k] * rtb_Sum2_a_idx_1) +
      Controller_P.Gain_Gain_hw[k + 6] * rtb_Normalization_idx) + rtb_ypm[k];
  }

  /* End of Sum: '<S104>/Sum4' */

  /* Gain: '<S108>/Gain' */
  for (k = 0; k < 3; k++) {
    Controller_B.Gain_n[k] = 0.0;
    Controller_B.Gain_n[k] += Controller_P.Gain_Gain_j[k] * rtb_Sum2_a_idx_1;
    Controller_B.Gain_n[k] += Controller_P.Gain_Gain_j[k + 3] * rtb_Sum2_a_idx_0;
    Controller_B.Gain_n[k] += Controller_P.Gain_Gain_j[k + 6] *
      rtb_Normalization_idx;
  }

  /* End of Gain: '<S108>/Gain' */

  /* Sum: '<S106>/Sum1' incorporates:
   *  Integrator: '<S106>/Integrator1'
   */
  rtb_TmpSignalConversionAtSFu_gy[0] = rtb_TransferFcn -
    Controller_X.Integrator1_CSTATE_b[0];
  rtb_TmpSignalConversionAtSFu_gy[1] = rtb_TransferFcn1 -
    Controller_X.Integrator1_CSTATE_b[1];
  rtb_TmpSignalConversionAtSFu_gy[2] = rtb_TransferFcn2 -
    Controller_X.Integrator1_CSTATE_b[2];

  /* MATLAB Function: '<S106>/MATLAB Function1' incorporates:
   *  SignalConversion: '<S112>/TmpSignal ConversionAt SFunction Inport2'
   */
  /* MATLAB Function 'Controll system/Observers/Kinematic observer/Rot observer/MATLAB Function1': '<S112>:1' */
  /* '<S112>:1:4' roll = attitude(1); */
  /* '<S112>:1:5' pitch = attitude(2); */
  /* DD = [1 sin(pitch)*tan(roll) cos(pitch)*tan(roll); 0 cos(pitch) -sin(pitch); 0 sin(pitch)/cos(roll) cos(pitch)/cos(roll)]; */
  /* '<S112>:1:8' DD_inv = [1 0 -sin(roll);0 cos(pitch) cos(roll)*sin(pitch);0 -sin(pitch) cos(roll)*cos(pitch)]; */
  /* '<S112>:1:10' error_w = DD_inv*error; */
  tmp_3[0] = 1.0;
  tmp_3[3] = 0.0;
  tmp_3[6] = -sin(rtb_TransferFcn);
  tmp_3[1] = 0.0;
  tmp_3[4] = cos(rtb_TransferFcn1);
  tmp_3[7] = cos(rtb_TransferFcn) * sin(rtb_TransferFcn1);
  tmp_3[2] = 0.0;
  tmp_3[5] = -sin(rtb_TransferFcn1);
  tmp_3[8] = cos(rtb_TransferFcn) * cos(rtb_TransferFcn1);
  for (k = 0; k < 3; k++) {
    Controller_B.error_w[k] = 0.0;
    Controller_B.error_w[k] += tmp_3[k] * rtb_TmpSignalConversionAtSFu_gy[0];
    Controller_B.error_w[k] += tmp_3[k + 3] * rtb_TmpSignalConversionAtSFu_gy[1];
    Controller_B.error_w[k] += tmp_3[k + 6] * rtb_TmpSignalConversionAtSFu_gy[2];
  }

  /* End of MATLAB Function: '<S106>/MATLAB Function1' */

  /* Sum: '<S106>/Sum4' incorporates:
   *  Gain: '<S106>/Gain2'
   *  Integrator: '<S106>/Integrator2'
   */
  /* MATLAB Function 'Controll system/Observers/Kinematic observer/Rot observer/MATLAB Function': '<S111>:1' */
  /* '<S111>:1:4' roll = attitude(1); */
  /* '<S111>:1:5' pitch = attitude(2); */
  /* '<S111>:1:7' DD = [1 sin(pitch)*tan(roll) cos(pitch)*tan(roll); 0 cos(pitch) -sin(pitch); 0 sin(pitch)/cos(roll) cos(pitch)/cos(roll)]; */
  /* '<S111>:1:10' theta_dot = DD*gyro; */
  rtb_Product_g[0] = Controller_P.Gain2_Gain_a *
    Controller_X.Integrator2_CSTATE_h[0] + rtb_theta_ctrl_hat[3];
  rtb_Product_g[1] = Controller_P.Gain2_Gain_a *
    Controller_X.Integrator2_CSTATE_h[1] + rtb_theta_ctrl_hat[4];
  rtb_Product_g[2] = Controller_P.Gain2_Gain_a *
    Controller_X.Integrator2_CSTATE_h[2] + rtb_theta_ctrl_hat[5];

  /* Sum: '<S106>/Sum' incorporates:
   *  Gain: '<S106>/Gain1'
   *  Gain: '<S106>/Gain3'
   *  Sum: '<S106>/Sum3'
   *  Sum: '<S106>/Sum5'
   */
  Controller_B.Sum_o[0] = (rtb_Sum_g[0] - Controller_B.Integrator[0]) *
    Controller_P.Gain1_Gain_gv + (Controller_P.Gain3_Gain_i *
    Controller_B.error_w[0] + rtb_Product_g[0]);
  Controller_B.Sum_o[1] = (rtb_Sum_g[1] - Controller_B.Integrator[1]) *
    Controller_P.Gain1_Gain_gv + (Controller_P.Gain3_Gain_i *
    Controller_B.error_w[1] + rtb_Product_g[1]);
  Controller_B.Sum_o[2] = (rtb_Sum_g[2] - Controller_B.Integrator[2]) *
    Controller_P.Gain1_Gain_gv + (Controller_P.Gain3_Gain_i *
    Controller_B.error_w[2] + rtb_Product_g[2]);

  /* MATLAB Function: '<S106>/MATLAB Function' incorporates:
   *  SignalConversion: '<S111>/TmpSignal ConversionAt SFunction Inport1'
   */
  tmp_4[0] = 1.0;
  tmp_4[3] = sin(rtb_TransferFcn1) * tan(rtb_TransferFcn);
  tmp_4[6] = cos(rtb_TransferFcn1) * tan(rtb_TransferFcn);
  tmp_4[1] = 0.0;
  tmp_4[4] = cos(rtb_TransferFcn1);
  tmp_4[7] = -sin(rtb_TransferFcn1);
  tmp_4[2] = 0.0;
  tmp_4[5] = sin(rtb_TransferFcn1) / cos(rtb_TransferFcn);
  tmp_4[8] = cos(rtb_TransferFcn1) / cos(rtb_TransferFcn);

  /* Sum: '<S106>/Sum2' incorporates:
   *  Gain: '<S106>/Gain'
   *  MATLAB Function: '<S106>/MATLAB Function'
   */
  for (k = 0; k < 3; k++) {
    Controller_B.Sum2_g[k] = ((tmp_4[k + 3] * Controller_B.Integrator[1] +
      tmp_4[k] * Controller_B.Integrator[0]) + tmp_4[k + 6] *
      Controller_B.Integrator[2]) + Controller_P.Gain_Gain_e *
      rtb_TmpSignalConversionAtSFu_gy[k];
  }

  /* End of Sum: '<S106>/Sum2' */

  /* Product: '<S107>/Product' incorporates:
   *  SignalConversion: '<S107>/TmpSignal ConversionAtMInport1'
   */
  for (k = 0; k < 3; k++) {
    rtb_VectorConcatenate_p_0[k] = rtb_VectorConcatenate_d[k + 6] * rtb_ypm[2] +
      (rtb_VectorConcatenate_d[k + 3] * rtb_ypm[1] + rtb_VectorConcatenate_d[k] *
       rtb_ypm[0]);
  }

  /* End of Product: '<S107>/Product' */

  /* SignalConversion: '<S107>/TmpSignal ConversionAtMInport1' */
  rtb_TmpSignalConversionAtSFu_gy[2] = rtb_Product_g[2];

  /* Gain: '<S107>/M' incorporates:
   *  SignalConversion: '<S107>/TmpSignal ConversionAtMInport1'
   */
  for (k = 0; k < 3; k++) {
    rtb_Product_g[k] = Controller_P.M_Gain_a[k + 6] *
      rtb_TmpSignalConversionAtSFu_gy[2] + (Controller_P.M_Gain_a[k + 3] *
      rtb_VectorConcatenate_p_0[1] + Controller_P.M_Gain_a[k] *
      rtb_VectorConcatenate_p_0[0]);
  }

  /* End of Gain: '<S107>/M' */

  /* Sum: '<S107>/Sum5' incorporates:
   *  Sum: '<S107>/Sum'
   */
  rtb_Sum5_o_idx_1 = (rtb_Product_g[0] - rtb_Integrator_idx_1) -
    rtb_Sum5_o_idx_1;
  rtb_Sum5_o_idx_0 = (rtb_Product_g[1] - rtb_Integrator_idx_0) -
    rtb_Sum5_o_idx_0;
  rtb_Normalization_idx_0 = (rtb_Product_g[2] - rtb_Integrator_idx) -
    rtb_Sum5_o_idx;

  /* Gain: '<S107>/Gain2' */
  for (k = 0; k < 3; k++) {
    Controller_B.Gain2[k] = 0.0;
    Controller_B.Gain2[k] += Controller_P.Gain2_Gain_ni[k] * rtb_Sum5_o_idx_1;
    Controller_B.Gain2[k] += Controller_P.Gain2_Gain_ni[k + 3] *
      rtb_Sum5_o_idx_0;
    Controller_B.Gain2[k] += Controller_P.Gain2_Gain_ni[k + 6] *
      rtb_Normalization_idx_0;
  }

  /* End of Gain: '<S107>/Gain2' */
  if (rtmIsMajorTimeStep(Controller_M)) {
  }

  /* Trigonometry: '<S125>/sincos' incorporates:
   *  SignalConversion: '<S120>/TmpSignal ConversionAtsincosInport1'
   */
  rtb_Product_g[0] = sin(rtb_Integrator6[5]);
  rtb_TmpSignalConversionAtSFu_gy[0] = cos(rtb_Integrator6[5]);
  rtb_Product_g[1] = sin(rtb_Integrator6[4]);
  rtb_TmpSignalConversionAtSFu_gy[1] = cos(rtb_Integrator6[4]);
  rtb_Product_g[2] = sin(rtb_Integrator6[3]);
  rtb_TmpSignalConversionAtSFu_gy[2] = cos(rtb_Integrator6[3]);

  /* Fcn: '<S125>/Fcn11' */
  rtb_VectorConcatenate_b[0] = rtb_TmpSignalConversionAtSFu_gy[1] *
    rtb_TmpSignalConversionAtSFu_gy[0];

  /* Fcn: '<S125>/Fcn21' */
  rtb_VectorConcatenate_b[1] = rtb_Product_g[2] * rtb_Product_g[1] *
    rtb_TmpSignalConversionAtSFu_gy[0] - rtb_TmpSignalConversionAtSFu_gy[2] *
    rtb_Product_g[0];

  /* Fcn: '<S125>/Fcn31' */
  rtb_VectorConcatenate_b[2] = rtb_TmpSignalConversionAtSFu_gy[2] *
    rtb_Product_g[1] * rtb_TmpSignalConversionAtSFu_gy[0] + rtb_Product_g[2] *
    rtb_Product_g[0];

  /* Fcn: '<S125>/Fcn12' */
  rtb_VectorConcatenate_b[3] = rtb_TmpSignalConversionAtSFu_gy[1] *
    rtb_Product_g[0];

  /* Fcn: '<S125>/Fcn22' */
  rtb_VectorConcatenate_b[4] = rtb_Product_g[2] * rtb_Product_g[1] *
    rtb_Product_g[0] + rtb_TmpSignalConversionAtSFu_gy[2] *
    rtb_TmpSignalConversionAtSFu_gy[0];

  /* Fcn: '<S125>/Fcn32' */
  rtb_VectorConcatenate_b[5] = rtb_TmpSignalConversionAtSFu_gy[2] *
    rtb_Product_g[1] * rtb_Product_g[0] - rtb_Product_g[2] *
    rtb_TmpSignalConversionAtSFu_gy[0];

  /* Fcn: '<S125>/Fcn13' */
  rtb_VectorConcatenate_b[6] = -rtb_Product_g[1];

  /* Fcn: '<S125>/Fcn23' */
  rtb_VectorConcatenate_b[7] = rtb_Product_g[2] *
    rtb_TmpSignalConversionAtSFu_gy[1];

  /* Fcn: '<S125>/Fcn33' */
  rtb_VectorConcatenate_b[8] = rtb_TmpSignalConversionAtSFu_gy[2] *
    rtb_TmpSignalConversionAtSFu_gy[1];

  /* Sum: '<S84>/Sum3' */
  rtb_Product_g[0] = rtb_Integrator6[0] - Controller_B.Integrator1[0];
  rtb_Product_g[1] = rtb_Integrator6[1] - Controller_B.Integrator1[1];
  rtb_Product_g[2] = rtb_Integrator6[5] - Controller_B.Integrator1[2];

  /* Sum: '<S84>/Sum1' */
  rtb_Step = rtb_Gain1_l_idx - Controller_B.Integrator_o[2];

  /* Gain: '<S84>/Gain2' */
  rtb_Divide = Controller_P.Gain2_Gain_l1 * rtb_Step;

  /* Gain: '<S84>/Gain3' */
  for (k = 0; k < 3; k++) {
    rtb_TmpSignalConversionAtSFu_gy[k] = Controller_P.Gain3_Gain_bo[k + 6] *
      rtb_Product_g[2] + (Controller_P.Gain3_Gain_bo[k + 3] * rtb_Product_g[1] +
                          Controller_P.Gain3_Gain_bo[k] * rtb_Product_g[0]);
  }

  /* End of Gain: '<S84>/Gain3' */

  /* Gain: '<S84>/Gain5' */
  rtb_Step *= Controller_P.Gain5_Gain_o;

  /* Gain: '<S84>/Gain6' */
  for (k = 0; k < 3; k++) {
    rtb_ypm[k] = Controller_P.Gain6_Gain_k[k + 6] * rtb_Product_g[2] +
      (Controller_P.Gain6_Gain_k[k + 3] * rtb_Product_g[1] +
       Controller_P.Gain6_Gain_k[k] * rtb_Product_g[0]);
  }

  /* End of Gain: '<S84>/Gain6' */

  /* Product: '<S118>/Product' incorporates:
   *  Gain: '<S84>/Gain1'
   */
  for (k = 0; k < 3; k++) {
    rtb_VectorConcatenate_p_0[k] = rtb_VectorConcatenate_b[k + 6] *
      rtb_Product_g[2] + (rtb_VectorConcatenate_b[k + 3] * rtb_Product_g[1] +
                          rtb_VectorConcatenate_b[k] * rtb_Product_g[0]);
  }

  /* End of Product: '<S118>/Product' */

  /* Sum: '<S84>/Sum' incorporates:
   *  Gain: '<S84>/Gain1'
   *  Gain: '<S84>/M'
   */
  for (k = 0; k < 3; k++) {
    tmp_2[k] = (((((Controller_P.Gain1_Gain_fq[k + 3] *
                    rtb_VectorConcatenate_p_0[1] + Controller_P.Gain1_Gain_fq[k]
                    * rtb_VectorConcatenate_p_0[0]) +
                   Controller_P.Gain1_Gain_fq[k + 6] *
                   rtb_VectorConcatenate_p_0[2]) + Controller_B.Gain4[k]) +
                 rtb_TmpSignalConversionAtSFun_n[k]) + rtb_Divide) - rtb_D[k];
  }

  /* End of Sum: '<S84>/Sum' */

  /* Gain: '<S84>/M' */
  for (k = 0; k < 3; k++) {
    Controller_B.M_j[k] = 0.0;
    Controller_B.M_j[k] += Controller_P.M_Gain_g[k] * tmp_2[0];
    Controller_B.M_j[k] += Controller_P.M_Gain_g[k + 3] * tmp_2[1];
    Controller_B.M_j[k] += Controller_P.M_Gain_g[k + 6] * tmp_2[2];
  }

  /* Trigonometry: '<S120>/sincos' incorporates:
   *  SignalConversion: '<S120>/TmpSignal ConversionAtsincosInport1'
   */
  rtb_Product_g[0] = cos(rtb_Integrator6[5]);
  rtb_Normalization_idx_0 = sin(rtb_Integrator6[5]);
  rtb_Product_g[1] = cos(rtb_sincos_o1_e_idx);
  rtb_sincos_o1_e_idx = sin(rtb_sincos_o1_e_idx);
  rtb_Divide = cos(rtb_Integrator6[3]);
  rtb_Normalization_idx = sin(rtb_Integrator6[3]);

  /* Fcn: '<S120>/Fcn11' */
  rtb_VectorConcatenate_ou[0] = rtb_Product_g[1] * rtb_Product_g[0];

  /* Fcn: '<S120>/Fcn21' incorporates:
   *  Trigonometry: '<S120>/sincos'
   */
  rtb_VectorConcatenate_ou[1] = rtb_Normalization_idx * rtb_sincos_o1_e_idx *
    rtb_Product_g[0] - rtb_Divide * rtb_Normalization_idx_0;

  /* Fcn: '<S120>/Fcn31' incorporates:
   *  Trigonometry: '<S120>/sincos'
   */
  rtb_VectorConcatenate_ou[2] = rtb_Divide * rtb_sincos_o1_e_idx *
    rtb_Product_g[0] + rtb_Normalization_idx * rtb_Normalization_idx_0;

  /* Fcn: '<S120>/Fcn12' */
  rtb_VectorConcatenate_ou[3] = rtb_Product_g[1] * rtb_Normalization_idx_0;

  /* Fcn: '<S120>/Fcn22' incorporates:
   *  Trigonometry: '<S120>/sincos'
   */
  rtb_VectorConcatenate_ou[4] = rtb_Normalization_idx * rtb_sincos_o1_e_idx *
    rtb_Normalization_idx_0 + rtb_Divide * rtb_Product_g[0];

  /* Fcn: '<S120>/Fcn32' incorporates:
   *  Trigonometry: '<S120>/sincos'
   */
  rtb_VectorConcatenate_ou[5] = rtb_Divide * rtb_sincos_o1_e_idx *
    rtb_Normalization_idx_0 - rtb_Normalization_idx * rtb_Product_g[0];

  /* Fcn: '<S120>/Fcn13' */
  rtb_VectorConcatenate_ou[6] = -rtb_sincos_o1_e_idx;

  /* Fcn: '<S120>/Fcn23' */
  rtb_VectorConcatenate_ou[7] = rtb_Normalization_idx * rtb_Product_g[1];

  /* Fcn: '<S120>/Fcn33' incorporates:
   *  Trigonometry: '<S120>/sincos'
   */
  rtb_VectorConcatenate_ou[8] = rtb_Divide * rtb_Product_g[1];

  /* Sum: '<S119>/Sum' incorporates:
   *  Constant: '<S119>/Constant'
   */
  rtb_ypm[0] += Controller_P.Constant_Value_k;
  rtb_ypm[1] += Controller_P.Constant_Value_k;

  /* Sum: '<S119>/Sum1' incorporates:
   *  Gain: '<S119>/Gain'
   *  Sum: '<S119>/Sum'
   */
  Controller_B.Sum1[0] = rtb_ypm[0] - Controller_P.Gain_Gain_k3 *
    rtb_Integrator2_n_idx_1;
  Controller_B.Sum1[1] = rtb_ypm[1] - Controller_P.Gain_Gain_k3 *
    rtb_Integrator2_n_idx_0;
  Controller_B.Sum1[2] = (rtb_ypm[2] + rtb_Step) - Controller_P.Gain_Gain_k3 *
    rtb_Integrator2_n_idx;

  /* Sum: '<S84>/Sum2' incorporates:
   *  Math: '<S121>/Math Function'
   *  Product: '<S116>/Product'
   */
  for (k = 0; k < 3; k++) {
    Controller_B.Sum2_h[k] = ((rtb_VectorConcatenate_ou[3 * k + 1] *
      Controller_B.Integrator_o[1] + rtb_VectorConcatenate_ou[3 * k] *
      Controller_B.Integrator_o[0]) + rtb_VectorConcatenate_ou[3 * k + 2] *
      Controller_B.Integrator_o[2]) + rtb_TmpSignalConversionAtSFu_gy[k];
  }

  /* End of Sum: '<S84>/Sum2' */

  /* Gain: '<S14>/Gain1' incorporates:
   *  Sum: '<S14>/Sum'
   */
  Controller_B.Gain1_b[0] = (rtb_Gain_pk[0] - rtb_Integrator_idx_1) *
    Controller_P.Gain1_Gain_kt;
  Controller_B.Gain1_b[1] = (rtb_Gain_pk[1] - rtb_Integrator_idx_0) *
    Controller_P.Gain1_Gain_kt;
  Controller_B.Gain1_b[2] = (rtb_Gain_pk[2] - rtb_Integrator_idx) *
    Controller_P.Gain1_Gain_kt;

  /* Step: '<S3>/Step' */
  if (Controller_M->Timing.t[0] < Controller_P.Step_Time_p) {
    rtb_Normalization_idx = Controller_P.Step_Y0_m;
  } else {
    rtb_Normalization_idx = Controller_P.Step_YFinal_a;
  }

  /* End of Step: '<S3>/Step' */

  /* Product: '<S3>/Product' incorporates:
   *  Inport: '<Root>/v_r'
   */
  Controller_B.Product = Controller_U.v_r * rtb_Normalization_idx;
  if (rtmIsMajorTimeStep(Controller_M)) {
    /* Outport: '<Root>/tau_Z' incorporates:
     *  Constant: '<Root>/Constant'
     */
    Controller_Y.tau_Z = Controller_P.Constant_Value_f[0];

    /* Outport: '<Root>/tau_K' incorporates:
     *  Constant: '<Root>/Constant'
     */
    Controller_Y.tau_K = Controller_P.Constant_Value_f[1];

    /* Outport: '<Root>/tau_M' incorporates:
     *  Constant: '<Root>/Constant'
     */
    Controller_Y.tau_M = Controller_P.Constant_Value_f[2];
  }

  if (rtmIsMajorTimeStep(Controller_M)) {
    /* Matfile logging */
    rt_UpdateTXYLogVars(Controller_M->rtwLogInfo, (Controller_M->Timing.t));
  }                                    /* end MajorTimeStep */

  if (rtmIsMajorTimeStep(Controller_M)) {
    /* Update for TransportDelay: '<S93>/Transport Delay' */
    {
      real_T **uBuffer = (real_T**)
        &Controller_DWork.TransportDelay_PWORK.TUbufferPtrs[0];
      real_T **tBuffer = (real_T**)
        &Controller_DWork.TransportDelay_PWORK.TUbufferPtrs[3];
      real_T simTime = Controller_M->Timing.t[0];
      boolean_T bufferisfull = FALSE;
      Controller_DWork.TransportDelay_IWORK.Head[0] =
        ((Controller_DWork.TransportDelay_IWORK.Head[0] <
          (Controller_DWork.TransportDelay_IWORK.CircularBufSize[0]-1)) ?
         (Controller_DWork.TransportDelay_IWORK.Head[0]+1) : 0);
      if (Controller_DWork.TransportDelay_IWORK.Head[0] ==
          Controller_DWork.TransportDelay_IWORK.Tail[0]) {
        bufferisfull = TRUE;
        Controller_DWork.TransportDelay_IWORK.Tail[0] =
          ((Controller_DWork.TransportDelay_IWORK.Tail[0] <
            (Controller_DWork.TransportDelay_IWORK.CircularBufSize[0]-1)) ?
           (Controller_DWork.TransportDelay_IWORK.Tail[0]+1) : 0);
      }

      (*tBuffer++)[Controller_DWork.TransportDelay_IWORK.Head[0]] = simTime;
      (*uBuffer++)[Controller_DWork.TransportDelay_IWORK.Head[0]] = rtb_Gain_i[0];
      Controller_DWork.TransportDelay_IWORK.Head[1] =
        ((Controller_DWork.TransportDelay_IWORK.Head[1] <
          (Controller_DWork.TransportDelay_IWORK.CircularBufSize[1]-1)) ?
         (Controller_DWork.TransportDelay_IWORK.Head[1]+1) : 0);
      if (Controller_DWork.TransportDelay_IWORK.Head[1] ==
          Controller_DWork.TransportDelay_IWORK.Tail[1]) {
        bufferisfull = TRUE;
        Controller_DWork.TransportDelay_IWORK.Tail[1] =
          ((Controller_DWork.TransportDelay_IWORK.Tail[1] <
            (Controller_DWork.TransportDelay_IWORK.CircularBufSize[1]-1)) ?
           (Controller_DWork.TransportDelay_IWORK.Tail[1]+1) : 0);
      }

      (*tBuffer++)[Controller_DWork.TransportDelay_IWORK.Head[1]] = simTime;
      (*uBuffer++)[Controller_DWork.TransportDelay_IWORK.Head[1]] = rtb_Gain_i[1];
      Controller_DWork.TransportDelay_IWORK.Head[2] =
        ((Controller_DWork.TransportDelay_IWORK.Head[2] <
          (Controller_DWork.TransportDelay_IWORK.CircularBufSize[2]-1)) ?
         (Controller_DWork.TransportDelay_IWORK.Head[2]+1) : 0);
      if (Controller_DWork.TransportDelay_IWORK.Head[2] ==
          Controller_DWork.TransportDelay_IWORK.Tail[2]) {
        bufferisfull = TRUE;
        Controller_DWork.TransportDelay_IWORK.Tail[2] =
          ((Controller_DWork.TransportDelay_IWORK.Tail[2] <
            (Controller_DWork.TransportDelay_IWORK.CircularBufSize[2]-1)) ?
           (Controller_DWork.TransportDelay_IWORK.Tail[2]+1) : 0);
      }

      (*tBuffer)[Controller_DWork.TransportDelay_IWORK.Head[2]] = simTime;
      (*uBuffer)[Controller_DWork.TransportDelay_IWORK.Head[2]] = rtb_Gain_i[2];
      if (bufferisfull) {
        rtsiSetSolverNeedsReset(&Controller_M->solverInfo, TRUE);
        rtsiSetBlkStateChange(&Controller_M->solverInfo, TRUE);
      }
    }

    /* Update for Integrator: '<S93>/Integrator1' */
    Controller_DWork.Integrator1_IWORK.IcNeedsLoading = 0;

    /* Update for Integrator: '<S93>/Integrator2' */
    Controller_DWork.Integrator2_IWORK.IcNeedsLoading = 0;

    /* Update for Integrator: '<S93>/Integrator3' */
    Controller_DWork.Integrator3_IWORK.IcNeedsLoading = 0;
    if (rtmIsMajorTimeStep(Controller_M)) {
      /* Update for RandomNumber: '<S58>/White Noise' */
      Controller_DWork.NextOutput = rt_nrand_Upu32_Yd_f_pw_snf
        (&Controller_DWork.RandSeed) * Controller_P.WhiteNoise_StdDev +
        Controller_P.WhiteNoise_Mean;
    }

    if (rtmIsMajorTimeStep(Controller_M)) {
      /* Update for RandomNumber: '<S63>/White Noise' */
      Controller_DWork.NextOutput_k = rt_nrand_Upu32_Yd_f_pw_snf
        (&Controller_DWork.RandSeed_f) * Controller_P.WhiteNoise_StdDev_b +
        Controller_P.WhiteNoise_Mean_f;
    }

    if (rtmIsMajorTimeStep(Controller_M)) {
      /* Update for RandomNumber: '<S68>/White Noise' */
      Controller_DWork.NextOutput_f = rt_nrand_Upu32_Yd_f_pw_snf
        (&Controller_DWork.RandSeed_p) * Controller_P.WhiteNoise_StdDev_h +
        Controller_P.WhiteNoise_Mean_g;
    }

    if (rtmIsMajorTimeStep(Controller_M)) {
      /* Update for RandomNumber: '<S73>/White Noise' */
      Controller_DWork.NextOutput_c = rt_nrand_Upu32_Yd_f_pw_snf
        (&Controller_DWork.RandSeed_a) * Controller_P.WhiteNoise_StdDev_d +
        Controller_P.WhiteNoise_Mean_j;
    }

    if (rtmIsMajorTimeStep(Controller_M)) {
      /* Update for RandomNumber: '<S75>/White Noise' */
      Controller_DWork.NextOutput_m[0] = rt_nrand_Upu32_Yd_f_pw_snf
        (&Controller_DWork.RandSeed_fl[0]) * Controller_P.WhiteNoise_StdDev_j +
        Controller_P.WhiteNoise_Mean_p;
      Controller_DWork.NextOutput_m[1] = rt_nrand_Upu32_Yd_f_pw_snf
        (&Controller_DWork.RandSeed_fl[1]) * Controller_P.WhiteNoise_StdDev_j +
        Controller_P.WhiteNoise_Mean_p;
      Controller_DWork.NextOutput_m[2] = rt_nrand_Upu32_Yd_f_pw_snf
        (&Controller_DWork.RandSeed_fl[2]) * Controller_P.WhiteNoise_StdDev_j +
        Controller_P.WhiteNoise_Mean_p;
    }

    /* BlkStateChangeFlag is set, need to run a minor output */
    if (rtmIsMajorTimeStep(Controller_M)) {
      if (rtsiGetBlkStateChange(&Controller_M->solverInfo)) {
        rtsiSetSimTimeStep(&Controller_M->solverInfo,MINOR_TIME_STEP);
        rtsiSetBlkStateChange(&Controller_M->solverInfo, FALSE);
        Controller_step();
        rtsiSetSimTimeStep(&Controller_M->solverInfo, MAJOR_TIME_STEP);
      }
    }
  }                                    /* end MajorTimeStep */

  if (rtmIsMajorTimeStep(Controller_M)) {
    /* signal main to stop simulation */
    {                                  /* Sample time: [0.0s, 0.0s] */
      if ((rtmGetTFinal(Controller_M)!=-1) &&
          !((rtmGetTFinal(Controller_M)-(((Controller_M->Timing.clockTick1+
               Controller_M->Timing.clockTickH1* 4294967296.0)) * 0.01)) >
            (((Controller_M->Timing.clockTick1+Controller_M->Timing.clockTickH1*
               4294967296.0)) * 0.01) * (DBL_EPSILON))) {
        rtmSetErrorStatus(Controller_M, "Simulation finished");
      }
    }

    rt_ertODEUpdateContinuousStates(&Controller_M->solverInfo);

    /* Update absolute time for base rate */
    /* The "clockTick0" counts the number of times the code of this task has
     * been executed. The absolute time is the multiplication of "clockTick0"
     * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
     * overflow during the application lifespan selected.
     * Timer of this task consists of two 32 bit unsigned integers.
     * The two integers represent the low bits Timing.clockTick0 and the high bits
     * Timing.clockTickH0. When the low bit overflows to 0, the high bits increment.
     */
    if (!(++Controller_M->Timing.clockTick0)) {
      ++Controller_M->Timing.clockTickH0;
    }

    Controller_M->Timing.t[0] = rtsiGetSolverStopTime(&Controller_M->solverInfo);

    {
      /* Update absolute timer for sample time: [0.01s, 0.0s] */
      /* The "clockTick1" counts the number of times the code of this task has
       * been executed. The resolution of this integer timer is 0.01, which is the step size
       * of the task. Size of "clockTick1" ensures timer will not overflow during the
       * application lifespan selected.
       * Timer of this task consists of two 32 bit unsigned integers.
       * The two integers represent the low bits Timing.clockTick1 and the high bits
       * Timing.clockTickH1. When the low bit overflows to 0, the high bits increment.
       */
      Controller_M->Timing.clockTick1++;
      if (!Controller_M->Timing.clockTick1) {
        Controller_M->Timing.clockTickH1++;
      }
    }
  }                                    /* end MajorTimeStep */
}

/* Derivatives for root system: '<Root>' */
void Controller_derivatives(void)
{
  int32_T i;
  StateDerivatives_Controller *_rtXdot;
  _rtXdot = ((StateDerivatives_Controller *) Controller_M->ModelData.derivs);

  /* Derivatives for Integrator: '<S14>/Integrator' */
  _rtXdot->Integrator_CSTATE[0] = Controller_B.Gain1_b[0];
  _rtXdot->Integrator_CSTATE[1] = Controller_B.Gain1_b[1];
  _rtXdot->Integrator_CSTATE[2] = Controller_B.Gain1_b[2];

  /* Derivatives for Integrator: '<S104>/Integrator1' */
  _rtXdot->Integrator1_CSTATE[0] = Controller_B.Sum3[0];
  _rtXdot->Integrator1_CSTATE[1] = Controller_B.Sum3[1];
  _rtXdot->Integrator1_CSTATE[2] = Controller_B.Sum3[2];

  /* Derivatives for TransferFcn: '<S77>/Transfer Fcn2' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE[0] = Controller_U.yaw;
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE[0] += (Controller_P.TransferFcn2_A[0])*
      Controller_X.TransferFcn2_CSTATE[0]
      + (Controller_P.TransferFcn2_A[1])*Controller_X.TransferFcn2_CSTATE[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE[1]= Controller_X.TransferFcn2_CSTATE[0];
  }

  /* Derivatives for TransferFcn: '<S77>/Transfer Fcn1' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE[0] = Controller_U.pitch;
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE[0] += (Controller_P.TransferFcn1_A[0])*
      Controller_X.TransferFcn1_CSTATE[0]
      + (Controller_P.TransferFcn1_A[1])*Controller_X.TransferFcn1_CSTATE[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE[1]= Controller_X.TransferFcn1_CSTATE[0];
  }

  /* Derivatives for TransferFcn: '<S77>/Transfer Fcn' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE[0] = Controller_U.roll;
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE[0] += (Controller_P.TransferFcn_A[0])*
      Controller_X.TransferFcn_CSTATE[0]
      + (Controller_P.TransferFcn_A[1])*Controller_X.TransferFcn_CSTATE[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE[1]= Controller_X.TransferFcn_CSTATE[0];
  }

  /* Derivatives for Integrator: '<S104>/Integrator' */
  _rtXdot->Integrator_CSTATE_g[0] = Controller_B.Sum4[0];
  _rtXdot->Integrator_CSTATE_g[1] = Controller_B.Sum4[1];
  _rtXdot->Integrator_CSTATE_g[2] = Controller_B.Sum4[2];

  /* Derivatives for Integrator: '<S106>/Integrator' */
  _rtXdot->Integrator_CSTATE_f[0] = Controller_B.Sum_o[0];
  _rtXdot->Integrator_CSTATE_f[1] = Controller_B.Sum_o[1];
  _rtXdot->Integrator_CSTATE_f[2] = Controller_B.Sum_o[2];

  /* Derivatives for Integrator: '<S107>/Integrator2' */
  _rtXdot->Integrator2_CSTATE[0] = Controller_B.Gain2[0];
  _rtXdot->Integrator2_CSTATE[1] = Controller_B.Gain2[1];
  _rtXdot->Integrator2_CSTATE[2] = Controller_B.Gain2[2];
  for (i = 0; i < 6; i++) {
    /* Derivatives for Integrator: '<S16>/Integrator2' */
    _rtXdot->Integrator2_CSTATE_f[i] = Controller_B.xm_dot[i];

    /* Derivatives for Integrator: '<S16>/Integrator6' */
    _rtXdot->Integrator6_CSTATE[i] = Controller_B.Fm_dot[i];
  }

  /* Derivatives for TransferFcn: '<S22>/Transfer Fcn' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE_e = Controller_B.Row1;
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE_e += (Controller_P.TransferFcn_A_p)*
      Controller_X.TransferFcn_CSTATE_e;
  }

  /* Derivatives for TransferFcn: '<S22>/Transfer Fcn1' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE_d = Controller_B.Row2;
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE_d += (Controller_P.TransferFcn1_A_e)*
      Controller_X.TransferFcn1_CSTATE_d;
  }

  /* Derivatives for TransferFcn: '<S22>/Transfer Fcn2' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE_b = Controller_B.Row3;
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE_b += (Controller_P.TransferFcn2_A_p)*
      Controller_X.TransferFcn2_CSTATE_b;
  }

  for (i = 0; i < 18; i++) {
    /* Derivatives for Integrator: '<S16>/Integrator10' */
    _rtXdot->Integrator10_CSTATE[i] = Controller_B.theta_hat_dot[i];

    /* Derivatives for Integrator: '<S16>/Integrator3' */
    _rtXdot->Integrator3_CSTATE[i] = Controller_B.theta_ves_hat_dot[i];
  }

  /* Derivatives for Integrator: '<S16>/Integrator1' */
  for (i = 0; i < 9; i++) {
    _rtXdot->Integrator1_CSTATE_m[i] = Controller_B.omega0_dot[i];
  }

  /* End of Derivatives for Integrator: '<S16>/Integrator1' */

  /* Derivatives for Integrator: '<S15>/Integrator' */
  _rtXdot->Integrator_CSTATE_p[0] =
    Controller_B.TmpSignalConversionAtProduct1In[0];
  _rtXdot->Integrator_CSTATE_p[1] =
    Controller_B.TmpSignalConversionAtProduct1In[1];
  _rtXdot->Integrator_CSTATE_p[2] =
    Controller_B.TmpSignalConversionAtProduct1In[2];

  /* Derivatives for Integrator: '<S33>/Integrator1' */
  _rtXdot->Integrator1_CSTATE_f = Controller_B.Integrator_n;

  /* Derivatives for Integrator: '<S33>/Integrator' */
  _rtXdot->Integrator_CSTATE_c = Controller_B.Gain1;

  /* Derivatives for Integrator: '<S3>/Integrator' */
  _rtXdot->Integrator_CSTATE_j = Controller_B.Product;

  /* Derivatives for Integrator: '<S84>/Integrator1' */
  _rtXdot->Integrator1_CSTATE_k[0] = Controller_B.Sum2_h[0];
  _rtXdot->Integrator1_CSTATE_k[1] = Controller_B.Sum2_h[1];
  _rtXdot->Integrator1_CSTATE_k[2] = Controller_B.Sum2_h[2];

  /* Derivatives for Integrator: '<S84>/Integrator' */
  _rtXdot->Integrator_CSTATE_px[0] = Controller_B.M_j[0];
  _rtXdot->Integrator_CSTATE_px[1] = Controller_B.M_j[1];
  _rtXdot->Integrator_CSTATE_px[2] = Controller_B.M_j[2];

  /* Derivatives for Integrator: '<S119>/Integrator2' */
  _rtXdot->Integrator2_CSTATE_i[0] = Controller_B.Sum1[0];
  _rtXdot->Integrator2_CSTATE_i[1] = Controller_B.Sum1[1];
  _rtXdot->Integrator2_CSTATE_i[2] = Controller_B.Sum1[2];

  /* Derivatives for Integrator: '<S93>/Integrator1' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->Integrator1_CSTATE_g = Controller_B.Sum2[0];
  }

  /* Derivatives for Integrator: '<S93>/Integrator2' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->Integrator2_CSTATE_n = Controller_B.Sum2[1];
  }

  /* Derivatives for Integrator: '<S93>/Integrator3' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->Integrator3_CSTATE_m = Controller_B.Sum2[2];
  }

  /* Derivatives for Integrator: '<S92>/Integrator' */
  _rtXdot->Integrator_CSTATE_d[0] = Controller_B.M[0];
  _rtXdot->Integrator_CSTATE_d[1] = Controller_B.M[1];
  _rtXdot->Integrator_CSTATE_d[2] = Controller_B.M[2];

  /* Derivatives for Integrator: '<S91>/Integrator2' */
  _rtXdot->Integrator2_CSTATE_n4[0] = Controller_B.Sum_k[0];
  _rtXdot->Integrator2_CSTATE_n4[1] = Controller_B.Sum_k[1];
  _rtXdot->Integrator2_CSTATE_n4[2] = Controller_B.Sum_k[2];

  /* Derivatives for Integrator: '<S16>/Integrator11' */
  _rtXdot->Integrator11_CSTATE[0] = Controller_B.m_s_dot_l[0];
  _rtXdot->Integrator11_CSTATE[1] = Controller_B.m_s_dot_l[1];
  _rtXdot->Integrator11_CSTATE[2] = Controller_B.m_s_dot_l[2];

  /* Derivatives for Integrator: '<S16>/Integrator4' */
  for (i = 0; i < 30; i++) {
    _rtXdot->Integrator4_CSTATE[i] = Controller_B.phi_dot[i];
  }

  /* End of Derivatives for Integrator: '<S16>/Integrator4' */

  /* Derivatives for Integrator: '<S16>/Integrator5' */
  _rtXdot->Integrator5_CSTATE[0] = Controller_B.m_s_dot[0];
  _rtXdot->Integrator5_CSTATE[1] = Controller_B.m_s_dot[1];
  _rtXdot->Integrator5_CSTATE[2] = Controller_B.m_s_dot[2];

  /* Derivatives for Integrator: '<S16>/Integrator9' */
  for (i = 0; i < 18; i++) {
    _rtXdot->Integrator9_CSTATE[i] = Controller_B.phi_dot_e[i];
  }

  /* End of Derivatives for Integrator: '<S16>/Integrator9' */
  /* Derivatives for TransferFcn: '<S59>/Transfer Fcn' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE_en[0] = Controller_B.Sum_a[0];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE_en[0] += (Controller_P.TransferFcn_A_o[0])*
      Controller_X.TransferFcn_CSTATE_en[0]
      + (Controller_P.TransferFcn_A_o[1])*Controller_X.TransferFcn_CSTATE_en[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE_en[1]= Controller_X.TransferFcn_CSTATE_en[0];
  }

  /* Derivatives for TransferFcn: '<S59>/Transfer Fcn1' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE_m[0] = Controller_B.Sum_a[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE_m[0] += (Controller_P.TransferFcn1_A_g[0])*
      Controller_X.TransferFcn1_CSTATE_m[0]
      + (Controller_P.TransferFcn1_A_g[1])*Controller_X.TransferFcn1_CSTATE_m[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE_m[1]= Controller_X.TransferFcn1_CSTATE_m[0];
  }

  /* Derivatives for TransferFcn: '<S59>/Transfer Fcn2' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE_j[0] = Controller_B.Sum_a[2];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE_j[0] += (Controller_P.TransferFcn2_A_g[0])*
      Controller_X.TransferFcn2_CSTATE_j[0]
      + (Controller_P.TransferFcn2_A_g[1])*Controller_X.TransferFcn2_CSTATE_j[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE_j[1]= Controller_X.TransferFcn2_CSTATE_j[0];
  }

  /* Derivatives for TransferFcn: '<S64>/Transfer Fcn' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE_d[0] = Controller_B.Sum_f[0];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE_d[0] += (Controller_P.TransferFcn_A_j[0])*
      Controller_X.TransferFcn_CSTATE_d[0]
      + (Controller_P.TransferFcn_A_j[1])*Controller_X.TransferFcn_CSTATE_d[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE_d[1]= Controller_X.TransferFcn_CSTATE_d[0];
  }

  /* Derivatives for TransferFcn: '<S64>/Transfer Fcn1' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE_e[0] = Controller_B.Sum_f[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE_e[0] += (Controller_P.TransferFcn1_A_b[0])*
      Controller_X.TransferFcn1_CSTATE_e[0]
      + (Controller_P.TransferFcn1_A_b[1])*Controller_X.TransferFcn1_CSTATE_e[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE_e[1]= Controller_X.TransferFcn1_CSTATE_e[0];
  }

  /* Derivatives for TransferFcn: '<S64>/Transfer Fcn2' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE_c[0] = Controller_B.Sum_f[2];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE_c[0] += (Controller_P.TransferFcn2_A_f[0])*
      Controller_X.TransferFcn2_CSTATE_c[0]
      + (Controller_P.TransferFcn2_A_f[1])*Controller_X.TransferFcn2_CSTATE_c[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE_c[1]= Controller_X.TransferFcn2_CSTATE_c[0];
  }

  /* Derivatives for TransferFcn: '<S69>/Transfer Fcn' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE_o[0] = Controller_B.Sum_l[0];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE_o[0] += (Controller_P.TransferFcn_A_e[0])*
      Controller_X.TransferFcn_CSTATE_o[0]
      + (Controller_P.TransferFcn_A_e[1])*Controller_X.TransferFcn_CSTATE_o[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE_o[1]= Controller_X.TransferFcn_CSTATE_o[0];
  }

  /* Derivatives for TransferFcn: '<S69>/Transfer Fcn1' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE_g[0] = Controller_B.Sum_l[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE_g[0] += (Controller_P.TransferFcn1_A_f[0])*
      Controller_X.TransferFcn1_CSTATE_g[0]
      + (Controller_P.TransferFcn1_A_f[1])*Controller_X.TransferFcn1_CSTATE_g[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE_g[1]= Controller_X.TransferFcn1_CSTATE_g[0];
  }

  /* Derivatives for TransferFcn: '<S69>/Transfer Fcn2' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE_i[0] = Controller_B.Sum_l[2];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE_i[0] += (Controller_P.TransferFcn2_A_h[0])*
      Controller_X.TransferFcn2_CSTATE_i[0]
      + (Controller_P.TransferFcn2_A_h[1])*Controller_X.TransferFcn2_CSTATE_i[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE_i[1]= Controller_X.TransferFcn2_CSTATE_i[0];
  }

  /* Derivatives for TransferFcn: '<S74>/Transfer Fcn' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE_c[0] = Controller_B.Sum_aq[0];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE_c[0] += (Controller_P.TransferFcn_A_d[0])*
      Controller_X.TransferFcn_CSTATE_c[0]
      + (Controller_P.TransferFcn_A_d[1])*Controller_X.TransferFcn_CSTATE_c[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE_c[1]= Controller_X.TransferFcn_CSTATE_c[0];
  }

  /* Derivatives for TransferFcn: '<S74>/Transfer Fcn1' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE_l[0] = Controller_B.Sum_aq[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE_l[0] += (Controller_P.TransferFcn1_A_g2[0])*
      Controller_X.TransferFcn1_CSTATE_l[0]
      + (Controller_P.TransferFcn1_A_g2[1])*Controller_X.TransferFcn1_CSTATE_l[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE_l[1]= Controller_X.TransferFcn1_CSTATE_l[0];
  }

  /* Derivatives for TransferFcn: '<S74>/Transfer Fcn2' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE_h[0] = Controller_B.Sum_aq[2];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE_h[0] += (Controller_P.TransferFcn2_A_k[0])*
      Controller_X.TransferFcn2_CSTATE_h[0]
      + (Controller_P.TransferFcn2_A_k[1])*Controller_X.TransferFcn2_CSTATE_h[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE_h[1]= Controller_X.TransferFcn2_CSTATE_h[0];
  }

  /* Derivatives for TransferFcn: '<S76>/Transfer Fcn' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE_n[0] = Controller_B.Product2[0];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE_n[0] += (Controller_P.TransferFcn_A_p1[0])*
      Controller_X.TransferFcn_CSTATE_n[0]
      + (Controller_P.TransferFcn_A_p1[1])*Controller_X.TransferFcn_CSTATE_n[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn_CSTATE_n[1]= Controller_X.TransferFcn_CSTATE_n[0];
  }

  /* Derivatives for TransferFcn: '<S76>/Transfer Fcn1' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE_p[0] = Controller_B.Product2[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE_p[0] += (Controller_P.TransferFcn1_A_n[0])*
      Controller_X.TransferFcn1_CSTATE_p[0]
      + (Controller_P.TransferFcn1_A_n[1])*Controller_X.TransferFcn1_CSTATE_p[1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn1_CSTATE_p[1]= Controller_X.TransferFcn1_CSTATE_p[0];
  }

  /* Derivatives for TransferFcn: '<S76>/Transfer Fcn2' */
  {
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE_ck[0] = Controller_B.Product2[2];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE_ck[0] += (Controller_P.TransferFcn2_A_gl[0])*
      Controller_X.TransferFcn2_CSTATE_ck[0]
      + (Controller_P.TransferFcn2_A_gl[1])*Controller_X.TransferFcn2_CSTATE_ck
      [1];
    ((StateDerivatives_Controller *) Controller_M->ModelData.derivs)
      ->TransferFcn2_CSTATE_ck[1]= Controller_X.TransferFcn2_CSTATE_ck[0];
  }

  /* Derivatives for Integrator: '<S108>/Integrator' */
  _rtXdot->Integrator_CSTATE_l[0] = Controller_B.Gain_n[0];
  _rtXdot->Integrator_CSTATE_l[1] = Controller_B.Gain_n[1];
  _rtXdot->Integrator_CSTATE_l[2] = Controller_B.Gain_n[2];

  /* Derivatives for Integrator: '<S106>/Integrator1' */
  _rtXdot->Integrator1_CSTATE_b[0] = Controller_B.Sum2_g[0];
  _rtXdot->Integrator1_CSTATE_b[1] = Controller_B.Sum2_g[1];
  _rtXdot->Integrator1_CSTATE_b[2] = Controller_B.Sum2_g[2];

  /* Derivatives for Integrator: '<S106>/Integrator2' */
  _rtXdot->Integrator2_CSTATE_h[0] = Controller_B.error_w[0];
  _rtXdot->Integrator2_CSTATE_h[1] = Controller_B.error_w[1];
  _rtXdot->Integrator2_CSTATE_h[2] = Controller_B.error_w[2];
}

/* Model initialize function */
void Controller_initialize(void)
{
  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* initialize real-time model */
  (void) memset((void *)Controller_M, 0,
                sizeof(RT_MODEL_Controller));

  {
    /* Setup solver object */
    rtsiSetSimTimeStepPtr(&Controller_M->solverInfo,
                          &Controller_M->Timing.simTimeStep);
    rtsiSetTPtr(&Controller_M->solverInfo, &rtmGetTPtr(Controller_M));
    rtsiSetStepSizePtr(&Controller_M->solverInfo,
                       &Controller_M->Timing.stepSize0);
    rtsiSetdXPtr(&Controller_M->solverInfo, &Controller_M->ModelData.derivs);
    rtsiSetContStatesPtr(&Controller_M->solverInfo,
                         &Controller_M->ModelData.contStates);
    rtsiSetNumContStatesPtr(&Controller_M->solverInfo,
      &Controller_M->Sizes.numContStates);
    rtsiSetErrorStatusPtr(&Controller_M->solverInfo, (&rtmGetErrorStatus
      (Controller_M)));
    rtsiSetRTModelPtr(&Controller_M->solverInfo, Controller_M);
  }

  rtsiSetSimTimeStep(&Controller_M->solverInfo, MAJOR_TIME_STEP);
  Controller_M->ModelData.intgData.y = Controller_M->ModelData.odeY;
  Controller_M->ModelData.intgData.f[0] = Controller_M->ModelData.odeF[0];
  Controller_M->ModelData.intgData.f[1] = Controller_M->ModelData.odeF[1];
  Controller_M->ModelData.intgData.f[2] = Controller_M->ModelData.odeF[2];
  Controller_M->ModelData.intgData.f[3] = Controller_M->ModelData.odeF[3];
  Controller_M->ModelData.contStates = ((real_T *) &Controller_X);
  rtsiSetSolverData(&Controller_M->solverInfo, (void *)
                    &Controller_M->ModelData.intgData);
  rtsiSetSolverName(&Controller_M->solverInfo,"ode4");
  rtmSetTPtr(Controller_M, &Controller_M->Timing.tArray[0]);
  rtmSetTFinal(Controller_M, -1);
  Controller_M->Timing.stepSize0 = 0.01;
  rtmSetFirstInitCond(Controller_M, 1);

  /* Setup for data logging */
  {
    static RTWLogInfo rt_DataLoggingInfo;
    Controller_M->rtwLogInfo = &rt_DataLoggingInfo;
  }

  /* Setup for data logging */
  {
    rtliSetLogXSignalInfo(Controller_M->rtwLogInfo, (NULL));
    rtliSetLogXSignalPtrs(Controller_M->rtwLogInfo, (NULL));
    rtliSetLogT(Controller_M->rtwLogInfo, "tout");
    rtliSetLogX(Controller_M->rtwLogInfo, "");
    rtliSetLogXFinal(Controller_M->rtwLogInfo, "");
    rtliSetSigLog(Controller_M->rtwLogInfo, "");
    rtliSetLogVarNameModifier(Controller_M->rtwLogInfo, "rt_");
    rtliSetLogFormat(Controller_M->rtwLogInfo, 0);
    rtliSetLogMaxRows(Controller_M->rtwLogInfo, 1000);
    rtliSetLogDecimation(Controller_M->rtwLogInfo, 1);

    /*
     * Set pointers to the data and signal info for each output
     */
    {
      static void * rt_LoggedOutputSignalPtrs[] = {
        &Controller_Y.tau_X,
        &Controller_Y.tau_Y,
        &Controller_Y.tau_N,
        &Controller_Y.eta_err_N,
        &Controller_Y.eta_err_E,
        &Controller_Y.eta_err_psi,
        &Controller_Y.eta_e_N_AFF,
        &Controller_Y.eta_e_E_AFF,
        &Controller_Y.eta_e_psi_AFF,
        &Controller_Y.nu_e_u_AFF,
        &Controller_Y.nu_e_v_AFF,
        &Controller_Y.nu_e_r_AFF,
        &Controller_Y.d_e_x_AFF,
        &Controller_Y.d_e_y_AFF,
        &Controller_Y.d_e_psi_AFF,
        &Controller_Y.X_com,
        &Controller_Y.Y_com,
        &Controller_Y.N_com,
        &Controller_Y.nu_sim_u,
        &Controller_Y.nu_sim_v,
        &Controller_Y.nu_sim_r,
        &Controller_Y.eta_sim_N,
        &Controller_Y.eta_sim_E,
        &Controller_Y.eta_sim_psi,
        &Controller_Y.nu_d_sim_u,
        &Controller_Y.nu_d_sim_v,
        &Controller_Y.nu_d_sim_r,
        &Controller_Y.tau_Z,
        &Controller_Y.tau_K,
        &Controller_Y.tau_M,
        &Controller_Y.eta_e_N_NL,
        &Controller_Y.eta_e_E_NL,
        &Controller_Y.eta_e_psi_NL,
        &Controller_Y.nu_e_u_NL,
        &Controller_Y.nu_e_v_NL,
        &Controller_Y.nu_e_r_NL,
        &Controller_Y.d_e_x_NL,
        &Controller_Y.d_e_y_NL,
        &Controller_Y.d_e_psi_NL,
        &Controller_Y.eta_e_N_HB,
        &Controller_Y.eta_e_E_HB,
        &Controller_Y.eta_e_psi_HB,
        &Controller_Y.nu_e_u_HB,
        &Controller_Y.nu_e_v_HB,
        &Controller_Y.nu_e_r_HB,
        &Controller_Y.d_e_x_HB,
        &Controller_Y.d_e_y_HB,
        &Controller_Y.d_e_psi_HB,
        &Controller_Y.M_v_x,
        &Controller_Y.M_v_y,
        &Controller_Y.M_v_n,
        &Controller_Y.D_v_x,
        &Controller_Y.D_v_y,
        &Controller_Y.D_v_n,
        &Controller_Y.D_e_x,
        &Controller_Y.D_e_y,
        &Controller_Y.D_e_n,
        &Controller_Y.K_e_x,
        &Controller_Y.K_e_y,
        &Controller_Y.K_e_n,
        &Controller_Y.pref_x,
        &Controller_Y.pref_y,
        &Controller_Y.pref_n,
        &Controller_Y.fref_x,
        &Controller_Y.fref_y,
        &Controller_Y.fref_n,
        &Controller_Y.T_c_1x,
        &Controller_Y.T_c_2x,
        &Controller_Y.T_c_3x,
        &Controller_Y.C_c_0x,
        &Controller_Y.T_c_4y,
        &Controller_Y.T_c_5y,
        &Controller_Y.T_c_6y,
        &Controller_Y.C_c_1y,
        &Controller_Y.T_c_7n,
        &Controller_Y.T_c_8n,
        &Controller_Y.T_c_9n,
        &Controller_Y.C_c_2n
      };

      rtliSetLogYSignalPtrs(Controller_M->rtwLogInfo, ((LogSignalPtrsType)
        rt_LoggedOutputSignalPtrs));
    }

    {
      static int_T rt_LoggedOutputWidths[] = {
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1
      };

      static int_T rt_LoggedOutputNumDimensions[] = {
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2,
        2
      };

      static int_T rt_LoggedOutputDimensions[] = {
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1,
        1, 1,
        1, 1,
        1, 1,
        1, 1,
        1, 1,
        1, 1,
        1, 1,
        1, 1,
        1, 1,
        1, 1,
        1, 1,
        1, 1
      };

      static boolean_T rt_LoggedOutputIsVarDims[] = {
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
      };

      static void* rt_LoggedCurrentSignalDimensions[] = {
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL),
        (NULL), (NULL),
        (NULL), (NULL),
        (NULL), (NULL),
        (NULL), (NULL),
        (NULL), (NULL),
        (NULL), (NULL),
        (NULL), (NULL),
        (NULL), (NULL),
        (NULL), (NULL),
        (NULL), (NULL),
        (NULL), (NULL),
        (NULL), (NULL)
      };

      static int_T rt_LoggedCurrentSignalDimensionsSize[] = {
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4,
        4, 4,
        4, 4,
        4, 4,
        4, 4,
        4, 4,
        4, 4,
        4, 4,
        4, 4,
        4, 4,
        4, 4,
        4, 4,
        4, 4
      };

      static BuiltInDTypeId rt_LoggedOutputDataTypeIds[] = {
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE,
        SS_DOUBLE
      };

      static int_T rt_LoggedOutputComplexSignals[] = {
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
      };

      static const char_T *rt_LoggedOutputLabels[] = {
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "",
        "" };

      static const char_T *rt_LoggedOutputBlockNames[] = {
        "Controller/tau_X",
        "Controller/tau_Y",
        "Controller/tau_N",
        "Controller/eta_err_N",
        "Controller/eta_err_E",
        "Controller/eta_err_psi",
        "Controller/eta_e_N_AFF",
        "Controller/eta_e_E_AFF",
        "Controller/eta_e_psi_AFF",
        "Controller/nu_e_u_AFF",
        "Controller/nu_e_v_AFF",
        "Controller/nu_e_r_AFF",
        "Controller/d_e_x_AFF",
        "Controller/d_e_y_AFF",
        "Controller/d_e_psi_AFF",
        "Controller/X_com",
        "Controller/Y_com",
        "Controller/N_com",
        "Controller/nu_sim_u",
        "Controller/nu_sim_v",
        "Controller/nu_sim_r",
        "Controller/eta_sim_N",
        "Controller/eta_sim_E",
        "Controller/eta_sim_psi",
        "Controller/nu_d_sim_u",
        "Controller/nu_d_sim_v",
        "Controller/nu_d_sim_r",
        "Controller/tau_Z",
        "Controller/tau_K",
        "Controller/tau_M",
        "Controller/eta_e_N_NL",
        "Controller/eta_e_E_NL",
        "Controller/eta_e_psi_NL",
        "Controller/nu_e_u_NL",
        "Controller/nu_e_v_NL",
        "Controller/nu_e_r_NL",
        "Controller/d_e_x_NL",
        "Controller/d_e_y_NL",
        "Controller/d_e_psi_NL",
        "Controller/eta_e_N_HB",
        "Controller/eta_e_E_HB",
        "Controller/eta_e_psi_HB",
        "Controller/nu_e_u_HB",
        "Controller/nu_e_v_HB",
        "Controller/nu_e_r_HB",
        "Controller/d_e_x_HB",
        "Controller/d_e_y_HB",
        "Controller/d_e_psi_HB",
        "Controller/M_v_x",
        "Controller/M_v_y",
        "Controller/M_v_n",
        "Controller/D_v_x",
        "Controller/D_v_y",
        "Controller/D_v_n",
        "Controller/D_e_x",
        "Controller/D_e_y",
        "Controller/D_e_n",
        "Controller/K_e_x",
        "Controller/K_e_y",
        "Controller/K_e_n",
        "Controller/pref_x",
        "Controller/pref_y",
        "Controller/pref_n",
        "Controller/fref_x",
        "Controller/fref_y",
        "Controller/fref_n",
        "Controller/T_c_1x",
        "Controller/T_c_2x",
        "Controller/T_c_3x",
        "Controller/C_c_0x",
        "Controller/T_c_4y",
        "Controller/T_c_5y",
        "Controller/T_c_6y",
        "Controller/C_c_1y",
        "Controller/T_c_7n",
        "Controller/T_c_8n",
        "Controller/T_c_9n",
        "Controller/C_c_2n" };

      static RTWLogDataTypeConvert rt_RTWLogDataTypeConvert[] = {
        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 },

        { 0, SS_DOUBLE, SS_DOUBLE, 0, 0, 0, 1.0, 0, 0.0 }
      };

      static RTWLogSignalInfo rt_LoggedOutputSignalInfo[] = {
        {
          78,
          rt_LoggedOutputWidths,
          rt_LoggedOutputNumDimensions,
          rt_LoggedOutputDimensions,
          rt_LoggedOutputIsVarDims,
          rt_LoggedCurrentSignalDimensions,
          rt_LoggedCurrentSignalDimensionsSize,
          rt_LoggedOutputDataTypeIds,
          rt_LoggedOutputComplexSignals,
          (NULL),

          { rt_LoggedOutputLabels },
          (NULL),
          (NULL),
          (NULL),

          { rt_LoggedOutputBlockNames },

          { (NULL) },
          (NULL),
          rt_RTWLogDataTypeConvert
        }
      };

      rtliSetLogYSignalInfo(Controller_M->rtwLogInfo, rt_LoggedOutputSignalInfo);

      /* set currSigDims field */
      rt_LoggedCurrentSignalDimensions[0] = &rt_LoggedOutputWidths[0];
      rt_LoggedCurrentSignalDimensions[1] = &rt_LoggedOutputWidths[1];
      rt_LoggedCurrentSignalDimensions[2] = &rt_LoggedOutputWidths[2];
      rt_LoggedCurrentSignalDimensions[3] = &rt_LoggedOutputWidths[3];
      rt_LoggedCurrentSignalDimensions[4] = &rt_LoggedOutputWidths[4];
      rt_LoggedCurrentSignalDimensions[5] = &rt_LoggedOutputWidths[5];
      rt_LoggedCurrentSignalDimensions[6] = &rt_LoggedOutputWidths[6];
      rt_LoggedCurrentSignalDimensions[7] = &rt_LoggedOutputWidths[7];
      rt_LoggedCurrentSignalDimensions[8] = &rt_LoggedOutputWidths[8];
      rt_LoggedCurrentSignalDimensions[9] = &rt_LoggedOutputWidths[9];
      rt_LoggedCurrentSignalDimensions[10] = &rt_LoggedOutputWidths[10];
      rt_LoggedCurrentSignalDimensions[11] = &rt_LoggedOutputWidths[11];
      rt_LoggedCurrentSignalDimensions[12] = &rt_LoggedOutputWidths[12];
      rt_LoggedCurrentSignalDimensions[13] = &rt_LoggedOutputWidths[13];
      rt_LoggedCurrentSignalDimensions[14] = &rt_LoggedOutputWidths[14];
      rt_LoggedCurrentSignalDimensions[15] = &rt_LoggedOutputWidths[15];
      rt_LoggedCurrentSignalDimensions[16] = &rt_LoggedOutputWidths[16];
      rt_LoggedCurrentSignalDimensions[17] = &rt_LoggedOutputWidths[17];
      rt_LoggedCurrentSignalDimensions[18] = &rt_LoggedOutputWidths[18];
      rt_LoggedCurrentSignalDimensions[19] = &rt_LoggedOutputWidths[19];
      rt_LoggedCurrentSignalDimensions[20] = &rt_LoggedOutputWidths[20];
      rt_LoggedCurrentSignalDimensions[21] = &rt_LoggedOutputWidths[21];
      rt_LoggedCurrentSignalDimensions[22] = &rt_LoggedOutputWidths[22];
      rt_LoggedCurrentSignalDimensions[23] = &rt_LoggedOutputWidths[23];
      rt_LoggedCurrentSignalDimensions[24] = &rt_LoggedOutputWidths[24];
      rt_LoggedCurrentSignalDimensions[25] = &rt_LoggedOutputWidths[25];
      rt_LoggedCurrentSignalDimensions[26] = &rt_LoggedOutputWidths[26];
      rt_LoggedCurrentSignalDimensions[27] = &rt_LoggedOutputWidths[27];
      rt_LoggedCurrentSignalDimensions[28] = &rt_LoggedOutputWidths[28];
      rt_LoggedCurrentSignalDimensions[29] = &rt_LoggedOutputWidths[29];
      rt_LoggedCurrentSignalDimensions[30] = &rt_LoggedOutputWidths[30];
      rt_LoggedCurrentSignalDimensions[31] = &rt_LoggedOutputWidths[31];
      rt_LoggedCurrentSignalDimensions[32] = &rt_LoggedOutputWidths[32];
      rt_LoggedCurrentSignalDimensions[33] = &rt_LoggedOutputWidths[33];
      rt_LoggedCurrentSignalDimensions[34] = &rt_LoggedOutputWidths[34];
      rt_LoggedCurrentSignalDimensions[35] = &rt_LoggedOutputWidths[35];
      rt_LoggedCurrentSignalDimensions[36] = &rt_LoggedOutputWidths[36];
      rt_LoggedCurrentSignalDimensions[37] = &rt_LoggedOutputWidths[37];
      rt_LoggedCurrentSignalDimensions[38] = &rt_LoggedOutputWidths[38];
      rt_LoggedCurrentSignalDimensions[39] = &rt_LoggedOutputWidths[39];
      rt_LoggedCurrentSignalDimensions[40] = &rt_LoggedOutputWidths[40];
      rt_LoggedCurrentSignalDimensions[41] = &rt_LoggedOutputWidths[41];
      rt_LoggedCurrentSignalDimensions[42] = &rt_LoggedOutputWidths[42];
      rt_LoggedCurrentSignalDimensions[43] = &rt_LoggedOutputWidths[43];
      rt_LoggedCurrentSignalDimensions[44] = &rt_LoggedOutputWidths[44];
      rt_LoggedCurrentSignalDimensions[45] = &rt_LoggedOutputWidths[45];
      rt_LoggedCurrentSignalDimensions[46] = &rt_LoggedOutputWidths[46];
      rt_LoggedCurrentSignalDimensions[47] = &rt_LoggedOutputWidths[47];
      rt_LoggedCurrentSignalDimensions[48] = &rt_LoggedOutputWidths[48];
      rt_LoggedCurrentSignalDimensions[49] = &rt_LoggedOutputWidths[49];
      rt_LoggedCurrentSignalDimensions[50] = &rt_LoggedOutputWidths[50];
      rt_LoggedCurrentSignalDimensions[51] = &rt_LoggedOutputWidths[51];
      rt_LoggedCurrentSignalDimensions[52] = &rt_LoggedOutputWidths[52];
      rt_LoggedCurrentSignalDimensions[53] = &rt_LoggedOutputWidths[53];
      rt_LoggedCurrentSignalDimensions[54] = &rt_LoggedOutputWidths[54];
      rt_LoggedCurrentSignalDimensions[55] = &rt_LoggedOutputWidths[55];
      rt_LoggedCurrentSignalDimensions[56] = &rt_LoggedOutputWidths[56];
      rt_LoggedCurrentSignalDimensions[57] = &rt_LoggedOutputWidths[57];
      rt_LoggedCurrentSignalDimensions[58] = &rt_LoggedOutputWidths[58];
      rt_LoggedCurrentSignalDimensions[59] = &rt_LoggedOutputWidths[59];
      rt_LoggedCurrentSignalDimensions[60] = &rt_LoggedOutputWidths[60];
      rt_LoggedCurrentSignalDimensions[61] = &rt_LoggedOutputWidths[61];
      rt_LoggedCurrentSignalDimensions[62] = &rt_LoggedOutputWidths[62];
      rt_LoggedCurrentSignalDimensions[63] = &rt_LoggedOutputWidths[63];
      rt_LoggedCurrentSignalDimensions[64] = &rt_LoggedOutputWidths[64];
      rt_LoggedCurrentSignalDimensions[65] = &rt_LoggedOutputWidths[65];
      rt_LoggedCurrentSignalDimensions[66] = &rt_LoggedOutputWidths[66];
      rt_LoggedCurrentSignalDimensions[67] = &rt_LoggedOutputWidths[66];
      rt_LoggedCurrentSignalDimensions[68] = &rt_LoggedOutputWidths[67];
      rt_LoggedCurrentSignalDimensions[69] = &rt_LoggedOutputWidths[67];
      rt_LoggedCurrentSignalDimensions[70] = &rt_LoggedOutputWidths[68];
      rt_LoggedCurrentSignalDimensions[71] = &rt_LoggedOutputWidths[68];
      rt_LoggedCurrentSignalDimensions[72] = &rt_LoggedOutputWidths[69];
      rt_LoggedCurrentSignalDimensions[73] = &rt_LoggedOutputWidths[69];
      rt_LoggedCurrentSignalDimensions[74] = &rt_LoggedOutputWidths[70];
      rt_LoggedCurrentSignalDimensions[75] = &rt_LoggedOutputWidths[70];
      rt_LoggedCurrentSignalDimensions[76] = &rt_LoggedOutputWidths[71];
      rt_LoggedCurrentSignalDimensions[77] = &rt_LoggedOutputWidths[71];
      rt_LoggedCurrentSignalDimensions[78] = &rt_LoggedOutputWidths[72];
      rt_LoggedCurrentSignalDimensions[79] = &rt_LoggedOutputWidths[72];
      rt_LoggedCurrentSignalDimensions[80] = &rt_LoggedOutputWidths[73];
      rt_LoggedCurrentSignalDimensions[81] = &rt_LoggedOutputWidths[73];
      rt_LoggedCurrentSignalDimensions[82] = &rt_LoggedOutputWidths[74];
      rt_LoggedCurrentSignalDimensions[83] = &rt_LoggedOutputWidths[74];
      rt_LoggedCurrentSignalDimensions[84] = &rt_LoggedOutputWidths[75];
      rt_LoggedCurrentSignalDimensions[85] = &rt_LoggedOutputWidths[75];
      rt_LoggedCurrentSignalDimensions[86] = &rt_LoggedOutputWidths[76];
      rt_LoggedCurrentSignalDimensions[87] = &rt_LoggedOutputWidths[76];
      rt_LoggedCurrentSignalDimensions[88] = &rt_LoggedOutputWidths[77];
      rt_LoggedCurrentSignalDimensions[89] = &rt_LoggedOutputWidths[77];
    }

    rtliSetLogY(Controller_M->rtwLogInfo, "yout");
  }

  /* block I/O */
  (void) memset(((void *) &Controller_B), 0,
                sizeof(BlockIO_Controller));

  /* states (continuous) */
  {
    (void) memset((void *)&Controller_X, 0,
                  sizeof(ContinuousStates_Controller));
  }

  /* states (dwork) */
  (void) memset((void *)&Controller_DWork, 0,
                sizeof(D_Work_Controller));

  /* external inputs */
  (void) memset((void *)&Controller_U, 0,
                sizeof(ExternalInputs_Controller));

  /* external outputs */
  (void) memset((void *)&Controller_Y, 0,
                sizeof(ExternalOutputs_Controller));

  /* Matfile logging */
  rt_StartDataLoggingWithStartTime(Controller_M->rtwLogInfo, 0.0, rtmGetTFinal
    (Controller_M), Controller_M->Timing.stepSize0, (&rtmGetErrorStatus
    (Controller_M)));

  {
    uint32_T tseed;
    int32_T r;
    int32_T t;
    real_T tmp;

    /* Start for TransportDelay: '<S93>/Transport Delay' */
    {
      real_T *pBuffer = &Controller_DWork.TransportDelay_RWORK.TUbufferArea[0];

      {
        int_T i1;
        int_T *iw_Tail = &Controller_DWork.TransportDelay_IWORK.Tail[0];
        int_T *iw_Head = &Controller_DWork.TransportDelay_IWORK.Head[0];
        int_T *iw_Last = &Controller_DWork.TransportDelay_IWORK.Last[0];
        int_T *iw_CircularBufSize =
          &Controller_DWork.TransportDelay_IWORK.CircularBufSize[0];
        void **pw_TUbufferPtrs =
          &Controller_DWork.TransportDelay_PWORK.TUbufferPtrs[0];
        for (i1=0; i1 < 3; i1++) {
          iw_Tail[i1] = 0;
          iw_Head[i1] = 0;
          iw_Last[i1] = 0;
          iw_CircularBufSize[i1] = 1024;
          pBuffer[0] = Controller_P.TransportDelay_InitOutput;
          pBuffer[1024] = Controller_M->Timing.t[0];
          pw_TUbufferPtrs[i1] = (void *) &pBuffer[0];
          pw_TUbufferPtrs[i1+3] = (void *) &pBuffer[1024];
          pBuffer += 2048;
        }
      }
    }

    /* Start for RandomNumber: '<S58>/White Noise' */
    tmp = floor(Controller_P.WhiteNoise_Seed);
    if (rtIsNaN(tmp) || rtIsInf(tmp)) {
      tmp = 0.0;
    } else {
      tmp = fmod(tmp, 4.294967296E+9);
    }

    tseed = tmp < 0.0 ? (uint32_T)-(int32_T)(uint32_T)-tmp : (uint32_T)tmp;
    r = (int32_T)(tseed >> 16U);
    t = (int32_T)(tseed & 32768U);
    tseed = ((((tseed - ((uint32_T)r << 16U)) + (uint32_T)t) << 16U) + (uint32_T)
             t) + (uint32_T)r;
    if (tseed < 1U) {
      tseed = 1144108930U;
    } else {
      if (tseed > 2147483646U) {
        tseed = 2147483646U;
      }
    }

    Controller_DWork.RandSeed = tseed;
    Controller_DWork.NextOutput = rt_nrand_Upu32_Yd_f_pw_snf
      (&Controller_DWork.RandSeed) * Controller_P.WhiteNoise_StdDev +
      Controller_P.WhiteNoise_Mean;

    /* End of Start for RandomNumber: '<S58>/White Noise' */

    /* Start for RandomNumber: '<S63>/White Noise' */
    tmp = floor(Controller_P.WhiteNoise_Seed_n);
    if (rtIsNaN(tmp) || rtIsInf(tmp)) {
      tmp = 0.0;
    } else {
      tmp = fmod(tmp, 4.294967296E+9);
    }

    tseed = tmp < 0.0 ? (uint32_T)-(int32_T)(uint32_T)-tmp : (uint32_T)tmp;
    r = (int32_T)(tseed >> 16U);
    t = (int32_T)(tseed & 32768U);
    tseed = ((((tseed - ((uint32_T)r << 16U)) + (uint32_T)t) << 16U) + (uint32_T)
             t) + (uint32_T)r;
    if (tseed < 1U) {
      tseed = 1144108930U;
    } else {
      if (tseed > 2147483646U) {
        tseed = 2147483646U;
      }
    }

    Controller_DWork.RandSeed_f = tseed;
    Controller_DWork.NextOutput_k = rt_nrand_Upu32_Yd_f_pw_snf
      (&Controller_DWork.RandSeed_f) * Controller_P.WhiteNoise_StdDev_b +
      Controller_P.WhiteNoise_Mean_f;

    /* End of Start for RandomNumber: '<S63>/White Noise' */

    /* Start for RandomNumber: '<S68>/White Noise' */
    tmp = floor(Controller_P.WhiteNoise_Seed_k);
    if (rtIsNaN(tmp) || rtIsInf(tmp)) {
      tmp = 0.0;
    } else {
      tmp = fmod(tmp, 4.294967296E+9);
    }

    tseed = tmp < 0.0 ? (uint32_T)-(int32_T)(uint32_T)-tmp : (uint32_T)tmp;
    r = (int32_T)(tseed >> 16U);
    t = (int32_T)(tseed & 32768U);
    tseed = ((((tseed - ((uint32_T)r << 16U)) + (uint32_T)t) << 16U) + (uint32_T)
             t) + (uint32_T)r;
    if (tseed < 1U) {
      tseed = 1144108930U;
    } else {
      if (tseed > 2147483646U) {
        tseed = 2147483646U;
      }
    }

    Controller_DWork.RandSeed_p = tseed;
    Controller_DWork.NextOutput_f = rt_nrand_Upu32_Yd_f_pw_snf
      (&Controller_DWork.RandSeed_p) * Controller_P.WhiteNoise_StdDev_h +
      Controller_P.WhiteNoise_Mean_g;

    /* End of Start for RandomNumber: '<S68>/White Noise' */

    /* Start for RandomNumber: '<S73>/White Noise' */
    tmp = floor(Controller_P.WhiteNoise_Seed_no);
    if (rtIsNaN(tmp) || rtIsInf(tmp)) {
      tmp = 0.0;
    } else {
      tmp = fmod(tmp, 4.294967296E+9);
    }

    tseed = tmp < 0.0 ? (uint32_T)-(int32_T)(uint32_T)-tmp : (uint32_T)tmp;
    r = (int32_T)(tseed >> 16U);
    t = (int32_T)(tseed & 32768U);
    tseed = ((((tseed - ((uint32_T)r << 16U)) + (uint32_T)t) << 16U) + (uint32_T)
             t) + (uint32_T)r;
    if (tseed < 1U) {
      tseed = 1144108930U;
    } else {
      if (tseed > 2147483646U) {
        tseed = 2147483646U;
      }
    }

    Controller_DWork.RandSeed_a = tseed;
    Controller_DWork.NextOutput_c = rt_nrand_Upu32_Yd_f_pw_snf
      (&Controller_DWork.RandSeed_a) * Controller_P.WhiteNoise_StdDev_d +
      Controller_P.WhiteNoise_Mean_j;

    /* End of Start for RandomNumber: '<S73>/White Noise' */

    /* Start for RandomNumber: '<S75>/White Noise' */
    tmp = floor(Controller_P.WhiteNoise_Seed_kt[0]);
    if (rtIsNaN(tmp) || rtIsInf(tmp)) {
      tmp = 0.0;
    } else {
      tmp = fmod(tmp, 4.294967296E+9);
    }

    tseed = tmp < 0.0 ? (uint32_T)-(int32_T)(uint32_T)-tmp : (uint32_T)tmp;
    r = (int32_T)(tseed >> 16U);
    t = (int32_T)(tseed & 32768U);
    tseed = ((((tseed - ((uint32_T)r << 16U)) + (uint32_T)t) << 16U) + (uint32_T)
             t) + (uint32_T)r;
    if (tseed < 1U) {
      tseed = 1144108930U;
    } else {
      if (tseed > 2147483646U) {
        tseed = 2147483646U;
      }
    }

    Controller_DWork.RandSeed_fl[0] = tseed;
    Controller_DWork.NextOutput_m[0] = rt_nrand_Upu32_Yd_f_pw_snf
      (&Controller_DWork.RandSeed_fl[0]) * Controller_P.WhiteNoise_StdDev_j +
      Controller_P.WhiteNoise_Mean_p;
    tmp = floor(Controller_P.WhiteNoise_Seed_kt[1]);
    if (rtIsNaN(tmp) || rtIsInf(tmp)) {
      tmp = 0.0;
    } else {
      tmp = fmod(tmp, 4.294967296E+9);
    }

    tseed = tmp < 0.0 ? (uint32_T)-(int32_T)(uint32_T)-tmp : (uint32_T)tmp;
    r = (int32_T)(tseed >> 16U);
    t = (int32_T)(tseed & 32768U);
    tseed = ((((tseed - ((uint32_T)r << 16U)) + (uint32_T)t) << 16U) + (uint32_T)
             t) + (uint32_T)r;
    if (tseed < 1U) {
      tseed = 1144108930U;
    } else {
      if (tseed > 2147483646U) {
        tseed = 2147483646U;
      }
    }

    Controller_DWork.RandSeed_fl[1] = tseed;
    Controller_DWork.NextOutput_m[1] = rt_nrand_Upu32_Yd_f_pw_snf
      (&Controller_DWork.RandSeed_fl[1]) * Controller_P.WhiteNoise_StdDev_j +
      Controller_P.WhiteNoise_Mean_p;
    tmp = floor(Controller_P.WhiteNoise_Seed_kt[2]);
    if (rtIsNaN(tmp) || rtIsInf(tmp)) {
      tmp = 0.0;
    } else {
      tmp = fmod(tmp, 4.294967296E+9);
    }

    tseed = tmp < 0.0 ? (uint32_T)-(int32_T)(uint32_T)-tmp : (uint32_T)tmp;
    r = (int32_T)(tseed >> 16U);
    t = (int32_T)(tseed & 32768U);
    tseed = ((((tseed - ((uint32_T)r << 16U)) + (uint32_T)t) << 16U) + (uint32_T)
             t) + (uint32_T)r;
    if (tseed < 1U) {
      tseed = 1144108930U;
    } else {
      if (tseed > 2147483646U) {
        tseed = 2147483646U;
      }
    }

    Controller_DWork.RandSeed_fl[2] = tseed;
    Controller_DWork.NextOutput_m[2] = rt_nrand_Upu32_Yd_f_pw_snf
      (&Controller_DWork.RandSeed_fl[2]) * Controller_P.WhiteNoise_StdDev_j +
      Controller_P.WhiteNoise_Mean_p;

    /* End of Start for RandomNumber: '<S75>/White Noise' */
  }

  Controller_PrevZCSigState.Integrator1_Reset_ZCE = UNINITIALIZED_ZCSIG;
  Controller_PrevZCSigState.Integrator2_Reset_ZCE = UNINITIALIZED_ZCSIG;
  Controller_PrevZCSigState.Integrator3_Reset_ZCE = UNINITIALIZED_ZCSIG;

  {
    int32_T i;

    /* InitializeConditions for Integrator: '<S14>/Integrator' */
    Controller_X.Integrator_CSTATE[0] = Controller_P.Integrator_IC;
    Controller_X.Integrator_CSTATE[1] = Controller_P.Integrator_IC;
    Controller_X.Integrator_CSTATE[2] = Controller_P.Integrator_IC;

    /* InitializeConditions for Integrator: '<S104>/Integrator1' */
    Controller_X.Integrator1_CSTATE[0] = Controller_P.Integrator1_IC[0];
    Controller_X.Integrator1_CSTATE[1] = Controller_P.Integrator1_IC[1];
    Controller_X.Integrator1_CSTATE[2] = Controller_P.Integrator1_IC[2];

    /* InitializeConditions for TransferFcn: '<S77>/Transfer Fcn2' */
    Controller_X.TransferFcn2_CSTATE[0] = 0.0;
    Controller_X.TransferFcn2_CSTATE[1] = 0.0;

    /* InitializeConditions for TransferFcn: '<S77>/Transfer Fcn1' */
    Controller_X.TransferFcn1_CSTATE[0] = 0.0;
    Controller_X.TransferFcn1_CSTATE[1] = 0.0;

    /* InitializeConditions for TransferFcn: '<S77>/Transfer Fcn' */
    Controller_X.TransferFcn_CSTATE[0] = 0.0;
    Controller_X.TransferFcn_CSTATE[1] = 0.0;

    /* InitializeConditions for Integrator: '<S104>/Integrator' */
    Controller_X.Integrator_CSTATE_g[0] = Controller_P.Integrator_IC_i[0];
    Controller_X.Integrator_CSTATE_g[1] = Controller_P.Integrator_IC_i[1];
    Controller_X.Integrator_CSTATE_g[2] = Controller_P.Integrator_IC_i[2];

    /* InitializeConditions for Integrator: '<S106>/Integrator' */
    Controller_X.Integrator_CSTATE_f[0] = Controller_P.Integrator_IC_p;
    Controller_X.Integrator_CSTATE_f[1] = Controller_P.Integrator_IC_p;
    Controller_X.Integrator_CSTATE_f[2] = Controller_P.Integrator_IC_p;

    /* InitializeConditions for Integrator: '<S107>/Integrator2' */
    Controller_X.Integrator2_CSTATE[0] = Controller_P.Integrator2_IC[0];
    Controller_X.Integrator2_CSTATE[1] = Controller_P.Integrator2_IC[1];
    Controller_X.Integrator2_CSTATE[2] = Controller_P.Integrator2_IC[2];
    for (i = 0; i < 6; i++) {
      /* InitializeConditions for Integrator: '<S16>/Integrator2' */
      Controller_X.Integrator2_CSTATE_f[i] = Controller_P.Integrator2_IC_h[i];

      /* InitializeConditions for Integrator: '<S16>/Integrator6' */
      Controller_X.Integrator6_CSTATE[i] = Controller_P.Integrator6_IC[i];
    }

    /* InitializeConditions for TransferFcn: '<S22>/Transfer Fcn' */
    Controller_X.TransferFcn_CSTATE_e = 0.0;

    /* InitializeConditions for TransferFcn: '<S22>/Transfer Fcn1' */
    Controller_X.TransferFcn1_CSTATE_d = 0.0;

    /* InitializeConditions for TransferFcn: '<S22>/Transfer Fcn2' */
    Controller_X.TransferFcn2_CSTATE_b = 0.0;

    /* InitializeConditions for MATLAB Function: '<S16>/reference_model' */
    Controller_DWork.flag[0] = 0.0;
    Controller_DWork.flag[1] = 0.0;
    Controller_DWork.flag[2] = 0.0;
    for (i = 0; i < 18; i++) {
      /* InitializeConditions for Integrator: '<S16>/Integrator10' */
      Controller_X.Integrator10_CSTATE[i] = Controller_P.Integrator10_IC[i];

      /* InitializeConditions for Integrator: '<S16>/Integrator3' */
      Controller_X.Integrator3_CSTATE[i] = Controller_P.Integrator3_IC[i];
    }

    /* InitializeConditions for MATLAB Function: '<S16>/Control law parameter calculation' */
    Controller_DWork.Lambda_0[0] = 1.0;
    Controller_DWork.Lambda_0[1] = 1.0;
    Controller_DWork.Z_p_bar_hat[0] = 0.0;
    Controller_DWork.Z_p_bar_hat[1] = 0.0;
    Controller_DWork.Z_p_bar_hat[2] = 0.0;
    memset(&Controller_DWork.R_p_hat[0], 0, 9U * sizeof(real_T));
    for (i = 0; i < 6; i++) {
      Controller_DWork.Q[i] = 0.0;
    }

    /* End of InitializeConditions for MATLAB Function: '<S16>/Control law parameter calculation' */

    /* InitializeConditions for Integrator: '<S16>/Integrator1' */
    for (i = 0; i < 9; i++) {
      Controller_X.Integrator1_CSTATE_m[i] = Controller_P.Integrator1_IC_m[i];
    }

    /* End of InitializeConditions for Integrator: '<S16>/Integrator1' */

    /* InitializeConditions for Integrator: '<S15>/Integrator' */
    Controller_X.Integrator_CSTATE_p[0] = Controller_P.Integrator_IC_m;
    Controller_X.Integrator_CSTATE_p[1] = Controller_P.Integrator_IC_m;
    Controller_X.Integrator_CSTATE_p[2] = Controller_P.Integrator_IC_m;

    /* InitializeConditions for Integrator: '<S33>/Integrator1' */
    Controller_X.Integrator1_CSTATE_f = Controller_P.Integrator1_IC_f;

    /* InitializeConditions for Integrator: '<S33>/Integrator' */
    Controller_X.Integrator_CSTATE_c = Controller_P.Integrator_IC_p1;

    /* InitializeConditions for MATLAB Function: '<S14>/MATLAB Function' */
    Controller_MATLABFunction_Init();

    /* InitializeConditions for Integrator: '<S3>/Integrator' */
    Controller_X.Integrator_CSTATE_j = Controller_P.Integrator_IC_f;

    /* InitializeConditions for Integrator: '<S84>/Integrator1' */
    Controller_X.Integrator1_CSTATE_k[0] = Controller_P.Integrator1_IC_a;
    Controller_X.Integrator1_CSTATE_k[1] = Controller_P.Integrator1_IC_a;
    Controller_X.Integrator1_CSTATE_k[2] = Controller_P.Integrator1_IC_a;

    /* InitializeConditions for Integrator: '<S84>/Integrator' */
    Controller_X.Integrator_CSTATE_px[0] = Controller_P.Integrator_IC_in;
    Controller_X.Integrator_CSTATE_px[1] = Controller_P.Integrator_IC_in;
    Controller_X.Integrator_CSTATE_px[2] = Controller_P.Integrator_IC_in;

    /* InitializeConditions for Integrator: '<S119>/Integrator2' */
    Controller_X.Integrator2_CSTATE_i[0] = Controller_P.Integrator2_IC_a;
    Controller_X.Integrator2_CSTATE_i[1] = Controller_P.Integrator2_IC_a;
    Controller_X.Integrator2_CSTATE_i[2] = Controller_P.Integrator2_IC_a;

    /* InitializeConditions for Integrator: '<S93>/Integrator1' */
    if (rtmIsFirstInitCond(Controller_M)) {
      Controller_X.Integrator1_CSTATE_g = 0.0;
    }

    Controller_DWork.Integrator1_IWORK.IcNeedsLoading = 1;

    /* InitializeConditions for Integrator: '<S93>/Integrator2' */
    if (rtmIsFirstInitCond(Controller_M)) {
      Controller_X.Integrator2_CSTATE_n = 0.0;
    }

    Controller_DWork.Integrator2_IWORK.IcNeedsLoading = 1;

    /* InitializeConditions for Integrator: '<S93>/Integrator3' */
    if (rtmIsFirstInitCond(Controller_M)) {
      Controller_X.Integrator3_CSTATE_m = 0.0;
    }

    Controller_DWork.Integrator3_IWORK.IcNeedsLoading = 1;

    /* InitializeConditions for MATLAB Function: '<S82>/MATLAB Function' */
    Controller_DWork.time_reset_x_not_empty = FALSE;
    Controller_DWork.time_reset_y_not_empty = FALSE;
    Controller_DWork.time_reset_psi_not_empty = FALSE;

    /* InitializeConditions for MATLAB Function: '<S92>/MATLAB Function' */
    Controller_DWork.nu_x_not_empty = FALSE;
    Controller_DWork.nu_y_not_empty = FALSE;
    Controller_DWork.nu_psi_not_empty = FALSE;

    /* InitializeConditions for Integrator: '<S92>/Integrator' */
    Controller_X.Integrator_CSTATE_d[0] = Controller_P.Integrator_IC_e;
    Controller_X.Integrator_CSTATE_d[1] = Controller_P.Integrator_IC_e;
    Controller_X.Integrator_CSTATE_d[2] = Controller_P.Integrator_IC_e;

    /* InitializeConditions for MATLAB Function: '<S91>/MATLAB Function' */
    Controller_DWork.d_x_not_empty = FALSE;
    Controller_DWork.d_y_not_empty = FALSE;
    Controller_DWork.d_psi_not_empty = FALSE;

    /* InitializeConditions for Integrator: '<S91>/Integrator2' */
    Controller_X.Integrator2_CSTATE_n4[0] = Controller_P.Integrator2_IC_g;
    Controller_X.Integrator2_CSTATE_n4[1] = Controller_P.Integrator2_IC_g;
    Controller_X.Integrator2_CSTATE_n4[2] = Controller_P.Integrator2_IC_g;

    /* InitializeConditions for Integrator: '<S16>/Integrator11' */
    Controller_X.Integrator11_CSTATE[0] = Controller_P.Integrator11_IC[0];
    Controller_X.Integrator11_CSTATE[1] = Controller_P.Integrator11_IC[1];
    Controller_X.Integrator11_CSTATE[2] = Controller_P.Integrator11_IC[2];

    /* InitializeConditions for Integrator: '<S16>/Integrator4' */
    for (i = 0; i < 30; i++) {
      Controller_X.Integrator4_CSTATE[i] = Controller_P.Integrator4_IC[i];
    }

    /* End of InitializeConditions for Integrator: '<S16>/Integrator4' */

    /* InitializeConditions for Integrator: '<S16>/Integrator5' */
    Controller_X.Integrator5_CSTATE[0] = Controller_P.Integrator5_IC[0];
    Controller_X.Integrator5_CSTATE[1] = Controller_P.Integrator5_IC[1];
    Controller_X.Integrator5_CSTATE[2] = Controller_P.Integrator5_IC[2];

    /* InitializeConditions for Integrator: '<S16>/Integrator9' */
    for (i = 0; i < 18; i++) {
      Controller_X.Integrator9_CSTATE[i] = Controller_P.Integrator9_IC[i];
    }

    for (i = 0; i < 6; i++) {
      /* InitializeConditions for MATLAB Function: '<S16>/environment_estimation' */
      Controller_DWork.z1_dot[i] = 0.0;
      Controller_DWork.phi01_dot[i] = 0.0;
      Controller_DWork.phi02_dot[i] = 0.0;

      /* InitializeConditions for MATLAB Function: '<S16>/normalized _adaptive_law1' */
      Controller_DWork.dphi01[i] = 0.0;
      Controller_DWork.dphi02[i] = 0.0;
      Controller_DWork.dphi03[i] = 0.0;
      Controller_DWork.dphi04[i] = 0.0;
      Controller_DWork.dphi05[i] = 0.0;
    }

    /* End of InitializeConditions for Integrator: '<S16>/Integrator9' */

    /* InitializeConditions for MATLAB Function: '<S16>/normalized _adaptive_law1' */
    Controller_DWork.phi1[0] = 0.0;
    Controller_DWork.phi1[1] = 0.0;
    Controller_DWork.phi1[2] = 0.0;
    Controller_DWork.phi2[0] = 0.0;
    Controller_DWork.phi2[1] = 0.0;
    Controller_DWork.phi2[2] = 0.0;
    Controller_DWork.phi3[0] = 0.0;
    Controller_DWork.phi3[1] = 0.0;
    Controller_DWork.phi3[2] = 0.0;
    Controller_DWork.phi5[0] = 0.0;
    Controller_DWork.phi5[1] = 0.0;
    Controller_DWork.phi5[2] = 0.0;

    /* InitializeConditions for TransferFcn: '<S59>/Transfer Fcn' */
    Controller_X.TransferFcn_CSTATE_en[0] = 0.0;
    Controller_X.TransferFcn_CSTATE_en[1] = 0.0;

    /* InitializeConditions for TransferFcn: '<S59>/Transfer Fcn1' */
    Controller_X.TransferFcn1_CSTATE_m[0] = 0.0;
    Controller_X.TransferFcn1_CSTATE_m[1] = 0.0;

    /* InitializeConditions for TransferFcn: '<S59>/Transfer Fcn2' */
    Controller_X.TransferFcn2_CSTATE_j[0] = 0.0;
    Controller_X.TransferFcn2_CSTATE_j[1] = 0.0;

    /* InitializeConditions for TransferFcn: '<S64>/Transfer Fcn' */
    Controller_X.TransferFcn_CSTATE_d[0] = 0.0;
    Controller_X.TransferFcn_CSTATE_d[1] = 0.0;

    /* InitializeConditions for TransferFcn: '<S64>/Transfer Fcn1' */
    Controller_X.TransferFcn1_CSTATE_e[0] = 0.0;
    Controller_X.TransferFcn1_CSTATE_e[1] = 0.0;

    /* InitializeConditions for TransferFcn: '<S64>/Transfer Fcn2' */
    Controller_X.TransferFcn2_CSTATE_c[0] = 0.0;
    Controller_X.TransferFcn2_CSTATE_c[1] = 0.0;

    /* InitializeConditions for TransferFcn: '<S69>/Transfer Fcn' */
    Controller_X.TransferFcn_CSTATE_o[0] = 0.0;
    Controller_X.TransferFcn_CSTATE_o[1] = 0.0;

    /* InitializeConditions for TransferFcn: '<S69>/Transfer Fcn1' */
    Controller_X.TransferFcn1_CSTATE_g[0] = 0.0;
    Controller_X.TransferFcn1_CSTATE_g[1] = 0.0;

    /* InitializeConditions for TransferFcn: '<S69>/Transfer Fcn2' */
    Controller_X.TransferFcn2_CSTATE_i[0] = 0.0;
    Controller_X.TransferFcn2_CSTATE_i[1] = 0.0;

    /* InitializeConditions for TransferFcn: '<S74>/Transfer Fcn' */
    Controller_X.TransferFcn_CSTATE_c[0] = 0.0;
    Controller_X.TransferFcn_CSTATE_c[1] = 0.0;

    /* InitializeConditions for TransferFcn: '<S74>/Transfer Fcn1' */
    Controller_X.TransferFcn1_CSTATE_l[0] = 0.0;
    Controller_X.TransferFcn1_CSTATE_l[1] = 0.0;

    /* InitializeConditions for TransferFcn: '<S74>/Transfer Fcn2' */
    Controller_X.TransferFcn2_CSTATE_h[0] = 0.0;
    Controller_X.TransferFcn2_CSTATE_h[1] = 0.0;

    /* InitializeConditions for TransferFcn: '<S76>/Transfer Fcn' */
    Controller_X.TransferFcn_CSTATE_n[0] = 0.0;
    Controller_X.TransferFcn_CSTATE_n[1] = 0.0;

    /* InitializeConditions for TransferFcn: '<S76>/Transfer Fcn1' */
    Controller_X.TransferFcn1_CSTATE_p[0] = 0.0;
    Controller_X.TransferFcn1_CSTATE_p[1] = 0.0;

    /* InitializeConditions for TransferFcn: '<S76>/Transfer Fcn2' */
    Controller_X.TransferFcn2_CSTATE_ck[0] = 0.0;
    Controller_X.TransferFcn2_CSTATE_ck[1] = 0.0;

    /* InitializeConditions for Integrator: '<S108>/Integrator' */
    Controller_X.Integrator_CSTATE_l[0] = Controller_P.Integrator_IC_ik[0];
    Controller_X.Integrator_CSTATE_l[1] = Controller_P.Integrator_IC_ik[1];
    Controller_X.Integrator_CSTATE_l[2] = Controller_P.Integrator_IC_ik[2];

    /* InitializeConditions for Integrator: '<S106>/Integrator1' */
    Controller_X.Integrator1_CSTATE_b[0] = Controller_P.Integrator1_IC_c;
    Controller_X.Integrator1_CSTATE_b[1] = Controller_P.Integrator1_IC_c;
    Controller_X.Integrator1_CSTATE_b[2] = Controller_P.Integrator1_IC_c;

    /* InitializeConditions for Integrator: '<S106>/Integrator2' */
    Controller_X.Integrator2_CSTATE_h[0] = Controller_P.Integrator2_IC_hf;
    Controller_X.Integrator2_CSTATE_h[1] = Controller_P.Integrator2_IC_hf;
    Controller_X.Integrator2_CSTATE_h[2] = Controller_P.Integrator2_IC_hf;

    /* set "at time zero" to false */
    if (rtmIsFirstInitCond(Controller_M)) {
      rtmSetFirstInitCond(Controller_M, 0);
    }
  }
}

/* Model terminate function */
void Controller_terminate(void)
{
}
